# This file has been generated automatically
from numpy import sin,cos,sqrt
phi = [ \
	lambda th1,th2: 0.5, \
	lambda th1,th2: 0, \
	lambda th1,th2: (cos(th2)*sqrt(3))/2., \
	lambda th1,th2: ((-1 + 3*cos(th2)**2)*sqrt(5))/4., \
	lambda th1,th2: (cos(th1)*sqrt(3))/2., \
	lambda th1,th2: (3*sin(th1)*sin(th2))/4., \
	lambda th1,th2: (3*cos(th1)*cos(th2))/2., \
	lambda th1,th2: (3*sin(th1)*sin(2*th2)*sqrt(5))/8., \
	lambda th1,th2: (cos(th1)*(-1 + 3*cos(th2)**2)*sqrt(15))/4., \
	lambda th1,th2: ((-1 + 3*cos(th1)**2)*sqrt(5))/4., \
	lambda th1,th2: (3*sin(2*th1)*sin(th2)*sqrt(5))/8., \
	lambda th1,th2: ((-1 + 3*cos(th1)**2)*cos(th2)*sqrt(15))/4., \
	lambda th1,th2: (15*sin(th1)**2*sin(th2)**2)/16., \
	lambda th1,th2: (15*cos(th1)*cos(th2)*sin(th1)*sin(th2))/4., \
	lambda th1,th2: (5*(-1 + 3*cos(th1)**2)*(-1 + 3*cos(th2)**2))/8., \
]

angular_phi = {\
	(0,0,0,0) : phi[0],	\
	(0,0,1,0) : phi[2],	\
	(0,0,2,0) : phi[3],	\
	(1,0,0,0) : phi[4],	\
	(1,-1,1,-1) : phi[5],	\
	(1,0,1,0) : phi[6],	\
	(1,1,1,1) : phi[5],	\
	(1,-1,2,-1) : phi[7],	\
	(1,0,2,0) : phi[8],	\
	(1,1,2,1) : phi[7],	\
	(2,0,0,0) : phi[9],	\
	(2,-1,1,-1) : phi[10],	\
	(2,0,1,0) : phi[11],	\
	(2,1,1,1) : phi[10],	\
	(2,-2,2,-2) : phi[12],	\
	(2,-1,2,-1) : phi[13],	\
	(2,0,2,0) : phi[14],	\
	(2,1,2,1) : phi[13],	\
	(2,2,2,2) : phi[12],	\
}

tau2index = {\
	(0,0,0,0) : 0,\
	(0,0,1,0) : 2,\
	(0,0,2,0) : 3,\
	(1,0,0,0) : 4,\
	(1,-1,1,-1) : 5,\
	(1,0,1,0) : 6,\
	(1,1,1,1) : 5,\
	(1,-1,2,-1) : 7,\
	(1,0,2,0) : 8,\
	(1,1,2,1) : 7,\
	(2,0,0,0) : 9,\
	(2,-1,1,-1) : 10,\
	(2,0,1,0) : 11,\
	(2,1,1,1) : 10,\
	(2,-2,2,-2) : 12,\
	(2,-1,2,-1) : 13,\
	(2,0,2,0) : 14,\
	(2,1,2,1) : 13,\
	(2,2,2,2) : 12,\
}

# tau2index is not injective but we can compute S(i,r)
# by using any tau for which tau2index[tau] == i
index2tau = {\
	0 : (0,0,0,0),\
	2 : (0,0,1,0),\
	3 : (0,0,2,0),\
	4 : (1,0,0,0),\
	5 : (1,-1,1,-1),\
	6 : (1,0,1,0),\
	5 : (1,1,1,1),\
	7 : (1,-1,2,-1),\
	8 : (1,0,2,0),\
	7 : (1,1,2,1),\
	9 : (2,0,0,0),\
	10 : (2,-1,1,-1),\
	11 : (2,0,1,0),\
	10 : (2,1,1,1),\
	12 : (2,-2,2,-2),\
	13 : (2,-1,2,-1),\
	14 : (2,0,2,0),\
	13 : (2,1,2,1),\
	12 : (2,2,2,2),\
}

# added by hand
orbital_symbols = {(0,0): "s", \
                   (1,-1): "py", (1,0): "pz", (1,1): "px", \
                   (2,-2): "dxy", (2,-1): "dyz", (2,0): "dz2", (2,1): "dzx", (2,2): "dx2y2"}

# not needed so far, I added this so that in the future the option select_lm could use the symbol "px" instead of (1,1).
symbols2lm = {"s": (0,0), \
              "py": (1,-1), "pz": (1,0), "px": (1,1), \
              "dxy": (2,-2), "dyz": (2,-1), "dz2": (2,0), "dzx": (2,1), "dx2y2": (2,2)}

tau2symbol = {\
    (0,0,0,0) : 'ss\sigma',
    (0,0,1,0) : 'sp\sigma', 
    (1,0,0,0) : 'ps\sigma', 
    (1,-1,1,-1):'pp\pi',
    (1,0,1,0) : 'pp\sigma',
    (1,1,1,1) : 'pp\pi',
    (2,0,0,0) : 'ds\sigma',
    (0,0,2,0) : 'sd\sigma',
    (2,-1,1,-1):'dp\pi',
    (1,-1,2,-1):'pd\pi',
    (2,0,1,0) : 'dp\sigma',
    (1,0,2,0) : 'pd\sigma',
    (2,1,1,1) : 'dp\pi',
    (1,1,2,1) : 'pd\pi',
    (2,-2,2,-2):'dd\delta',
    (2,-1,2,-1):'dd\pi',
    (2,0,2,0) : 'dd\sigma',
    (2,1,2,1) : 'dd\pi',
    (2,2,2,2) : 'dd\delta'
}

# order of Slater Koster integrals for atom pair AB
# e.g. 'pd\sigma' refers to the integral between the p orbital of the A atom
# and the d orbital of the B atom
tausymbols_AB = ['dd\sigma', 'dd\pi', 'dd\delta',   'pd\sigma', 'pd\pi', 'pp\sigma', 'pp\pi', 'sd\sigma', 'sp\sigma', 'ss\sigma']

# order of Slater Koster integrals for atom pair BA
# e.g. 'dp\sigma' refers to the integral between the d orbital of the A atom 
# and the p orbital of the B atom
tausymbols_BA = ['dd\sigma', 'dd\pi', 'dd\delta',   'dp\sigma', 'dp\pi', 'pp\sigma', 'pp\pi', 'ds\sigma', 'ps\sigma', 'ss\sigma']


symbol2tau = {\
    'ss\sigma' : (0,0,0,0), 
    'sp\sigma' : (0,0,1,0), 
    'ps\sigma' : (1,0,0,0), 
    'pp\pi'    : (1,-1,1,-1), 
    'pp\sigma' : (1,0,1,0), 
#    'pp\pi'    : (1,1,1,1), 
    'ds\sigma' : (2,0,0,0),
    'sd\sigma' : (0,0,2,0),
    'dp\pi'    : (2,-1,1,-1),
    'pd\pi'    : (1,-1,2,-1),
    'dp\sigma' : (2,0,1,0),
    'pd\sigma' : (1,0,2,0),
    'dd\delta' : (2,-2,2,-2),
    'dd\pi'    : (2,-1,2,-1),
    'dd\sigma' : (2,0,2,0)\
}
#

# transformation rules for matrix elements
# x,y,z are directional cosines, r is the distance between the two centers
slako_transformations = {\
	(0,0,0,0) : lambda r,x,y,z,SorH: SorH(0,r), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: y*SorH(2,r), \
	(0,0,1,0) : lambda r,x,y,z,SorH: z*SorH(2,r), \
	(0,0,1,1) : lambda r,x,y,z,SorH: x*SorH(2,r), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: x*y*SorH(3,r)*sqrt(3), \
	(0,0,2,-1) : lambda r,x,y,z,SorH: y*z*SorH(3,r)*sqrt(3), \
	(0,0,2,0) : lambda r,x,y,z,SorH: -((x**2 + y**2 - 2*z**2)*SorH(3,r))/2., \
	(0,0,2,1) : lambda r,x,y,z,SorH: x*z*SorH(3,r)*sqrt(3), \
	(0,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*SorH(3,r)*sqrt(3))/2., \
	(1,-1,0,0) : lambda r,x,y,z,SorH: y*SorH(4,r), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (x**2 + z**2)*SorH(5,r) + y**2*SorH(6,r), \
	(1,-1,1,0) : lambda r,x,y,z,SorH: y*z*(-SorH(5,r) + SorH(6,r)), \
	(1,-1,1,1) : lambda r,x,y,z,SorH: x*y*(-SorH(5,r) + SorH(6,r)), \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: x*((x**2 - y**2 + z**2)*SorH(7,r) + y**2*SorH(8,r)*sqrt(3)), \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: z*((x**2 - y**2 + z**2)*SorH(7,r) + y**2*SorH(8,r)*sqrt(3)), \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(y*((x**2 + y**2 - 2*z**2)*SorH(8,r) + 2*z**2*SorH(7,r)*sqrt(3)))/2., \
	(1,-1,2,1) : lambda r,x,y,z,SorH: x*y*z*(-2*SorH(7,r) + SorH(8,r)*sqrt(3)), \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(y*(2*(2*x**2 + z**2)*SorH(7,r) + (-x**2 + y**2)*SorH(8,r)*sqrt(3)))/2., \
	(1,0,0,0) : lambda r,x,y,z,SorH: z*SorH(4,r), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: y*z*(-SorH(5,r) + SorH(6,r)), \
	(1,0,1,0) : lambda r,x,y,z,SorH: (x**2 + y**2)*SorH(5,r) + z**2*SorH(6,r), \
	(1,0,1,1) : lambda r,x,y,z,SorH: x*z*(-SorH(5,r) + SorH(6,r)), \
	(1,0,2,-2) : lambda r,x,y,z,SorH: x*y*z*(-2*SorH(7,r) + SorH(8,r)*sqrt(3)), \
	(1,0,2,-1) : lambda r,x,y,z,SorH: y*((x**2 + y**2 - z**2)*SorH(7,r) + z**2*SorH(8,r)*sqrt(3)), \
	(1,0,2,0) : lambda r,x,y,z,SorH: z**3*SorH(8,r) - ((x**2 + y**2)*z*(SorH(8,r) - 2*SorH(7,r)*sqrt(3)))/2., \
	(1,0,2,1) : lambda r,x,y,z,SorH: x*((x**2 + y**2 - z**2)*SorH(7,r) + z**2*SorH(8,r)*sqrt(3)), \
	(1,0,2,2) : lambda r,x,y,z,SorH: -((x - y)*(x + y)*z*(2*SorH(7,r) - SorH(8,r)*sqrt(3)))/2., \
	(1,1,0,0) : lambda r,x,y,z,SorH: x*SorH(4,r), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: x*y*(-SorH(5,r) + SorH(6,r)), \
	(1,1,1,0) : lambda r,x,y,z,SorH: x*z*(-SorH(5,r) + SorH(6,r)), \
	(1,1,1,1) : lambda r,x,y,z,SorH: (y**2 + z**2)*SorH(5,r) + x**2*SorH(6,r), \
	(1,1,2,-2) : lambda r,x,y,z,SorH: y*((-x**2 + y**2 + z**2)*SorH(7,r) + x**2*SorH(8,r)*sqrt(3)), \
	(1,1,2,-1) : lambda r,x,y,z,SorH: x*y*z*(-2*SorH(7,r) + SorH(8,r)*sqrt(3)), \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(x*((x**2 + y**2 - 2*z**2)*SorH(8,r) + 2*z**2*SorH(7,r)*sqrt(3)))/2., \
	(1,1,2,1) : lambda r,x,y,z,SorH: z*((-x**2 + y**2 + z**2)*SorH(7,r) + x**2*SorH(8,r)*sqrt(3)), \
	(1,1,2,2) : lambda r,x,y,z,SorH: x*(2*y**2 + z**2)*SorH(7,r) + (x*(x - y)*(x + y)*SorH(8,r)*sqrt(3))/2., \
	(2,-2,0,0) : lambda r,x,y,z,SorH: x*y*SorH(9,r)*sqrt(3), \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: x*((x**2 - y**2 + z**2)*SorH(10,r) + y**2*SorH(11,r)*sqrt(3)), \
	(2,-2,1,0) : lambda r,x,y,z,SorH: x*y*z*(-2*SorH(10,r) + SorH(11,r)*sqrt(3)), \
	(2,-2,1,1) : lambda r,x,y,z,SorH: y*((-x**2 + y**2 + z**2)*SorH(10,r) + x**2*SorH(11,r)*sqrt(3)), \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (x**2 + z**2)*(y**2 + z**2)*SorH(12,r) + ((x**2 - y**2)**2 + (x**2 + y**2)*z**2)*SorH(13,r) + 3*x**2*y**2*SorH(14,r), \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: x*z*(-((x**2 + z**2)*SorH(12,r)) + (x**2 - 3*y**2 + z**2)*SorH(13,r) + 3*y**2*SorH(14,r)), \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*y*((x**2 + y**2 + 2*z**2)*SorH(12,r) - 4*z**2*SorH(13,r) - (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/2., \
	(2,-2,2,1) : lambda r,x,y,z,SorH: y*z*(-((y**2 + z**2)*(SorH(12,r) - SorH(13,r))) + 3*x**2*(-SorH(13,r) + SorH(14,r))), \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(SorH(12,r) - 4*SorH(13,r) + 3*SorH(14,r)))/2., \
	(2,-1,0,0) : lambda r,x,y,z,SorH: y*z*SorH(9,r)*sqrt(3), \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: z*((x**2 - y**2 + z**2)*SorH(10,r) + y**2*SorH(11,r)*sqrt(3)), \
	(2,-1,1,0) : lambda r,x,y,z,SorH: y*((x**2 + y**2 - z**2)*SorH(10,r) + z**2*SorH(11,r)*sqrt(3)), \
	(2,-1,1,1) : lambda r,x,y,z,SorH: x*y*z*(-2*SorH(10,r) + SorH(11,r)*sqrt(3)), \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: x*z*(-((x**2 + z**2)*SorH(12,r)) + (x**2 - 3*y**2 + z**2)*SorH(13,r) + 3*y**2*SorH(14,r)), \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (x**2 + y**2)*(x**2 + z**2)*SorH(12,r) + ((y**2 - z**2)**2 + x**2*(y**2 + z**2))*SorH(13,r) + 3*y**2*z**2*SorH(14,r), \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(y*z*((x**2 + y**2)*SorH(12,r) - 2*(x**2 + y**2 - z**2)*SorH(13,r) + (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/2., \
	(2,-1,2,1) : lambda r,x,y,z,SorH: x*y*(-((x**2 + y**2)*SorH(12,r)) + (x**2 + y**2 - 3*z**2)*SorH(13,r) + 3*z**2*SorH(14,r)), \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (y*z*((3*x**2 + y**2 + 2*z**2)*SorH(12,r) - 2*(3*x**2 - y**2 + z**2)*SorH(13,r) + 3*(x - y)*(x + y)*SorH(14,r)))/2., \
	(2,0,0,0) : lambda r,x,y,z,SorH: -((x**2 + y**2 - 2*z**2)*SorH(9,r))/2., \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(y*((x**2 + y**2 - 2*z**2)*SorH(11,r) + 2*z**2*SorH(10,r)*sqrt(3)))/2., \
	(2,0,1,0) : lambda r,x,y,z,SorH: z**3*SorH(11,r) - ((x**2 + y**2)*z*(SorH(11,r) - 2*SorH(10,r)*sqrt(3)))/2., \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(x*((x**2 + y**2 - 2*z**2)*SorH(11,r) + 2*z**2*SorH(10,r)*sqrt(3)))/2., \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*y*((x**2 + y**2 + 2*z**2)*SorH(12,r) - 4*z**2*SorH(13,r) - (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/2., \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(y*z*((x**2 + y**2)*SorH(12,r) - 2*(x**2 + y**2 - z**2)*SorH(13,r) + (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/2., \
	(2,0,2,0) : lambda r,x,y,z,SorH: (3*(x**2 + y**2)*((x**2 + y**2)*SorH(12,r) + 4*z**2*SorH(13,r)) + (x**2 + y**2 - 2*z**2)**2*SorH(14,r))/4., \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(x*z*((x**2 + y**2)*SorH(12,r) - 2*(x**2 + y**2 - z**2)*SorH(13,r) + (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/2., \
	(2,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((x**2 + y**2 + 2*z**2)*SorH(12,r) - 4*z**2*SorH(13,r) - (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/4., \
	(2,1,0,0) : lambda r,x,y,z,SorH: x*z*SorH(9,r)*sqrt(3), \
	(2,1,1,-1) : lambda r,x,y,z,SorH: x*y*z*(-2*SorH(10,r) + SorH(11,r)*sqrt(3)), \
	(2,1,1,0) : lambda r,x,y,z,SorH: x*((x**2 + y**2 - z**2)*SorH(10,r) + z**2*SorH(11,r)*sqrt(3)), \
	(2,1,1,1) : lambda r,x,y,z,SorH: z*((-x**2 + y**2 + z**2)*SorH(10,r) + x**2*SorH(11,r)*sqrt(3)), \
	(2,1,2,-2) : lambda r,x,y,z,SorH: y*z*(-((y**2 + z**2)*(SorH(12,r) - SorH(13,r))) + 3*x**2*(-SorH(13,r) + SorH(14,r))), \
	(2,1,2,-1) : lambda r,x,y,z,SorH: x*y*(-((x**2 + y**2)*SorH(12,r)) + (x**2 + y**2 - 3*z**2)*SorH(13,r) + 3*z**2*SorH(14,r)), \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(x*z*((x**2 + y**2)*SorH(12,r) - 2*(x**2 + y**2 - z**2)*SorH(13,r) + (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/2., \
	(2,1,2,1) : lambda r,x,y,z,SorH: (x**2 + y**2)*(y**2 + z**2)*SorH(12,r) + (x**4 + x**2*(y**2 - 2*z**2) + z**2*(y**2 + z**2))*SorH(13,r) + 3*x**2*z**2*SorH(14,r), \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*z*((x**2 + 3*y**2 + 2*z**2)*SorH(12,r) + 2*(x**2 - 3*y**2 - z**2)*SorH(13,r) + 3*(-x**2 + y**2)*SorH(14,r)))/2., \
	(2,2,0,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*SorH(9,r)*sqrt(3))/2., \
	(2,2,1,-1) : lambda r,x,y,z,SorH: -(y*(2*(2*x**2 + z**2)*SorH(10,r) + (-x**2 + y**2)*SorH(11,r)*sqrt(3)))/2., \
	(2,2,1,0) : lambda r,x,y,z,SorH: -((x - y)*(x + y)*z*(2*SorH(10,r) - SorH(11,r)*sqrt(3)))/2., \
	(2,2,1,1) : lambda r,x,y,z,SorH: x*(2*y**2 + z**2)*SorH(10,r) + (x*(x - y)*(x + y)*SorH(11,r)*sqrt(3))/2., \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(SorH(12,r) - 4*SorH(13,r) + 3*SorH(14,r)))/2., \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (y*z*((3*x**2 + y**2 + 2*z**2)*SorH(12,r) - 2*(3*x**2 - y**2 + z**2)*SorH(13,r) + 3*(x - y)*(x + y)*SorH(14,r)))/2., \
	(2,2,2,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((x**2 + y**2 + 2*z**2)*SorH(12,r) - 4*z**2*SorH(13,r) - (x**2 + y**2 - 2*z**2)*SorH(14,r))*sqrt(3))/4., \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*z*((x**2 + 3*y**2 + 2*z**2)*SorH(12,r) + 2*(x**2 - 3*y**2 - z**2)*SorH(13,r) + 3*(-x**2 + y**2)*SorH(14,r)))/2., \
	(2,2,2,2) : lambda r,x,y,z,SorH: (((x**2 - y**2)**2 + 4*(x**2 + y**2)*z**2 + 4*z**4)*SorH(12,r) + 4*(4*x**2*y**2 + (x**2 + y**2)*z**2)*SorH(13,r) + 3*(x**2 - y**2)**2*SorH(14,r))/4., \
}
# transformation rules for gradients of matrix elements
slako_transformations_gradient = [\
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: x*SorH(0,r,1), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: x*y*(-(SorH(2,r)/r) + SorH(2,r,1)), \
	(0,0,1,0) : lambda r,x,y,z,SorH: x*z*(-(SorH(2,r)/r) + SorH(2,r,1)), \
	(0,0,1,1) : lambda r,x,y,z,SorH: -(((-1 + x**2)*SorH(2,r))/r) + x**2*SorH(2,r,1), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (y*((1 - 2*x**2)*SorH(3,r) + r*x**2*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(-2*SorH(3,r) + r*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (x*(-1 + x**2 + y**2 - 2*z**2)*SorH(3,r))/r - (x*(x**2 + y**2 - 2*z**2)*SorH(3,r,1))/2., \
	(0,0,2,1) : lambda r,x,y,z,SorH: (z*((1 - 2*x**2)*SorH(3,r) + r*x**2*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (x*(2*(1 - x**2 + y**2)*SorH(3,r) + r*(x - y)*(x + y)*SorH(3,r,1))*sqrt(3))/(2.*r), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: x*y*(-(SorH(4,r)/r) + SorH(4,r,1)), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (x*(-2*(-1 + x**2 + z**2)*SorH(5,r) + r*(x**2 + z**2)*SorH(5,r,1) + y**2*(-2*SorH(6,r) + r*SorH(6,r,1))))/r, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (x*y*z*(2*SorH(5,r) - 2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1))))/r, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (y*((-1 + 2*x**2)*SorH(5,r) + SorH(6,r) + x**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: ((-y**2 + z**2 - 3*x**2*(-1 + x**2 - y**2 + z**2))*SorH(7,r) + r*x**2*(x**2 - y**2 + z**2)*SorH(7,r,1) + y**2*((1 - 3*x**2)*SorH(8,r) + r*x**2*SorH(8,r,1))*sqrt(3))/r, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 3*x**2 + 3*y**2 - 3*z**2)*SorH(7,r) + r*(x**2 - y**2 + z**2)*SorH(7,r,1) + y**2*(-3*SorH(8,r) + r*SorH(8,r,1))*sqrt(3)))/r, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(x*y*((2 - 3*x**2 - 3*y**2)*SorH(8,r) + r*(x**2 + y**2 - 2*z**2)*SorH(8,r,1) + 2*z**2*(3*SorH(8,r) - 3*SorH(7,r)*sqrt(3) + r*SorH(7,r,1)*sqrt(3))))/(2.*r), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (y*z*((-2 + 6*x**2)*SorH(7,r) + (1 - 3*x**2)*SorH(8,r)*sqrt(3) + r*x**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: (x*y*(2*(-4 + 6*x**2 + 3*z**2)*SorH(7,r) - 2*r*(2*x**2 + z**2)*SorH(7,r,1) + (2 - 3*x**2 + 3*y**2)*SorH(8,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,1)*sqrt(3)))/(2.*r), \
	(1,0,0,0) : lambda r,x,y,z,SorH: x*z*(-(SorH(4,r)/r) + SorH(4,r,1)), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(2*SorH(5,r) - 2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1))))/r, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (x*(-2*(-1 + x**2 + y**2)*SorH(5,r) + r*(x**2 + y**2)*SorH(5,r,1) + z**2*(-2*SorH(6,r) + r*SorH(6,r,1))))/r, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (z*((-1 + 2*x**2)*SorH(5,r) + SorH(6,r) + x**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (y*z*((-2 + 6*x**2)*SorH(7,r) + (1 - 3*x**2)*SorH(8,r)*sqrt(3) + r*x**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (x*y*((2 - 3*x**2 - 3*y**2 + 3*z**2)*SorH(7,r) + r*(x**2 + y**2 - z**2)*SorH(7,r,1) + z**2*(-3*SorH(8,r) + r*SorH(8,r,1))*sqrt(3)))/r, \
	(1,0,2,0) : lambda r,x,y,z,SorH: -(x*z*((2 - 3*x**2 - 3*y**2 + 6*z**2)*SorH(8,r) + 2*(-2 + 3*x**2 + 3*y**2)*SorH(7,r)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(8,r,1) - 2*(x**2 + y**2)*SorH(7,r,1)*sqrt(3))))/(2.*r), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (((y - z)*(y + z) - 3*x**2*(-1 + x**2 + y**2 - z**2))*SorH(7,r) + r*x**2*(x**2 + y**2 - z**2)*SorH(7,r,1) + z**2*((1 - 3*x**2)*SorH(8,r) + r*x**2*SorH(8,r,1))*sqrt(3))/r, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (x*z*((-4 + 6*x**2 - 6*y**2)*SorH(7,r) + 2*SorH(8,r)*sqrt(3) - (x - y)*(x + y)*(2*r*SorH(7,r,1) + 3*SorH(8,r)*sqrt(3) - r*SorH(8,r,1)*sqrt(3))))/(2.*r), \
	(1,1,0,0) : lambda r,x,y,z,SorH: -(((-1 + x**2)*SorH(4,r))/r) + x**2*SorH(4,r,1), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (y*((-1 + 2*x**2)*SorH(5,r) + SorH(6,r) + x**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (z*((-1 + 2*x**2)*SorH(5,r) + SorH(6,r) + x**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (x*(-2*(-1 + x**2)*SorH(6,r) - (y**2 + z**2)*(2*SorH(5,r) - r*SorH(5,r,1)) + r*x**2*SorH(6,r,1)))/r, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (x*y*((-2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(7,r) + r*(-x**2 + y**2 + z**2)*SorH(7,r,1) + (2 - 3*x**2)*SorH(8,r)*sqrt(3) + r*x**2*SorH(8,r,1)*sqrt(3)))/r, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (y*z*((-2 + 6*x**2)*SorH(7,r) + (1 - 3*x**2)*SorH(8,r)*sqrt(3) + r*x**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -((y**2 - 2*z**2 - 3*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r) + 2*(1 - 3*x**2)*z**2*SorH(7,r)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,1) + 2*z**2*SorH(7,r,1)*sqrt(3)))/(2.*r), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (x*z*((-2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(7,r) + r*(-x**2 + y**2 + z**2)*SorH(7,r,1) + (2 - 3*x**2)*SorH(8,r)*sqrt(3) + r*x**2*SorH(8,r,1)*sqrt(3)))/r, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (-2*(-1 + 3*x**2)*(2*y**2 + z**2)*SorH(7,r) - (3*x**4 + y**2 - 3*x**2*(1 + y**2))*SorH(8,r)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(7,r,1) + (x - y)*(x + y)*SorH(8,r,1)*sqrt(3)))/(2.*r), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (y*((1 - 2*x**2)*SorH(9,r) + r*x**2*SorH(9,r,1))*sqrt(3))/r, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: ((-y**2 + z**2 - 3*x**2*(-1 + x**2 - y**2 + z**2))*SorH(10,r) + r*x**2*(x**2 - y**2 + z**2)*SorH(10,r,1) + y**2*((1 - 3*x**2)*SorH(11,r) + r*x**2*SorH(11,r,1))*sqrt(3))/r, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (y*z*((-2 + 6*x**2)*SorH(10,r) + (1 - 3*x**2)*SorH(11,r)*sqrt(3) + r*x**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (x*y*((-2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(10,r) + r*(-x**2 + y**2 + z**2)*SorH(10,r,1) + (2 - 3*x**2)*SorH(11,r)*sqrt(3) + r*x**2*SorH(11,r,1)*sqrt(3)))/r, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (x*(-2*(y**2 + z**2)*(-1 + 2*x**2 + 2*z**2)*SorH(12,r) + 2*(-2*x**4 + z**2 + x**2*(2 + 4*y**2 - 2*z**2) - 2*y**2*(1 + y**2 + z**2))*SorH(13,r) + 6*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*z**4*SorH(12,r,1) + r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (z*((4*x**4 - z**2 + x**2*(-3 + 4*z**2))*SorH(12,r) + (-3*y**2 + z**2 + x**2*(3 - 4*x**2 + 12*y**2 - 4*z**2))*SorH(13,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - r*x**4*SorH(12,r,1) - r*x**2*z**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (y*((-4*x**4 + y**2 + 2*z**2 + x**2*(3 - 4*y**2 - 8*z**2))*SorH(12,r) + 4*(-1 + 4*x**2)*z**2*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 4*r*x**2*z**2*SorH(13,r,1) - r*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (x*y*z*(4*(y**2 + z**2)*SorH(12,r) - 4*(y**2 + z**2)*SorH(13,r) + 6*(-1 + 2*x**2)*(SorH(13,r) - SorH(14,r)) + r*(-((y**2 + z**2)*SorH(12,r,1)) + (-3*x**2 + y**2 + z**2)*SorH(13,r,1) + 3*x**2*SorH(14,r,1))))/r, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (y*(-((4*x**4 + y**2 - x**2*(3 + 4*y**2))*SorH(12,r)) + 4*(y**2 + x**2*(-3 + 4*x**2 - 4*y**2))*SorH(13,r) + 9*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 12*x**2*y**2*SorH(14,r) + r*x**4*SorH(12,r,1) - r*x**2*y**2*SorH(12,r,1) - 4*r*x**4*SorH(13,r,1) + 4*r*x**2*y**2*SorH(13,r,1) + 3*r*x**2*(x - y)*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (x*y*z*(-2*SorH(9,r) + r*SorH(9,r,1))*sqrt(3))/r, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 3*x**2 + 3*y**2 - 3*z**2)*SorH(10,r) + r*(x**2 - y**2 + z**2)*SorH(10,r,1) + y**2*(-3*SorH(11,r) + r*SorH(11,r,1))*sqrt(3)))/r, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (x*y*((2 - 3*x**2 - 3*y**2 + 3*z**2)*SorH(10,r) + r*(x**2 + y**2 - z**2)*SorH(10,r,1) + z**2*(-3*SorH(11,r) + r*SorH(11,r,1))*sqrt(3)))/r, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (y*z*((-2 + 6*x**2)*SorH(10,r) + (1 - 3*x**2)*SorH(11,r)*sqrt(3) + r*x**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (z*((4*x**4 - z**2 + x**2*(-3 + 4*z**2))*SorH(12,r) + (-3*y**2 + z**2 + x**2*(3 - 4*x**2 + 12*y**2 - 4*z**2))*SorH(13,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - r*x**4*SorH(12,r,1) - r*x**2*z**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (x*(2*(y**2 - 2*x**2*(-1 + x**2 + y**2) + z**2 - 2*(x**2 + y**2)*z**2)*SorH(12,r) + 2*(-2*y**4 + z**2 - 2*z**2*(x**2 + z**2) + y**2*(1 - 2*x**2 + 4*z**2))*SorH(13,r) - 12*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: (x*y*z*((-2 + 4*x**2 + 4*y**2)*SorH(12,r) + (4 - 8*x**2 - 8*y**2 + 8*z**2)*SorH(13,r) - 2*SorH(14,r) + 4*x**2*SorH(14,r) + 4*y**2*SorH(14,r) - 8*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 2*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (y*((4*x**4 - y**2 + x**2*(-3 + 4*y**2))*SorH(12,r) + (y**2 - 3*z**2 + x**2*(3 - 4*x**2 - 4*y**2 + 12*z**2))*SorH(13,r) + 3*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - r*x**2*y**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) + r*x**2*y**2*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (x*y*z*(-2*(-3 + 6*x**2 + 2*y**2 + 4*z**2)*SorH(12,r) + 4*(-3 + 6*x**2 - 2*y**2 + 2*z**2)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 6*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 3*r*(x - y)*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (x*(-1 + x**2 + y**2 - 2*z**2)*SorH(9,r))/r - (x*(x**2 + y**2 - 2*z**2)*SorH(9,r,1))/2., \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(x*y*((2 - 3*x**2 - 3*y**2)*SorH(11,r) + r*(x**2 + y**2 - 2*z**2)*SorH(11,r,1) + 2*z**2*(3*SorH(11,r) - 3*SorH(10,r)*sqrt(3) + r*SorH(10,r,1)*sqrt(3))))/(2.*r), \
	(2,0,1,0) : lambda r,x,y,z,SorH: -(x*z*((2 - 3*x**2 - 3*y**2 + 6*z**2)*SorH(11,r) + 2*(-2 + 3*x**2 + 3*y**2)*SorH(10,r)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(11,r,1) - 2*(x**2 + y**2)*SorH(10,r,1)*sqrt(3))))/(2.*r), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -((y**2 - 2*z**2 - 3*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(11,r) + 2*(1 - 3*x**2)*z**2*SorH(10,r)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,1) + 2*z**2*SorH(10,r,1)*sqrt(3)))/(2.*r), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (y*((-4*x**4 + y**2 + 2*z**2 + x**2*(3 - 4*y**2 - 8*z**2))*SorH(12,r) + 4*(-1 + 4*x**2)*z**2*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 4*r*x**2*z**2*SorH(13,r,1) - r*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: (x*y*z*((-2 + 4*x**2 + 4*y**2)*SorH(12,r) + (4 - 8*x**2 - 8*y**2 + 8*z**2)*SorH(13,r) - 2*SorH(14,r) + 4*x**2*SorH(14,r) + 4*y**2*SorH(14,r) - 8*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 2*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (x*(-12*(-1 + x**2 + y**2)*(x**2 + y**2)*SorH(12,r) - 24*(-1 + 2*x**2 + 2*y**2)*z**2*SorH(13,r) + 4*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 8*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 16*x**2*z**2*SorH(14,r) + 16*y**2*z**2*SorH(14,r) - 16*z**4*SorH(14,r) + 3*r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) + 3*r*y**4*SorH(12,r,1) + 12*r*x**2*z**2*SorH(13,r,1) + 12*r*y**2*z**2*SorH(13,r,1) + r*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,1)))/(4.*r), \
	(2,0,2,1) : lambda r,x,y,z,SorH: (z*((4*x**4 - y**2 + x**2*(-3 + 4*y**2))*SorH(12,r) + 2*((y - z)*(y + z) + x**2*(3 - 4*x**2 - 4*y**2 + 4*z**2))*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - r*x**2*y**2*SorH(12,r,1) + 2*r*x**4*SorH(13,r,1) + 2*r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) - r*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (x*(4*(-x**4 + y**4 + z**2 + 2*y**2*z**2 + x**2*(1 - 2*z**2))*SorH(12,r) + 8*(-1 + 2*x**2 - 2*y**2)*z**2*SorH(13,r) - 4*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - 4*y**4*SorH(14,r) + 4*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + 8*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 2*r*y**2*z**2*SorH(12,r,1) - 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - r*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(4.*r), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (z*((1 - 2*x**2)*SorH(9,r) + r*x**2*SorH(9,r,1))*sqrt(3))/r, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (y*z*((-2 + 6*x**2)*SorH(10,r) + (1 - 3*x**2)*SorH(11,r)*sqrt(3) + r*x**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (((y - z)*(y + z) - 3*x**2*(-1 + x**2 + y**2 - z**2))*SorH(10,r) + r*x**2*(x**2 + y**2 - z**2)*SorH(10,r,1) + z**2*((1 - 3*x**2)*SorH(11,r) + r*x**2*SorH(11,r,1))*sqrt(3))/r, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (x*z*((-2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(10,r) + r*(-x**2 + y**2 + z**2)*SorH(10,r,1) + (2 - 3*x**2)*SorH(11,r)*sqrt(3) + r*x**2*SorH(11,r,1)*sqrt(3)))/r, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(4*(y**2 + z**2)*SorH(12,r) - 4*(y**2 + z**2)*SorH(13,r) + 6*(-1 + 2*x**2)*(SorH(13,r) - SorH(14,r)) + r*(-((y**2 + z**2)*SorH(12,r,1)) + (-3*x**2 + y**2 + z**2)*SorH(13,r,1) + 3*x**2*SorH(14,r,1))))/r, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (y*((4*x**4 - y**2 + x**2*(-3 + 4*y**2))*SorH(12,r) + (y**2 - 3*z**2 + x**2*(3 - 4*x**2 - 4*y**2 + 12*z**2))*SorH(13,r) + 3*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - r*x**2*y**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) + r*x**2*y**2*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,1,2,0) : lambda r,x,y,z,SorH: (z*((4*x**4 - y**2 + x**2*(-3 + 4*y**2))*SorH(12,r) + 2*((y - z)*(y + z) + x**2*(3 - 4*x**2 - 4*y**2 + 4*z**2))*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - r*x**2*y**2*SorH(12,r,1) + 2*r*x**4*SorH(13,r,1) + 2*r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) - r*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (x*(-2*(-1 + 2*x**2 + 2*y**2)*(y**2 + z**2)*SorH(12,r) + 2*(y**2 - 2*z**2 - 2*(x**2*(-1 + x**2 + y**2) + (-2*x**2 + y**2)*z**2 + z**4))*SorH(13,r) + 6*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) + r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(z*((-4*x**4 + 3*y**2 + 2*z**2 + x**2*(3 - 12*y**2 - 8*z**2))*SorH(12,r) - 2*(4*x**4 + 3*y**2 + z**2 - x**2*(3 + 12*y**2 + 4*z**2))*SorH(13,r) - 9*x**2*SorH(14,r) + 12*x**4*SorH(14,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 3*r*x**2*y**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) + 2*r*x**4*SorH(13,r,1) - 6*r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 3*r*x**2*(-x**2 + y**2)*SorH(14,r,1)))/(2.*r), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (x*(2*(1 - x**2 + y**2)*SorH(9,r) + r*(x - y)*(x + y)*SorH(9,r,1))*sqrt(3))/(2.*r), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (x*y*(2*(-4 + 6*x**2 + 3*z**2)*SorH(10,r) - 2*r*(2*x**2 + z**2)*SorH(10,r,1) + (2 - 3*x**2 + 3*y**2)*SorH(11,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,1)*sqrt(3)))/(2.*r), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (x*z*((-4 + 6*x**2 - 6*y**2)*SorH(10,r) + (2 - 3*x**2 + 3*y**2)*SorH(11,r)*sqrt(3) - r*(x - y)*(x + y)*(2*SorH(10,r,1) - SorH(11,r,1)*sqrt(3))))/(2.*r), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (-2*(-1 + 3*x**2)*(2*y**2 + z**2)*SorH(10,r) - (3*x**4 + y**2 - 3*x**2*(1 + y**2))*SorH(11,r)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(10,r,1) + (x - y)*(x + y)*SorH(11,r,1)*sqrt(3)))/(2.*r), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (y*(-((4*x**4 + y**2 - x**2*(3 + 4*y**2))*SorH(12,r)) + 4*(y**2 + x**2*(-3 + 4*x**2 - 4*y**2))*SorH(13,r) + 9*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 12*x**2*y**2*SorH(14,r) + r*x**4*SorH(12,r,1) - r*x**2*y**2*SorH(12,r,1) - 4*r*x**4*SorH(13,r,1) + 4*r*x**2*y**2*SorH(13,r,1) + 3*r*x**2*(x - y)*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(-2*(-3 + 6*x**2 + 2*y**2 + 4*z**2)*SorH(12,r) + 4*(-3 + 6*x**2 - 2*y**2 + 2*z**2)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 6*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 3*r*(x - y)*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (x*(4*(-x**4 + y**4 + z**2 + 2*y**2*z**2 + x**2*(1 - 2*z**2))*SorH(12,r) + 8*(-1 + 2*x**2 - 2*y**2)*z**2*SorH(13,r) - 4*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - 4*y**4*SorH(14,r) + 4*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + 8*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 2*r*y**2*z**2*SorH(12,r,1) - 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - r*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(4.*r), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(z*((-4*x**4 + 3*y**2 + 2*z**2 + x**2*(3 - 12*y**2 - 8*z**2))*SorH(12,r) - 2*(4*x**4 + 3*y**2 + z**2 - x**2*(3 + 12*y**2 + 4*z**2))*SorH(13,r) - 9*x**2*SorH(14,r) + 12*x**4*SorH(14,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 3*r*x**2*y**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) + 2*r*x**4*SorH(13,r,1) - 6*r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 3*r*x**2*(-x**2 + y**2)*SorH(14,r,1)))/(2.*r), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (x*(-4*(x**4 + y**2 - 2*z**2 + (y**2 + 2*z**2)**2 + x**2*(-1 - 2*y**2 + 4*z**2))*SorH(12,r) - 8*((-1 + 2*x**2)*z**2 + 2*y**2*(-2 + 4*x**2 + z**2))*SorH(13,r) + 12*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 12*y**4*SorH(14,r) + r*x**4*SorH(12,r,1) - 2*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 4*r*x**2*z**2*SorH(12,r,1) + 4*r*y**2*z**2*SorH(12,r,1) + 4*r*z**4*SorH(12,r,1) + 16*r*x**2*y**2*SorH(13,r,1) + 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) + 3*r*(x**2 - y**2)**2*SorH(14,r,1)))/(4.*r), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: y*SorH(0,r,1), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: -(((-1 + y**2)*SorH(2,r))/r) + y**2*SorH(2,r,1), \
	(0,0,1,0) : lambda r,x,y,z,SorH: y*z*(-(SorH(2,r)/r) + SorH(2,r,1)), \
	(0,0,1,1) : lambda r,x,y,z,SorH: x*y*(-(SorH(2,r)/r) + SorH(2,r,1)), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*((1 - 2*y**2)*SorH(3,r) + r*y**2*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (z*((1 - 2*y**2)*SorH(3,r) + r*y**2*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (y*(-1 + x**2 + y**2 - 2*z**2)*SorH(3,r))/r - (y*(x**2 + y**2 - 2*z**2)*SorH(3,r,1))/2., \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*y*z*(-2*SorH(3,r) + r*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (y*(-2*(1 + x**2 - y**2)*SorH(3,r) + r*(x - y)*(x + y)*SorH(3,r,1))*sqrt(3))/(2.*r), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: -(((-1 + y**2)*SorH(4,r))/r) + y**2*SorH(4,r,1), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (y*(-2*(-1 + y**2)*SorH(6,r) - (x**2 + z**2)*(2*SorH(5,r) - r*SorH(5,r,1)) + r*y**2*SorH(6,r,1)))/r, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (z*((-1 + 2*y**2)*SorH(5,r) + SorH(6,r) + y**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*((-1 + 2*y**2)*SorH(5,r) + SorH(6,r) + y**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*y*(-((2 + 3*x**2 - 3*y**2 + 3*z**2)*SorH(7,r)) + r*(x**2 - y**2 + z**2)*SorH(7,r,1) + (2 - 3*y**2)*SorH(8,r)*sqrt(3) + r*y**2*SorH(8,r,1)*sqrt(3)))/r, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (y*z*(-((2 + 3*x**2 - 3*y**2 + 3*z**2)*SorH(7,r)) + r*(x**2 - y**2 + z**2)*SorH(7,r,1) + (2 - 3*y**2)*SorH(8,r)*sqrt(3) + r*y**2*SorH(8,r,1)*sqrt(3)))/r, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(x**2*SorH(8,r) + (-2*z**2 - 3*y**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r) + 2*(1 - 3*y**2)*z**2*SorH(7,r)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,1) + 2*z**2*SorH(7,r,1)*sqrt(3)))/(2.*r), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*z*((-2 + 6*y**2)*SorH(7,r) + (1 - 3*y**2)*SorH(8,r)*sqrt(3) + r*y**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: (2*(-1 + 3*y**2)*(2*x**2 + z**2)*SorH(7,r) + (x**2 - 3*(1 + x**2)*y**2 + 3*y**4)*SorH(8,r)*sqrt(3) + r*y**2*(-2*(2*x**2 + z**2)*SorH(7,r,1) + (x - y)*(x + y)*SorH(8,r,1)*sqrt(3)))/(2.*r), \
	(1,0,0,0) : lambda r,x,y,z,SorH: y*z*(-(SorH(4,r)/r) + SorH(4,r,1)), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (z*((-1 + 2*y**2)*SorH(5,r) + SorH(6,r) + y**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (y*(-2*(-1 + x**2 + y**2)*SorH(5,r) + r*(x**2 + y**2)*SorH(5,r,1) + z**2*(-2*SorH(6,r) + r*SorH(6,r,1))))/r, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*y*z*(2*SorH(5,r) - 2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1))))/r, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*z*((-2 + 6*y**2)*SorH(7,r) + (1 - 3*y**2)*SorH(8,r)*sqrt(3) + r*y**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: ((x**2*(1 - 3*y**2) - z**2 + 3*y**2*(1 - y**2 + z**2))*SorH(7,r) + r*y**2*(x**2 + y**2 - z**2)*SorH(7,r,1) + z**2*((1 - 3*y**2)*SorH(8,r) + r*y**2*SorH(8,r,1))*sqrt(3))/r, \
	(1,0,2,0) : lambda r,x,y,z,SorH: -(y*z*((2 - 3*x**2 - 3*y**2 + 6*z**2)*SorH(8,r) + 2*(-2 + 3*x**2 + 3*y**2)*SorH(7,r)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(8,r,1) - 2*(x**2 + y**2)*SorH(7,r,1)*sqrt(3))))/(2.*r), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*y*((2 - 3*x**2 - 3*y**2 + 3*z**2)*SorH(7,r) + r*(x**2 + y**2 - z**2)*SorH(7,r,1) + z**2*(-3*SorH(8,r) + r*SorH(8,r,1))*sqrt(3)))/r, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (y*z*((4 + 6*x**2 - 6*y**2)*SorH(7,r) - 2*SorH(8,r)*sqrt(3) - (x - y)*(x + y)*(2*r*SorH(7,r,1) + 3*SorH(8,r)*sqrt(3) - r*SorH(8,r,1)*sqrt(3))))/(2.*r), \
	(1,1,0,0) : lambda r,x,y,z,SorH: x*y*(-(SorH(4,r)/r) + SorH(4,r,1)), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*((-1 + 2*y**2)*SorH(5,r) + SorH(6,r) + y**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*y*z*(2*SorH(5,r) - 2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1))))/r, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (y*(-2*(-1 + y**2 + z**2)*SorH(5,r) + r*(y**2 + z**2)*SorH(5,r,1) + x**2*(-2*SorH(6,r) + r*SorH(6,r,1))))/r, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: ((x**2*(-1 + 3*y**2) + z**2 - 3*y**2*(-1 + y**2 + z**2))*SorH(7,r) + r*y**2*(-x**2 + y**2 + z**2)*SorH(7,r,1) + x**2*((1 - 3*y**2)*SorH(8,r) + r*y**2*SorH(8,r,1))*sqrt(3))/r, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*z*((-2 + 6*y**2)*SorH(7,r) + (1 - 3*y**2)*SorH(8,r)*sqrt(3) + r*y**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(x*y*((2 - 3*x**2 - 3*y**2)*SorH(8,r) + r*(x**2 + y**2 - 2*z**2)*SorH(8,r,1) + 2*z**2*(3*SorH(8,r) - 3*SorH(7,r)*sqrt(3) + r*SorH(7,r,1)*sqrt(3))))/(2.*r), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (y*z*((2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(7,r) + r*(-x**2 + y**2 + z**2)*SorH(7,r,1) + x**2*(-3*SorH(8,r) + r*SorH(8,r,1))*sqrt(3)))/r, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*y*(-2*(-4 + 6*y**2 + 3*z**2)*SorH(7,r) + 2*r*(2*y**2 + z**2)*SorH(7,r,1) + (-2 - 3*x**2 + 3*y**2)*SorH(8,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,1)*sqrt(3)))/(2.*r), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*((1 - 2*y**2)*SorH(9,r) + r*y**2*SorH(9,r,1))*sqrt(3))/r, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*y*(-((2 + 3*x**2 - 3*y**2 + 3*z**2)*SorH(10,r)) + r*(x**2 - y**2 + z**2)*SorH(10,r,1) + (2 - 3*y**2)*SorH(11,r)*sqrt(3) + r*y**2*SorH(11,r,1)*sqrt(3)))/r, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*z*((-2 + 6*y**2)*SorH(10,r) + (1 - 3*y**2)*SorH(11,r)*sqrt(3) + r*y**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: ((x**2*(-1 + 3*y**2) + z**2 - 3*y**2*(-1 + y**2 + z**2))*SorH(10,r) + r*y**2*(-x**2 + y**2 + z**2)*SorH(10,r,1) + x**2*((1 - 3*y**2)*SorH(11,r) + r*y**2*SorH(11,r,1))*sqrt(3))/r, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (y*(-2*(x**2 + z**2)*(-1 + 2*y**2 + 2*z**2)*SorH(12,r) + 2*(-2*(x - y)*(x + y)*(1 + x**2 - y**2) + (1 - 2*x**2 - 2*y**2)*z**2)*SorH(13,r) + 6*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*z**4*SorH(12,r,1) + r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(4*(x**2 + z**2)*SorH(12,r) - 2*(3 + 2*x**2 - 6*y**2 + 2*z**2)*SorH(13,r) + 6*SorH(14,r) - 12*y**2*SorH(14,r) - r*(x**2 + z**2)*SorH(12,r,1) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + r*z**2*SorH(13,r,1) + 3*r*y**2*SorH(14,r,1)))/r, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*((x**2*(1 - 4*y**2) + 2*z**2 + y**2*(3 - 4*y**2 - 8*z**2))*SorH(12,r) + 4*(-1 + 4*y**2)*z**2*SorH(13,r) - x**2*SorH(14,r) - 3*y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 4*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 4*r*y**2*z**2*SorH(13,r,1) - r*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (z*((4*y**4 - z**2 + y**2*(-3 + 4*z**2))*SorH(12,r) + (3*x**2*(-1 + 4*y**2) + z**2 + y**2*(3 - 4*y**2 - 4*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - r*y**4*SorH(12,r,1) - r*y**2*z**2*SorH(12,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*((x**2 - (3 + 4*x**2)*y**2 + 4*y**4)*SorH(12,r) + 4*(3*y**2 - 4*y**4 + x**2*(-1 + 4*y**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 4*r*y**2*(-x**2 + y**2)*SorH(13,r,1) + 3*r*(x - y)*y**2*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (z*((1 - 2*y**2)*SorH(9,r) + r*y**2*SorH(9,r,1))*sqrt(3))/r, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (y*z*(-((2 + 3*x**2 - 3*y**2 + 3*z**2)*SorH(10,r)) + r*(x**2 - y**2 + z**2)*SorH(10,r,1) + (2 - 3*y**2)*SorH(11,r)*sqrt(3) + r*y**2*SorH(11,r,1)*sqrt(3)))/r, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: ((x**2*(1 - 3*y**2) - z**2 + 3*y**2*(1 - y**2 + z**2))*SorH(10,r) + r*y**2*(x**2 + y**2 - z**2)*SorH(10,r,1) + z**2*((1 - 3*y**2)*SorH(11,r) + r*y**2*SorH(11,r,1))*sqrt(3))/r, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*z*((-2 + 6*y**2)*SorH(10,r) + (1 - 3*y**2)*SorH(11,r)*sqrt(3) + r*y**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(4*(x**2 + z**2)*SorH(12,r) - 2*(3 + 2*x**2 - 6*y**2 + 2*z**2)*SorH(13,r) + 6*SorH(14,r) - 12*y**2*SorH(14,r) - r*(x**2 + z**2)*SorH(12,r,1) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + r*z**2*SorH(13,r,1) + 3*r*y**2*SorH(14,r,1)))/r, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (y*(-2*(-1 + 2*x**2 + 2*y**2)*(x**2 + z**2)*SorH(12,r) + 2*(x**2*(1 - 2*y**2 - 2*z**2) - 2*(y - z)*(y + z)*(-1 + y**2 - z**2))*SorH(13,r) + 6*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: (z*((-x**2 + (-3 + 4*x**2)*y**2 + 4*y**4)*SorH(12,r) + 2*(x**2 + 3*y**2 - 4*x**2*y**2 - 4*y**4 + (-1 + 4*y**2)*z**2)*SorH(13,r) - x**2*SorH(14,r) - 3*y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 4*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) - r*x**2*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 2*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) - r*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*((-x**2 + (-3 + 4*x**2)*y**2 + 4*y**4)*SorH(12,r) + (x**2 + 3*y**2 - 4*x**2*y**2 - 4*y**4 + 3*(-1 + 4*y**2)*z**2)*SorH(13,r) + 3*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) - r*x**2*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (z*((-4*y**4 + x**2*(3 - 12*y**2) + 2*z**2 + y**2*(3 - 8*z**2))*SorH(12,r) + (-8*y**4 + 6*x**2*(-1 + 4*y**2) - 2*z**2 + y**2*(6 + 8*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) + 3*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 6*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 3*r*(x - y)*y**2*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (y*(-1 + x**2 + y**2 - 2*z**2)*SorH(9,r))/r - (y*(x**2 + y**2 - 2*z**2)*SorH(9,r,1))/2., \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -((-3*y**4 + x**2*(1 - 3*y**2) - 2*z**2 + y**2*(3 + 6*z**2))*SorH(11,r) + 2*(1 - 3*y**2)*z**2*SorH(10,r)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,1) + 2*z**2*SorH(10,r,1)*sqrt(3)))/(2.*r), \
	(2,0,1,0) : lambda r,x,y,z,SorH: -(y*z*((2 - 3*x**2 - 3*y**2 + 6*z**2)*SorH(11,r) + 2*(-2 + 3*x**2 + 3*y**2)*SorH(10,r)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(11,r,1) - 2*(x**2 + y**2)*SorH(10,r,1)*sqrt(3))))/(2.*r), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(x*y*((2 - 3*x**2 - 3*y**2)*SorH(11,r) + r*(x**2 + y**2 - 2*z**2)*SorH(11,r,1) + 2*z**2*(3*SorH(11,r) - 3*SorH(10,r)*sqrt(3) + r*SorH(10,r,1)*sqrt(3))))/(2.*r), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*((x**2*(1 - 4*y**2) + 2*z**2 + y**2*(3 - 4*y**2 - 8*z**2))*SorH(12,r) + 4*(-1 + 4*y**2)*z**2*SorH(13,r) - x**2*SorH(14,r) - 3*y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 4*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 4*r*y**2*z**2*SorH(13,r,1) - r*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: (z*((-x**2 + (-3 + 4*x**2)*y**2 + 4*y**4)*SorH(12,r) + 2*(x**2 + 3*y**2 - 4*x**2*y**2 - 4*y**4 + (-1 + 4*y**2)*z**2)*SorH(13,r) - x**2*SorH(14,r) - 3*y**2*SorH(14,r) + 4*x**2*y**2*SorH(14,r) + 4*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) - r*x**2*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 2*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) - r*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (y*(-12*(-1 + x**2 + y**2)*(x**2 + y**2)*SorH(12,r) - 24*(-1 + 2*x**2 + 2*y**2)*z**2*SorH(13,r) + 4*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 8*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 16*x**2*z**2*SorH(14,r) + 16*y**2*z**2*SorH(14,r) - 16*z**4*SorH(14,r) + 3*r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) + 3*r*y**4*SorH(12,r,1) + 12*r*x**2*z**2*SorH(13,r,1) + 12*r*y**2*z**2*SorH(13,r,1) + r*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,1)))/(4.*r), \
	(2,0,2,1) : lambda r,x,y,z,SorH: (x*y*z*((-2 + 4*x**2 + 4*y**2)*SorH(12,r) + (4 - 8*x**2 - 8*y**2 + 8*z**2)*SorH(13,r) - 2*SorH(14,r) + 4*x**2*SorH(14,r) + 4*y**2*SorH(14,r) - 8*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 2*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (y*(-4*(x**4 + y**2 - y**4 + (1 + 2*x**2 - 2*y**2)*z**2)*SorH(12,r) + 8*(1 + 2*x**2 - 2*y**2)*z**2*SorH(13,r) + 4*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 4*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + 8*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 2*r*y**2*z**2*SorH(12,r,1) - 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - r*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(4.*r), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*y*z*(-2*SorH(9,r) + r*SorH(9,r,1))*sqrt(3))/r, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*z*((-2 + 6*y**2)*SorH(10,r) + (1 - 3*y**2)*SorH(11,r)*sqrt(3) + r*y**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*y*((2 - 3*x**2 - 3*y**2 + 3*z**2)*SorH(10,r) + r*(x**2 + y**2 - z**2)*SorH(10,r,1) + z**2*(-3*SorH(11,r) + r*SorH(11,r,1))*sqrt(3)))/r, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (y*z*((2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(10,r) + r*(-x**2 + y**2 + z**2)*SorH(10,r,1) + x**2*(-3*SorH(11,r) + r*SorH(11,r,1))*sqrt(3)))/r, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (z*((4*y**4 - z**2 + y**2*(-3 + 4*z**2))*SorH(12,r) + (3*x**2*(-1 + 4*y**2) + z**2 + y**2*(3 - 4*y**2 - 4*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - r*y**4*SorH(12,r,1) - r*y**2*z**2*SorH(12,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*((-x**2 + (-3 + 4*x**2)*y**2 + 4*y**4)*SorH(12,r) + (x**2 + 3*y**2 - 4*x**2*y**2 - 4*y**4 + 3*(-1 + 4*y**2)*z**2)*SorH(13,r) + 3*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) - r*x**2*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,1,2,0) : lambda r,x,y,z,SorH: (x*y*z*((-2 + 4*x**2 + 4*y**2)*SorH(12,r) + (4 - 8*x**2 - 8*y**2 + 8*z**2)*SorH(13,r) - 2*SorH(14,r) + 4*x**2*SorH(14,r) + 4*y**2*SorH(14,r) - 8*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 2*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (y*(2*(z**2 + x**2*(1 - 2*y**2 - 2*z**2) - 2*y**2*(-1 + y**2 + z**2))*SorH(12,r) + 2*(-2*x**4 + z**2 - 2*z**2*(y**2 + z**2) + x**2*(1 - 2*y**2 + 4*z**2))*SorH(13,r) - 12*x**2*z**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) + r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,1,2,2) : lambda r,x,y,z,SorH: (x*y*z*(2*(-3 + 2*x**2 + 6*y**2 + 4*z**2)*SorH(12,r) + 4*(3 + 2*x**2 - 6*y**2 - 2*z**2)*SorH(13,r) - 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) - 2*r*z**2*SorH(12,r,1) + 2*r*(-x**2 + 3*y**2 + z**2)*SorH(13,r,1) + 3*r*(x - y)*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (y*(-2*(1 + x**2 - y**2)*SorH(9,r) + r*(x - y)*(x + y)*SorH(9,r,1))*sqrt(3))/(2.*r), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (2*(-1 + 3*y**2)*(2*x**2 + z**2)*SorH(10,r) + (x**2 - 3*(1 + x**2)*y**2 + 3*y**4)*SorH(11,r)*sqrt(3) + r*y**2*(-2*(2*x**2 + z**2)*SorH(10,r,1) + (x - y)*(x + y)*SorH(11,r,1)*sqrt(3)))/(2.*r), \
	(2,2,1,0) : lambda r,x,y,z,SorH: -(y*z*((-4 - 6*x**2 + 6*y**2)*SorH(10,r) + (2 + 3*x**2 - 3*y**2)*SorH(11,r)*sqrt(3) + r*(x - y)*(x + y)*(2*SorH(10,r,1) - SorH(11,r,1)*sqrt(3))))/(2.*r), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*y*(-2*(-4 + 6*y**2 + 3*z**2)*SorH(10,r) + 2*r*(2*y**2 + z**2)*SorH(10,r,1) + (-2 - 3*x**2 + 3*y**2)*SorH(11,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,1)*sqrt(3)))/(2.*r), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*((x**2 - (3 + 4*x**2)*y**2 + 4*y**4)*SorH(12,r) + 4*(3*y**2 - 4*y**4 + x**2*(-1 + 4*y**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 4*r*y**2*(-x**2 + y**2)*SorH(13,r,1) + 3*r*(x - y)*y**2*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (z*((-4*y**4 + x**2*(3 - 12*y**2) + 2*z**2 + y**2*(3 - 8*z**2))*SorH(12,r) + (-8*y**4 + 6*x**2*(-1 + 4*y**2) - 2*z**2 + y**2*(6 + 8*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) + 3*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 6*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 3*r*(x - y)*y**2*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (y*(-4*(x**4 + y**2 - y**4 + (1 + 2*x**2 - 2*y**2)*z**2)*SorH(12,r) + 8*(1 + 2*x**2 - 2*y**2)*z**2*SorH(13,r) + 4*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 4*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + 8*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 2*r*y**2*z**2*SorH(12,r,1) - 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - r*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(4.*r), \
	(2,2,2,1) : lambda r,x,y,z,SorH: (x*y*z*(2*(-3 + 2*x**2 + 6*y**2 + 4*z**2)*SorH(12,r) + 4*(3 + 2*x**2 - 6*y**2 - 2*z**2)*SorH(13,r) - 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) - 2*r*z**2*SorH(12,r,1) + 2*r*(-x**2 + 3*y**2 + z**2)*SorH(13,r,1) + 3*r*(x - y)*(x + y)*SorH(14,r,1)))/(2.*r), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (y*(-4*(x**4 + (-1 + y**2 + 2*z**2)*(y**2 + 2*z**2) + x**2*(1 - 2*y**2 + 4*z**2))*SorH(12,r) - 8*((-1 + 2*y**2)*z**2 + 2*x**2*(-2 + 4*y**2 + z**2))*SorH(13,r) - 12*x**2*SorH(14,r) - 12*x**4*SorH(14,r) + 12*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 12*y**4*SorH(14,r) + r*x**4*SorH(12,r,1) - 2*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 4*r*x**2*z**2*SorH(12,r,1) + 4*r*y**2*z**2*SorH(12,r,1) + 4*r*z**4*SorH(12,r,1) + 16*r*x**2*y**2*SorH(13,r,1) + 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) + 3*r*(x**2 - y**2)**2*SorH(14,r,1)))/(4.*r), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: z*SorH(0,r,1), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: y*z*(-(SorH(2,r)/r) + SorH(2,r,1)), \
	(0,0,1,0) : lambda r,x,y,z,SorH: -(((-1 + z**2)*SorH(2,r))/r) + z**2*SorH(2,r,1), \
	(0,0,1,1) : lambda r,x,y,z,SorH: x*z*(-(SorH(2,r)/r) + SorH(2,r,1)), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(-2*SorH(3,r) + r*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (y*((1 - 2*z**2)*SorH(3,r) + r*z**2*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (z*(2*(2 + x**2 + y**2 - 2*z**2)*SorH(3,r) - r*(x**2 + y**2 - 2*z**2)*SorH(3,r,1)))/(2.*r), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*((1 - 2*z**2)*SorH(3,r) + r*z**2*SorH(3,r,1))*sqrt(3))/r, \
	(0,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*z*(-2*SorH(3,r) + r*SorH(3,r,1))*sqrt(3))/(2.*r), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: y*z*(-(SorH(4,r)/r) + SorH(4,r,1)), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (z*(-2*(-1 + x**2 + z**2)*SorH(5,r) + r*(x**2 + z**2)*SorH(5,r,1) + y**2*(-2*SorH(6,r) + r*SorH(6,r,1))))/r, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (y*((-1 + 2*z**2)*SorH(5,r) + SorH(6,r) + z**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*y*z*(2*SorH(5,r) - 2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1))))/r, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*z*((2 - 3*x**2 + 3*y**2 - 3*z**2)*SorH(7,r) + r*(x**2 - y**2 + z**2)*SorH(7,r,1) + y**2*(-3*SorH(8,r) + r*SorH(8,r,1))*sqrt(3)))/r, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: ((x**2 - y**2 + 3*(1 - x**2 + y**2)*z**2 - 3*z**4)*SorH(7,r) + r*z**2*(x**2 - y**2 + z**2)*SorH(7,r,1) + y**2*((1 - 3*z**2)*SorH(8,r) + r*z**2*SorH(8,r,1))*sqrt(3))/r, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: (y*z*((4 + 3*x**2 + 3*y**2 - 6*z**2)*SorH(8,r) + 2*(-2 + 3*z**2)*SorH(7,r)*sqrt(3) - r*((x**2 + y**2 - 2*z**2)*SorH(8,r,1) + 2*z**2*SorH(7,r,1)*sqrt(3))))/(2.*r), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*y*((-2 + 6*z**2)*SorH(7,r) + (1 - 3*z**2)*SorH(8,r)*sqrt(3) + r*z**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: (y*z*(2*(-2 + 6*x**2 + 3*z**2)*SorH(7,r) - 2*r*(2*x**2 + z**2)*SorH(7,r,1) + 3*(-x**2 + y**2)*SorH(8,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,1)*sqrt(3)))/(2.*r), \
	(1,0,0,0) : lambda r,x,y,z,SorH: -(((-1 + z**2)*SorH(4,r))/r) + z**2*SorH(4,r,1), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (y*((-1 + 2*z**2)*SorH(5,r) + SorH(6,r) + z**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (z*(-2*(-1 + z**2)*SorH(6,r) - (x**2 + y**2)*(2*SorH(5,r) - r*SorH(5,r,1)) + r*z**2*SorH(6,r,1)))/r, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*((-1 + 2*z**2)*SorH(5,r) + SorH(6,r) + z**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*y*((-2 + 6*z**2)*SorH(7,r) + (1 - 3*z**2)*SorH(8,r)*sqrt(3) + r*z**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (y*z*(-((2 + 3*x**2 + 3*y**2 - 3*z**2)*SorH(7,r)) + r*(x**2 + y**2 - z**2)*SorH(7,r,1) + (2 - 3*z**2)*SorH(8,r)*sqrt(3) + r*z**2*SorH(8,r,1)*sqrt(3)))/r, \
	(1,0,2,0) : lambda r,x,y,z,SorH: ((-x**2 - y**2 + 3*(2 + x**2 + y**2)*z**2 - 6*z**4)*SorH(8,r) + 2*r*z**4*SorH(8,r,1) - 2*(x**2 + y**2)*(-1 + 3*z**2)*SorH(7,r)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(8,r,1) + 2*SorH(7,r,1)*sqrt(3)))/(2.*r), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*z*(-((2 + 3*x**2 + 3*y**2 - 3*z**2)*SorH(7,r)) + r*(x**2 + y**2 - z**2)*SorH(7,r,1) + (2 - 3*z**2)*SorH(8,r)*sqrt(3) + r*z**2*SorH(8,r,1)*sqrt(3)))/r, \
	(1,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((-2 + 6*z**2)*SorH(7,r) + (1 - 3*z**2)*SorH(8,r)*sqrt(3) + r*z**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/(2.*r), \
	(1,1,0,0) : lambda r,x,y,z,SorH: x*z*(-(SorH(4,r)/r) + SorH(4,r,1)), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(2*SorH(5,r) - 2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1))))/r, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*((-1 + 2*z**2)*SorH(5,r) + SorH(6,r) + z**2*(-2*SorH(6,r) + r*(-SorH(5,r,1) + SorH(6,r,1)))))/r, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (z*(-2*(-1 + y**2 + z**2)*SorH(5,r) + r*(y**2 + z**2)*SorH(5,r,1) + x**2*(-2*SorH(6,r) + r*SorH(6,r,1))))/r, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (y*z*((2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(7,r) + r*(-x**2 + y**2 + z**2)*SorH(7,r,1) + x**2*(-3*SorH(8,r) + r*SorH(8,r,1))*sqrt(3)))/r, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*y*((-2 + 6*z**2)*SorH(7,r) + (1 - 3*z**2)*SorH(8,r)*sqrt(3) + r*z**2*(-2*SorH(7,r,1) + SorH(8,r,1)*sqrt(3))))/r, \
	(1,1,2,0) : lambda r,x,y,z,SorH: (x*z*((4 + 3*x**2 + 3*y**2 - 6*z**2)*SorH(8,r) + 2*(-2 + 3*z**2)*SorH(7,r)*sqrt(3) - r*((x**2 + y**2 - 2*z**2)*SorH(8,r,1) + 2*z**2*SorH(7,r,1)*sqrt(3))))/(2.*r), \
	(1,1,2,1) : lambda r,x,y,z,SorH: ((-x**2 + y**2 + 3*(1 + x**2 - y**2)*z**2 - 3*z**4)*SorH(7,r) + r*z**2*(-x**2 + y**2 + z**2)*SorH(7,r,1) + x**2*((1 - 3*z**2)*SorH(8,r) + r*z**2*SorH(8,r,1))*sqrt(3))/r, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*z*(-2*(-2 + 6*y**2 + 3*z**2)*SorH(7,r) + 2*r*(2*y**2 + z**2)*SorH(7,r,1) + 3*(-x**2 + y**2)*SorH(8,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,1)*sqrt(3)))/(2.*r), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*y*z*(-2*SorH(9,r) + r*SorH(9,r,1))*sqrt(3))/r, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 3*x**2 + 3*y**2 - 3*z**2)*SorH(10,r) + r*(x**2 - y**2 + z**2)*SorH(10,r,1) + y**2*(-3*SorH(11,r) + r*SorH(11,r,1))*sqrt(3)))/r, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*y*((-2 + 6*z**2)*SorH(10,r) + (1 - 3*z**2)*SorH(11,r)*sqrt(3) + r*z**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (y*z*((2 + 3*x**2 - 3*y**2 - 3*z**2)*SorH(10,r) + r*(-x**2 + y**2 + z**2)*SorH(10,r,1) + x**2*(-3*SorH(11,r) + r*SorH(11,r,1))*sqrt(3)))/r, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (z*(2*(x**2 + y**2 - 2*x**2*y**2 - 2*(-1 + x**2 + y**2)*z**2 - 2*z**4)*SorH(12,r) + 2*(x**2 - 2*x**4 + y**2 + 4*x**2*y**2 - 2*y**4 - 2*(x**2 + y**2)*z**2)*SorH(13,r) - 12*x**2*y**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*z**4*SorH(12,r,1) + r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + 3*r*x**2*y**2*SorH(14,r,1)))/r, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*((-x**2 + (-3 + 4*x**2)*z**2 + 4*z**4)*SorH(12,r) + (x**2 - 3*y**2 + (3 - 4*x**2 + 12*y**2)*z**2 - 4*z**4)*SorH(13,r) + 3*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) - r*x**2*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + r*x**2*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*y*z*(-4*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*SorH(13,r) + 4*SorH(14,r) + (x**2 + y**2)*(4*SorH(14,r) + r*SorH(12,r,1)) + 2*z**2*(8*SorH(13,r) - 4*SorH(14,r) + r*(SorH(12,r,1) - 2*SorH(13,r,1))) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (y*((-y**2 + (-3 + 4*y**2)*z**2 + 4*z**4)*SorH(12,r) + (-3*x**2 + y**2 + (3 + 12*x**2 - 4*y**2)*z**2 - 4*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - r*y**2*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*z*(-4*SorH(12,r) + 16*SorH(13,r) - 12*SorH(14,r) + r*(SorH(12,r,1) - 4*SorH(13,r,1) + 3*SorH(14,r,1))))/(2.*r), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (y*((1 - 2*z**2)*SorH(9,r) + r*z**2*SorH(9,r,1))*sqrt(3))/r, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: ((x**2 - y**2 + 3*(1 - x**2 + y**2)*z**2 - 3*z**4)*SorH(10,r) + r*z**2*(x**2 - y**2 + z**2)*SorH(10,r,1) + y**2*((1 - 3*z**2)*SorH(11,r) + r*z**2*SorH(11,r,1))*sqrt(3))/r, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (y*z*(-((2 + 3*x**2 + 3*y**2 - 3*z**2)*SorH(10,r)) + r*(x**2 + y**2 - z**2)*SorH(10,r,1) + (2 - 3*z**2)*SorH(11,r)*sqrt(3) + r*z**2*SorH(11,r,1)*sqrt(3)))/r, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*y*((-2 + 6*z**2)*SorH(10,r) + (1 - 3*z**2)*SorH(11,r)*sqrt(3) + r*z**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*((-x**2 + (-3 + 4*x**2)*z**2 + 4*z**4)*SorH(12,r) + (x**2 - 3*y**2 + (3 - 4*x**2 + 12*y**2)*z**2 - 4*z**4)*SorH(13,r) + 3*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) - r*x**2*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + r*x**2*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (z*(-2*(x**2 + y**2)*(-1 + 2*x**2 + 2*z**2)*SorH(12,r) + 2*(x**2*(1 - 2*y**2 - 2*z**2) - 2*(y - z)*(y + z)*(1 + y**2 - z**2))*SorH(13,r) + 6*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*y**2*z**2*SorH(14,r,1)))/r, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: (y*((x**2 + y**2)*(-1 + 4*z**2)*SorH(12,r) + 2*(x**2 + y**2 - (3 + 4*x**2 + 4*y**2)*z**2 + 4*z**4)*SorH(13,r) - x**2*SorH(14,r) - y**2*SorH(14,r) + 6*z**2*SorH(14,r) + 4*x**2*z**2*SorH(14,r) + 4*y**2*z**2*SorH(14,r) - 8*z**4*SorH(14,r) - r*x**2*z**2*SorH(12,r,1) - r*y**2*z**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(13,r,1) + 2*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) - r*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*y*z*(4*(x**2 + y**2)*SorH(12,r) - 2*(3 + 2*x**2 + 2*y**2 - 6*z**2)*SorH(13,r) + 6*SorH(14,r) + r*(x**2 + y**2)*(-SorH(12,r,1) + SorH(13,r,1)) - 3*z**2*(4*SorH(14,r) + r*(SorH(13,r,1) - SorH(14,r,1)))))/r, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (y*((3*x**2 + y**2 - 2*(-3 + 6*x**2 + 2*y**2)*z**2 - 8*z**4)*SorH(12,r) + 2*(-3*x**2 + y**2 + (-3 + 12*x**2 - 4*y**2)*z**2 + 4*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 3*y**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) + 3*r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) - 6*r*x**2*z**2*SorH(13,r,1) + 2*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 3*r*(x - y)*(x + y)*z**2*SorH(14,r,1)))/(2.*r), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (z*(2*(2 + x**2 + y**2 - 2*z**2)*SorH(9,r) - r*(x**2 + y**2 - 2*z**2)*SorH(9,r,1)))/(2.*r), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: (y*z*((4 + 3*x**2 + 3*y**2 - 6*z**2)*SorH(11,r) + 2*(-2 + 3*z**2)*SorH(10,r)*sqrt(3) - r*((x**2 + y**2 - 2*z**2)*SorH(11,r,1) + 2*z**2*SorH(10,r,1)*sqrt(3))))/(2.*r), \
	(2,0,1,0) : lambda r,x,y,z,SorH: ((-x**2 - y**2 + 3*(2 + x**2 + y**2)*z**2 - 6*z**4)*SorH(11,r) + 2*r*z**4*SorH(11,r,1) - 2*(x**2 + y**2)*(-1 + 3*z**2)*SorH(10,r)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(11,r,1) + 2*SorH(10,r,1)*sqrt(3)))/(2.*r), \
	(2,0,1,1) : lambda r,x,y,z,SorH: (x*z*((4 + 3*x**2 + 3*y**2 - 6*z**2)*SorH(11,r) + 2*(-2 + 3*z**2)*SorH(10,r)*sqrt(3) - r*((x**2 + y**2 - 2*z**2)*SorH(11,r,1) + 2*z**2*SorH(10,r,1)*sqrt(3))))/(2.*r), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(-4*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*SorH(13,r) + 4*SorH(14,r) + (x**2 + y**2)*(4*SorH(14,r) + r*SorH(12,r,1)) + 2*z**2*(8*SorH(13,r) - 4*SorH(14,r) + r*(SorH(12,r,1) - 2*SorH(13,r,1))) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: (y*((x**2 + y**2)*(-1 + 4*z**2)*SorH(12,r) + 2*(x**2 + y**2 - (3 + 4*x**2 + 4*y**2)*z**2 + 4*z**4)*SorH(13,r) - x**2*SorH(14,r) - y**2*SorH(14,r) + 6*z**2*SorH(14,r) + 4*x**2*z**2*SorH(14,r) + 4*y**2*z**2*SorH(14,r) - 8*z**4*SorH(14,r) - r*x**2*z**2*SorH(12,r,1) - r*y**2*z**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(13,r,1) + 2*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) - r*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (z*(-8*(x**2 + y**2 - 2*z**2)*SorH(14,r) - 4*(3*(x**2 + y**2)*((x**2 + y**2)*SorH(12,r) + 4*z**2*SorH(13,r)) + (x**2 + y**2 - 2*z**2)**2*SorH(14,r)) + 3*(x**2 + y**2)*(8*SorH(13,r) + r*(x**2 + y**2)*SorH(12,r,1) + 4*r*z**2*SorH(13,r,1)) + r*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,1)))/(4.*r), \
	(2,0,2,1) : lambda r,x,y,z,SorH: (x*((x**2 + y**2)*(-1 + 4*z**2)*SorH(12,r) + 2*(x**2 + y**2 - (3 + 4*x**2 + 4*y**2)*z**2 + 4*z**4)*SorH(13,r) - x**2*SorH(14,r) - y**2*SorH(14,r) + 6*z**2*SorH(14,r) + 4*x**2*z**2*SorH(14,r) + 4*y**2*z**2*SorH(14,r) - 8*z**4*SorH(14,r) - r*x**2*z**2*SorH(12,r,1) - r*y**2*z**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(13,r,1) + 2*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) - r*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*z*(-4*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*SorH(13,r) + 4*SorH(14,r) + (x**2 + y**2)*(4*SorH(14,r) + r*SorH(12,r,1)) + 2*z**2*(8*SorH(13,r) - 4*SorH(14,r) + r*(SorH(12,r,1) - 2*SorH(13,r,1))) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(4.*r), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*((1 - 2*z**2)*SorH(9,r) + r*z**2*SorH(9,r,1))*sqrt(3))/r, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*y*((-2 + 6*z**2)*SorH(10,r) + (1 - 3*z**2)*SorH(11,r)*sqrt(3) + r*z**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/r, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*z*(-((2 + 3*x**2 + 3*y**2 - 3*z**2)*SorH(10,r)) + r*(x**2 + y**2 - z**2)*SorH(10,r,1) + (2 - 3*z**2)*SorH(11,r)*sqrt(3) + r*z**2*SorH(11,r,1)*sqrt(3)))/r, \
	(2,1,1,1) : lambda r,x,y,z,SorH: ((-x**2 + y**2 + 3*(1 + x**2 - y**2)*z**2 - 3*z**4)*SorH(10,r) + r*z**2*(-x**2 + y**2 + z**2)*SorH(10,r,1) + x**2*((1 - 3*z**2)*SorH(11,r) + r*z**2*SorH(11,r,1))*sqrt(3))/r, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (y*((-y**2 + (-3 + 4*y**2)*z**2 + 4*z**4)*SorH(12,r) + (-3*x**2 + y**2 + (3 + 12*x**2 - 4*y**2)*z**2 - 4*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - r*y**2*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(4*(x**2 + y**2)*SorH(12,r) - 2*(3 + 2*x**2 + 2*y**2 - 6*z**2)*SorH(13,r) + 6*SorH(14,r) + r*(x**2 + y**2)*(-SorH(12,r,1) + SorH(13,r,1)) - 3*z**2*(4*SorH(14,r) + r*(SorH(13,r,1) - SorH(14,r,1)))))/r, \
	(2,1,2,0) : lambda r,x,y,z,SorH: (x*((x**2 + y**2)*(-1 + 4*z**2)*SorH(12,r) + 2*(x**2 + y**2 - (3 + 4*x**2 + 4*y**2)*z**2 + 4*z**4)*SorH(13,r) - x**2*SorH(14,r) - y**2*SorH(14,r) + 6*z**2*SorH(14,r) + 4*x**2*z**2*SorH(14,r) + 4*y**2*z**2*SorH(14,r) - 8*z**4*SorH(14,r) - r*x**2*z**2*SorH(12,r,1) - r*y**2*z**2*SorH(12,r,1) + 2*r*x**2*z**2*SorH(13,r,1) + 2*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) - r*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(2.*r), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (z*(-2*(x**2 + y**2)*(-1 + 2*y**2 + 2*z**2)*SorH(12,r) + 2*(y**2 + 2*z**2 - 2*(x**4 + x**2*(1 + y**2 - 2*z**2) + z**2*(y**2 + z**2)))*SorH(13,r) + 6*x**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + r*x**4*SorH(13,r,1) + r*x**2*y**2*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) + 3*r*x**2*z**2*SorH(14,r,1)))/r, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*((x**2 + 3*y**2 - 2*(-3 + 2*x**2 + 6*y**2)*z**2 - 8*z**4)*SorH(12,r) + 2*(x**2 - 3*y**2 + (-3 - 4*x**2 + 12*y**2)*z**2 + 4*z**4)*SorH(13,r) - 3*x**2*SorH(14,r) + 3*y**2*SorH(14,r) + 12*x**2*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + r*x**2*z**2*SorH(12,r,1) + 3*r*y**2*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(13,r,1) - 6*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 3*r*(-x**2 + y**2)*z**2*SorH(14,r,1)))/(2.*r), \
	(2,2,0,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*z*(-2*SorH(9,r) + r*SorH(9,r,1))*sqrt(3))/(2.*r), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (y*z*(2*(-2 + 6*x**2 + 3*z**2)*SorH(10,r) - 2*r*(2*x**2 + z**2)*SorH(10,r,1) + 3*(-x**2 + y**2)*SorH(11,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,1)*sqrt(3)))/(2.*r), \
	(2,2,1,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((-2 + 6*z**2)*SorH(10,r) + (1 - 3*z**2)*SorH(11,r)*sqrt(3) + r*z**2*(-2*SorH(10,r,1) + SorH(11,r,1)*sqrt(3))))/(2.*r), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*z*(-2*(-2 + 6*y**2 + 3*z**2)*SorH(10,r) + 2*r*(2*y**2 + z**2)*SorH(10,r,1) + 3*(-x**2 + y**2)*SorH(11,r)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,1)*sqrt(3)))/(2.*r), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*z*(-4*SorH(12,r) + 16*SorH(13,r) - 12*SorH(14,r) + r*(SorH(12,r,1) - 4*SorH(13,r,1) + 3*SorH(14,r,1))))/(2.*r), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (y*((3*x**2 + y**2 - 2*(-3 + 6*x**2 + 2*y**2)*z**2 - 8*z**4)*SorH(12,r) + 2*(-3*x**2 + y**2 + (-3 + 12*x**2 - 4*y**2)*z**2 + 4*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 3*y**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) + 3*r*x**2*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) - 6*r*x**2*z**2*SorH(13,r,1) + 2*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 3*r*(x - y)*(x + y)*z**2*SorH(14,r,1)))/(2.*r), \
	(2,2,2,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*z*(-4*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*SorH(13,r) + 4*SorH(14,r) + (x**2 + y**2)*(4*SorH(14,r) + r*SorH(12,r,1)) + 2*z**2*(8*SorH(13,r) - 4*SorH(14,r) + r*(SorH(12,r,1) - 2*SorH(13,r,1))) - r*(x**2 + y**2 - 2*z**2)*SorH(14,r,1))*sqrt(3))/(4.*r), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*((x**2 + 3*y**2 - 2*(-3 + 2*x**2 + 6*y**2)*z**2 - 8*z**4)*SorH(12,r) + 2*(x**2 - 3*y**2 + (-3 - 4*x**2 + 12*y**2)*z**2 + 4*z**4)*SorH(13,r) - 3*x**2*SorH(14,r) + 3*y**2*SorH(14,r) + 12*x**2*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + r*x**2*z**2*SorH(12,r,1) + 3*r*y**2*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(13,r,1) - 6*r*y**2*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 3*r*(-x**2 + y**2)*z**2*SorH(14,r,1)))/(2.*r), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (z*(-4*(x**4 - 2*x**2*(1 + y**2 - 2*z**2) + (-2 + y**2 + 2*z**2)*(y**2 + 2*z**2))*SorH(12,r) - 8*(y**2*(-1 + 2*z**2) + x**2*(-1 + 8*y**2 + 2*z**2))*SorH(13,r) - 12*x**4*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 12*y**4*SorH(14,r) + r*x**4*SorH(12,r,1) - 2*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 4*r*x**2*z**2*SorH(12,r,1) + 4*r*y**2*z**2*SorH(12,r,1) + 4*r*z**4*SorH(12,r,1) + 16*r*x**2*y**2*SorH(13,r,1) + 4*r*x**2*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) + 3*r*(x**2 - y**2)**2*SorH(14,r,1)))/(4.*r), \
},
]
slako_transformations_hessian = [\
[\
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: -(((-1 + x**2)*SorH(0,r,1))/r) + x**2*SorH(0,r,2), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*y*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**2*y*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*z*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**2*z*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: (3*x*(-1 + x**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**3*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*y*((-6 + 8*x**2)*SorH(3,r) + r*((3 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(3,r) + r*((1 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: -(2*(-1 + 4*x**2)*(-1 + x**2 + y**2 - 2*z**2)*SorH(3,r) + r*((y**2 - 2*z**2 - 5*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(3,r,1) + r*x**2*(x**2 + y**2 - 2*z**2)*SorH(3,r,2)))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*z*((-6 + 8*x**2)*SorH(3,r) + r*((3 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: ((2*(-1 + 4*x**2)*(-1 + x**2 - y**2)*SorH(3,r) + r*(-((5*x**4 + y**2 - 5*x**2*(1 + y**2))*SorH(3,r,1)) + r*x**2*(x - y)*(x + y)*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*y*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**2*y*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (2*(-1 + 4*x**2)*(-1 + x**2 + z**2)*SorH(5,r) + 2*(-1 + 4*x**2)*y**2*SorH(6,r) + r*((z**2 - 5*x**2*(-1 + x**2 + z**2))*SorH(5,r,1) + (1 - 5*x**2)*y**2*SorH(6,r,1) + r*x**2*((x**2 + z**2)*SorH(5,r,2) + y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*y*((6 - 8*x**2)*SorH(5,r) + (-6 + 8*x**2)*SorH(6,r) + r*((-3 + 5*x**2)*SorH(5,r,1) + (3 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*(3*(2 + 5*x**4 + 3*y**2 - 3*z**2 + x**2*(-7 - 5*y**2 + 5*z**2))*SorH(7,r) + 3*(-3 + 5*x**2)*y**2*SorH(8,r)*sqrt(3) + r*((-3*(y - z)*(y + z) - 7*x**2*(-1 + x**2 - y**2 + z**2))*SorH(7,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((3 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (z*((2 + 3*y**2 - 3*z**2 + 15*x**2*(-1 + x**2 - y**2 + z**2))*SorH(7,r) + 3*(-1 + 5*x**2)*y**2*SorH(8,r)*sqrt(3) + r*((-7*x**4 - y**2 + z**2 + x**2*(5 + 7*y**2 - 7*z**2))*SorH(7,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((1 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(y*((2 - 3*y**2 + 6*z**2 + 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r) + 6*(-1 + 5*x**2)*z**2*SorH(7,r)*sqrt(3) + r*((-7*x**4 + y**2 - 2*z**2 + x**2*(5 - 7*y**2 + 14*z**2))*SorH(8,r,1) + 2*(1 - 7*x**2)*z**2*SorH(7,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*x**2)*SorH(7,r) + 3*(-3 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*x**2)*SorH(7,r,1) + (3 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(y*((8 - 6*z**2 + 30*x**2*(-2 + 2*x**2 + z**2))*SorH(7,r) + (-2 - 3*y**2 + 15*x**2*(1 - x**2 + y**2))*SorH(8,r)*sqrt(3) + r*(2*(-14*x**4 + z**2 + x**2*(10 - 7*z**2))*SorH(7,r,1) + (y**2 + x**2*(-5 + 7*x**2 - 7*y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*(2*(2*x**2 + z**2)*SorH(7,r,2) + (-x**2 + y**2)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*z*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**2*z*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (2*(-1 + 4*x**2)*(-1 + x**2 + y**2)*SorH(5,r) + 2*(-1 + 4*x**2)*z**2*SorH(6,r) + r*((y**2 - 5*x**2*(-1 + x**2 + y**2))*SorH(5,r,1) + (1 - 5*x**2)*z**2*SorH(6,r,1) + r*x**2*((x**2 + y**2)*SorH(5,r,2) + z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*z*((6 - 8*x**2)*SorH(5,r) + (-6 + 8*x**2)*SorH(6,r) + r*((-3 + 5*x**2)*SorH(5,r,1) + (3 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*x**2)*SorH(7,r) + 3*(-3 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*x**2)*SorH(7,r,1) + (3 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (y*((2 - 3*y**2 + 3*z**2 + 15*x**2*(-1 + x**2 + y**2 - z**2))*SorH(7,r) + 3*(-1 + 5*x**2)*z**2*SorH(8,r)*sqrt(3) + r*((-7*x**4 + (y - z)*(y + z) + x**2*(5 - 7*y**2 + 7*z**2))*SorH(7,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((1 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (z*((-2 + 3*y**2 - 6*z**2 - 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r) + 2*(2 - 3*y**2 + 15*x**2*(-1 + x**2 + y**2))*SorH(7,r)*sqrt(3) + r*((7*x**4 - y**2 + 2*z**2 + x**2*(-5 + 7*y**2 - 14*z**2))*SorH(8,r,1) + 2*(-7*x**4 + y**2 + x**2*(5 - 7*y**2))*SorH(7,r,1)*sqrt(3) + r*x**2*(-((x**2 + y**2 - 2*z**2)*SorH(8,r,2)) + 2*(x**2 + y**2)*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*(3*(2 + 5*x**4 - 3*y**2 + 3*z**2 + x**2*(-7 + 5*y**2 - 5*z**2))*SorH(7,r) + 3*(-3 + 5*x**2)*z**2*SorH(8,r)*sqrt(3) + r*((3*(y - z)*(y + z) - 7*x**2*(-1 + x**2 + y**2 - z**2))*SorH(7,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((3 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (z*((-4 - 6*y**2 + 30*x**2*(1 - x**2 + y**2))*SorH(7,r) + (2 + 15*x**4 + 3*y**2 - 15*x**2*(1 + y**2))*SorH(8,r)*sqrt(3) + r*(2*(7*x**4 + y**2 - x**2*(5 + 7*y**2))*SorH(7,r,1) - (y**2 + x**2*(-5 + 7*x**2 - 7*y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*(x - y)*(x + y)*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: (3*x*(-1 + x**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**3*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*y*((6 - 8*x**2)*SorH(5,r) + (-6 + 8*x**2)*SorH(6,r) + r*((-3 + 5*x**2)*SorH(5,r,1) + (3 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*z*((6 - 8*x**2)*SorH(5,r) + (-6 + 8*x**2)*SorH(6,r) + r*((-3 + 5*x**2)*SorH(5,r,1) + (3 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (2*(-1 + 4*x**2)*(y**2 + z**2)*SorH(5,r) + 2*(1 - 5*x**2 + 4*x**4)*SorH(6,r) + r*(-((-1 + 5*x**2)*(y**2 + z**2)*SorH(5,r,1)) + x**2*(r*(y**2 + z**2)*SorH(5,r,2) - 5*(-1 + x**2)*SorH(6,r,1) + r*x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (y*((-2 - 3*y**2 - 3*z**2 + 15*x**2*(1 - x**2 + y**2 + z**2))*SorH(7,r) + r*(7*x**4 + y**2 + z**2 - x**2*(5 + 7*y**2 + 7*z**2))*SorH(7,r,1) + (2 - 15*x**2 + 15*x**4)*SorH(8,r)*sqrt(3) + r*x**2*(r*(-x**2 + y**2 + z**2)*SorH(7,r,2) + (5 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*x**2)*SorH(7,r) + 3*(-3 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*x**2)*SorH(7,r,1) + (3 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: (x*(-3*(2 + 5*x**4 - 3*y**2 + 6*z**2 + x**2*(-7 + 5*y**2 - 10*z**2))*SorH(8,r) + 6*(3 - 5*x**2)*z**2*SorH(7,r)*sqrt(3) + r*((-3*y**2 + 6*z**2 + 7*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r,1) + 2*(-3 + 7*x**2)*z**2*SorH(7,r,1)*sqrt(3) - r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (z*((-2 - 3*y**2 - 3*z**2 + 15*x**2*(1 - x**2 + y**2 + z**2))*SorH(7,r) + r*(7*x**4 + y**2 + z**2 - x**2*(5 + 7*y**2 + 7*z**2))*SorH(7,r,1) + (2 - 15*x**2 + 15*x**4)*SorH(8,r)*sqrt(3) + r*x**2*(r*(-x**2 + y**2 + z**2)*SorH(7,r,2) + (5 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*(6*(-3 + 5*x**2)*(2*y**2 + z**2)*SorH(7,r) + 3*(2 + 5*x**4 + 3*y**2 - x**2*(7 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(-2*(-3 + 7*x**2)*(2*y**2 + z**2)*SorH(7,r,1) + (-3*y**2 + 7*x**2*(1 - x**2 + y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*y*((-6 + 8*x**2)*SorH(9,r) + r*((3 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*(3*(2 + 5*x**4 + 3*y**2 - 3*z**2 + x**2*(-7 - 5*y**2 + 5*z**2))*SorH(10,r) + 3*(-3 + 5*x**2)*y**2*SorH(11,r)*sqrt(3) + r*((-3*(y - z)*(y + z) - 7*x**2*(-1 + x**2 - y**2 + z**2))*SorH(10,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((3 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*x**2)*SorH(10,r) + 3*(-3 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*x**2)*SorH(10,r,1) + (3 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (y*((-2 - 3*y**2 - 3*z**2 + 15*x**2*(1 - x**2 + y**2 + z**2))*SorH(10,r) + r*(7*x**4 + y**2 + z**2 - x**2*(5 + 7*y**2 + 7*z**2))*SorH(10,r,1) + (2 - 15*x**2 + 15*x**4)*SorH(11,r)*sqrt(3) + r*x**2*(r*(-x**2 + y**2 + z**2)*SorH(10,r,2) + (5 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (2*(y**2 + z**2)*(1 - 2*z**2 + 2*x**2*(-5 + 6*x**2 + 6*z**2))*SorH(12,r) + 2*(2*(-1 + x**2 - y**2)*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2)) + (1 - 2*y**2 + 2*x**2*(-5 + 6*x**2 + 6*y**2))*z**2)*SorH(13,r) + 6*y**2*SorH(14,r) - 60*x**2*y**2*SorH(14,r) + 72*x**4*y**2*SorH(14,r) + 5*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + 5*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r*z**4*SorH(12,r,1) - 9*r*x**2*z**4*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*x**2*z**4*SorH(12,r,2) + 9*r*x**4*SorH(13,r,1) - 9*r*x**6*SorH(13,r,1) - 10*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) + 5*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) - 9*r*x**2*y**2*z**2*SorH(13,r,1) + r**2*x**6*SorH(13,r,2) - 2*r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) + r**2*x**4*z**2*SorH(13,r,2) + r**2*x**2*y**2*z**2*SorH(13,r,2) + 15*r*x**2*y**2*SorH(14,r,1) - 27*r*x**4*y**2*SorH(14,r,1) + 3*r**2*x**4*y**2*SorH(14,r,2))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*z*(-2*(3 - 6*z**2 + 2*x**2*(-7 + 6*x**2 + 6*z**2))*SorH(12,r) + 2*(3 + 18*y**2 - 6*z**2 + 2*x**2*(-7 + 6*x**2 - 18*y**2 + 6*z**2))*SorH(13,r) - 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 7*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*z**2*SorH(12,r,2) + 7*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 9*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) + 3*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*y*(2*(3 - 6*y**2 - 12*z**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2 + 12*z**2))*SorH(12,r) + 48*(1 - 2*x**2)*z**2*SorH(13,r) - 6*SorH(14,r) + 28*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 12*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) - 7*r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) - r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: -((y*z*(4*(-1 + 6*x**2)*(y**2 + z**2)*SorH(12,r) + (6 + 72*x**4 + 4*y**2 + 4*z**2 - 12*x**2*(5 + 2*y**2 + 2*z**2))*SorH(13,r) - 6*SorH(14,r) + 60*x**2*SorH(14,r) - 72*x**4*SorH(14,r) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + 15*r*x**2*SorH(13,r,1) - 27*r*x**4*SorH(13,r,1) - r*y**2*SorH(13,r,1) + 9*r*x**2*y**2*SorH(13,r,1) - r*z**2*SorH(13,r,1) + 9*r*x**2*z**2*SorH(13,r,1) + 3*r**2*x**4*SorH(13,r,2) - r**2*x**2*y**2*SorH(13,r,2) - r**2*x**2*z**2*SorH(13,r,2) - 15*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) - 3*r**2*x**4*SorH(14,r,2)))/r**2), \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*y*(2*(3 + 12*x**4 + 6*y**2 - 2*x**2*(7 + 6*y**2))*SorH(12,r) - 8*(3 + 6*y**2 + 2*x**2*(-7 + 6*x**2 - 6*y**2))*SorH(13,r) + 18*SorH(14,r) - 84*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 36*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 28*r*x**2*SorH(13,r,1) + 36*r*x**4*SorH(13,r,1) + 12*r*y**2*SorH(13,r,1) - 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**4*SorH(13,r,2) + 4*r**2*x**2*y**2*SorH(13,r,2) + 21*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(9,r) + r*((1 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (z*((2 + 3*y**2 - 3*z**2 + 15*x**2*(-1 + x**2 - y**2 + z**2))*SorH(10,r) + 3*(-1 + 5*x**2)*y**2*SorH(11,r)*sqrt(3) + r*((-7*x**4 - y**2 + z**2 + x**2*(5 + 7*y**2 - 7*z**2))*SorH(10,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((1 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (y*((2 - 3*y**2 + 3*z**2 + 15*x**2*(-1 + x**2 + y**2 - z**2))*SorH(10,r) + 3*(-1 + 5*x**2)*z**2*SorH(11,r)*sqrt(3) + r*((-7*x**4 + (y - z)*(y + z) + x**2*(5 - 7*y**2 + 7*z**2))*SorH(10,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((1 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*x**2)*SorH(10,r) + 3*(-3 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*x**2)*SorH(10,r,1) + (3 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*z*(-2*(3 - 6*z**2 + 2*x**2*(-7 + 6*x**2 + 6*z**2))*SorH(12,r) + 2*(3 + 18*y**2 - 6*z**2 + 2*x**2*(-7 + 6*x**2 - 18*y**2 + 6*z**2))*SorH(13,r) - 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 7*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*z**2*SorH(12,r,2) + 7*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 9*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) + 3*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (2*(12*x**6 + y**2 + z**2 - 2*y**2*z**2 + 6*x**4*(-3 + 2*y**2 + 2*z**2) + 2*x**2*(3 - 5*y**2 + (-5 + 6*y**2)*z**2))*SorH(12,r) + 2*(y**2*(1 - 2*y**2 + 2*x**2*(-5 + 6*x**2 + 6*y**2)) + (1 + 4*y**2 + 2*x**2*(-5 + 6*x**2 - 12*y**2))*z**2 + 2*(-1 + 6*x**2)*z**4)*SorH(13,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) + 9*r*x**4*SorH(12,r,1) - 9*r*x**6*SorH(12,r,1) + 5*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + 5*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**6*SorH(12,r,2) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + 5*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) + 5*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) + r**2*x**4*z**2*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(y*z*((2 - 4*y**2 + 4*x**2*(-5 + 6*x**2 + 6*y**2))*SorH(12,r) + (-4 + 8*y**2 - 8*z**2 + 8*x**2*(5 - 6*x**2 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 20*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 4*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 8*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 5*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 10*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 5*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*y*(-2*(3 - 6*y**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2))*SorH(12,r) + 2*(3 - 6*y**2 + 18*z**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2 - 18*z**2))*SorH(13,r) - 36*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 7*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) + 7*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 3*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*x**2*z**2*SorH(13,r,2) + 9*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (y*z*((6 - 4*y**2 - 8*z**2 + 12*x**2*(-5 + 6*x**2 + 2*y**2 + 4*z**2))*SorH(12,r) - 4*(3 + 2*y**2 - 2*z**2 + 6*x**2*(-5 + 6*x**2 - 2*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 60*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 15*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 30*r*x**2*SorH(13,r,1) + 54*r*x**4*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 18*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 6*r**2*x**4*SorH(13,r,2) + 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + 15*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: -(2*(-1 + 4*x**2)*(-1 + x**2 + y**2 - 2*z**2)*SorH(9,r) + r*((y**2 - 2*z**2 - 5*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(9,r,1) + r*x**2*(x**2 + y**2 - 2*z**2)*SorH(9,r,2)))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(y*((2 - 3*y**2 + 6*z**2 + 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(11,r) + 6*(-1 + 5*x**2)*z**2*SorH(10,r)*sqrt(3) + r*((-7*x**4 + y**2 - 2*z**2 + x**2*(5 - 7*y**2 + 14*z**2))*SorH(11,r,1) + 2*(1 - 7*x**2)*z**2*SorH(10,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (z*((-2 + 3*y**2 - 6*z**2 - 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(11,r) + 2*(2 - 3*y**2 + 15*x**2*(-1 + x**2 + y**2))*SorH(10,r)*sqrt(3) + r*((7*x**4 - y**2 + 2*z**2 + x**2*(-5 + 7*y**2 - 14*z**2))*SorH(11,r,1) + 2*(-7*x**4 + y**2 + x**2*(5 - 7*y**2))*SorH(10,r,1)*sqrt(3) + r*x**2*(-((x**2 + y**2 - 2*z**2)*SorH(11,r,2)) + 2*(x**2 + y**2)*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: (x*(-3*(2 + 5*x**4 - 3*y**2 + 6*z**2 + x**2*(-7 + 5*y**2 - 10*z**2))*SorH(11,r) + 6*(3 - 5*x**2)*z**2*SorH(10,r)*sqrt(3) + r*((-3*y**2 + 6*z**2 + 7*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(11,r,1) + 2*(-3 + 7*x**2)*z**2*SorH(10,r,1)*sqrt(3) - r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*y*(2*(3 - 6*y**2 - 12*z**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2 + 12*z**2))*SorH(12,r) + 48*(1 - 2*x**2)*z**2*SorH(13,r) - 6*SorH(14,r) + 28*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 12*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) - 7*r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) - r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(y*z*((2 - 4*y**2 + 4*x**2*(-5 + 6*x**2 + 6*y**2))*SorH(12,r) + (-4 + 8*y**2 - 8*z**2 + 8*x**2*(5 - 6*x**2 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 20*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 4*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 8*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 5*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 10*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 5*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (12*(-1 + x**2 + y**2)*(6*x**4 - y**2 + x**2*(-3 + 6*y**2))*SorH(12,r) + 24*(1 - 2*y**2 + 2*x**2*(-5 + 6*x**2 + 6*y**2))*z**2*SorH(13,r) + 12*x**2*SorH(14,r) - 36*x**4*SorH(14,r) + 24*x**6*SorH(14,r) + 4*y**2*SorH(14,r) - 40*x**2*y**2*SorH(14,r) + 48*x**4*y**2*SorH(14,r) - 4*y**4*SorH(14,r) + 24*x**2*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 80*x**2*z**2*SorH(14,r) - 96*x**4*z**2*SorH(14,r) + 16*y**2*z**2*SorH(14,r) - 96*x**2*y**2*z**2*SorH(14,r) - 16*z**4*SorH(14,r) + 96*x**2*z**4*SorH(14,r) + 27*r*x**4*SorH(12,r,1) - 27*r*x**6*SorH(12,r,1) + 30*r*x**2*y**2*SorH(12,r,1) - 54*r*x**4*y**2*SorH(12,r,1) + 3*r*y**4*SorH(12,r,1) - 27*r*x**2*y**4*SorH(12,r,1) + 3*r**2*x**6*SorH(12,r,2) + 6*r**2*x**4*y**2*SorH(12,r,2) + 3*r**2*x**2*y**4*SorH(12,r,2) + 60*r*x**2*z**2*SorH(13,r,1) - 108*r*x**4*z**2*SorH(13,r,1) + 12*r*y**2*z**2*SorH(13,r,1) - 108*r*x**2*y**2*z**2*SorH(13,r,1) + 12*r**2*x**4*z**2*SorH(13,r,2) + 12*r**2*x**2*y**2*z**2*SorH(13,r,2) + 9*r*x**4*SorH(14,r,1) - 9*r*x**6*SorH(14,r,1) + 10*r*x**2*y**2*SorH(14,r,1) - 18*r*x**4*y**2*SorH(14,r,1) + r*y**4*SorH(14,r,1) - 9*r*x**2*y**4*SorH(14,r,1) - 20*r*x**2*z**2*SorH(14,r,1) + 36*r*x**4*z**2*SorH(14,r,1) - 4*r*y**2*z**2*SorH(14,r,1) + 36*r*x**2*y**2*z**2*SorH(14,r,1) + 4*r*z**4*SorH(14,r,1) - 36*r*x**2*z**4*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(x*z*(2*(3 - 6*y**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2))*SorH(12,r) - 4*(3 - 6*y**2 + 6*z**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 28*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 14*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 7*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 6*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: ((4*(y**4 + 3*x**2*(1 - 3*x**2 + 2*x**4 - 2*y**4) + z**2 + 2*(6*x**4 + y**2 - x**2*(5 + 6*y**2))*z**2)*SorH(12,r) - 8*(1 + 2*y**2 + 2*x**2*(-5 + 6*x**2 - 6*y**2))*z**2*SorH(13,r) - 12*x**2*SorH(14,r) + 36*x**4*SorH(14,r) - 24*x**6*SorH(14,r) - 4*y**4*SorH(14,r) + 24*x**2*y**4*SorH(14,r) + 4*z**2*SorH(14,r) - 40*x**2*z**2*SorH(14,r) + 48*x**4*z**2*SorH(14,r) + 8*y**2*z**2*SorH(14,r) - 48*x**2*y**2*z**2*SorH(14,r) + 9*r*x**4*SorH(12,r,1) - 9*r*x**6*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 9*r*x**2*y**4*SorH(12,r,1) + 10*r*x**2*z**2*SorH(12,r,1) - 18*r*x**4*z**2*SorH(12,r,1) - 2*r*y**2*z**2*SorH(12,r,1) + 18*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**6*SorH(12,r,2) - r**2*x**2*y**4*SorH(12,r,2) + 2*r**2*x**4*z**2*SorH(12,r,2) - 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 20*r*x**2*z**2*SorH(13,r,1) + 36*r*x**4*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - 36*r*x**2*y**2*z**2*SorH(13,r,1) - 4*r**2*x**4*z**2*SorH(13,r,2) + 4*r**2*x**2*y**2*z**2*SorH(13,r,2) - 9*r*x**4*SorH(14,r,1) + 9*r*x**6*SorH(14,r,1) + r*y**4*SorH(14,r,1) - 9*r*x**2*y**4*SorH(14,r,1) + 10*r*x**2*z**2*SorH(14,r,1) - 18*r*x**4*z**2*SorH(14,r,1) - 2*r*y**2*z**2*SorH(14,r,1) + 18*r*x**2*y**2*z**2*SorH(14,r,1) - r**2*x**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*z*((-6 + 8*x**2)*SorH(9,r) + r*((3 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*x**2)*SorH(10,r) + 3*(-3 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*x**2)*SorH(10,r,1) + (3 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*(3*(2 + 5*x**4 - 3*y**2 + 3*z**2 + x**2*(-7 + 5*y**2 - 5*z**2))*SorH(10,r) + 3*(-3 + 5*x**2)*z**2*SorH(11,r)*sqrt(3) + r*((3*(y - z)*(y + z) - 7*x**2*(-1 + x**2 + y**2 - z**2))*SorH(10,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((3 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (z*((-2 - 3*y**2 - 3*z**2 + 15*x**2*(1 - x**2 + y**2 + z**2))*SorH(10,r) + r*(7*x**4 + y**2 + z**2 - x**2*(5 + 7*y**2 + 7*z**2))*SorH(10,r,1) + (2 - 15*x**2 + 15*x**4)*SorH(11,r)*sqrt(3) + r*x**2*(r*(-x**2 + y**2 + z**2)*SorH(10,r,2) + (5 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: -((y*z*(4*(-1 + 6*x**2)*(y**2 + z**2)*SorH(12,r) + (6 + 72*x**4 + 4*y**2 + 4*z**2 - 12*x**2*(5 + 2*y**2 + 2*z**2))*SorH(13,r) - 6*SorH(14,r) + 60*x**2*SorH(14,r) - 72*x**4*SorH(14,r) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + 15*r*x**2*SorH(13,r,1) - 27*r*x**4*SorH(13,r,1) - r*y**2*SorH(13,r,1) + 9*r*x**2*y**2*SorH(13,r,1) - r*z**2*SorH(13,r,1) + 9*r*x**2*z**2*SorH(13,r,1) + 3*r**2*x**4*SorH(13,r,2) - r**2*x**2*y**2*SorH(13,r,2) - r**2*x**2*z**2*SorH(13,r,2) - 15*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) - 3*r**2*x**4*SorH(14,r,2)))/r**2), \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*y*(-2*(3 - 6*y**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2))*SorH(12,r) + 2*(3 - 6*y**2 + 18*z**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2 - 18*z**2))*SorH(13,r) - 36*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 7*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) + 7*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 3*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*x**2*z**2*SorH(13,r,2) + 9*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(x*z*(2*(3 - 6*y**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2))*SorH(12,r) - 4*(3 - 6*y**2 + 6*z**2 + 2*x**2*(-7 + 6*x**2 + 6*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 28*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 14*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 7*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 6*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (2*(1 - 2*y**2 + 2*x**2*(-5 + 6*x**2 + 6*y**2))*(y**2 + z**2)*SorH(12,r) + 2*(12*x**6 + y**2 - 2*(1 + y**2)*z**2 - 2*z**4 + 6*x**4*(-3 + 2*y**2 - 4*z**2) + 2*x**2*(3 - 5*y**2 + 2*(5 + 3*y**2)*z**2 + 6*z**4))*SorH(13,r) + 6*z**2*SorH(14,r) - 60*x**2*z**2*SorH(14,r) + 72*x**4*z**2*SorH(14,r) + 5*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + 5*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + 9*r*x**4*SorH(13,r,1) - 9*r*x**6*SorH(13,r,1) + 5*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) - 10*r*x**2*z**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) + r*y**2*z**2*SorH(13,r,1) - 9*r*x**2*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + r**2*x**6*SorH(13,r,2) + r**2*x**4*y**2*SorH(13,r,2) - 2*r**2*x**4*z**2*SorH(13,r,2) + r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + 15*r*x**2*z**2*SorH(14,r,1) - 27*r*x**4*z**2*SorH(14,r,1) + 3*r**2*x**4*z**2*SorH(14,r,2))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*z*((-6*(-1 + 6*y**2 + 4*z**2) + 4*x**2*(-7 + 6*x**2 + 18*y**2 + 12*z**2))*SorH(12,r) + 4*(3 + 12*x**4 + 18*y**2 + 6*z**2 - 2*x**2*(7 + 18*y**2 + 6*z**2))*SorH(13,r) - 18*SorH(14,r) + 84*x**2*SorH(14,r) - 72*x**4*SorH(14,r) - 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + 3*r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) + 14*r*x**2*SorH(13,r,1) - 18*r*x**4*SorH(13,r,1) - 18*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 6*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 2*r**2*x**4*SorH(13,r,2) - 6*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) - 21*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: ((2*(-1 + 4*x**2)*(-1 + x**2 - y**2)*SorH(9,r) + r*(-((5*x**4 + y**2 - 5*x**2*(1 + y**2))*SorH(9,r,1)) + r*x**2*(x - y)*(x + y)*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: -(y*((8 - 6*z**2 + 30*x**2*(-2 + 2*x**2 + z**2))*SorH(10,r) + (-2 - 3*y**2 + 15*x**2*(1 - x**2 + y**2))*SorH(11,r)*sqrt(3) + r*(2*(-14*x**4 + z**2 + x**2*(10 - 7*z**2))*SorH(10,r,1) + (y**2 + x**2*(-5 + 7*x**2 - 7*y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*(2*(2*x**2 + z**2)*SorH(10,r,2) + (-x**2 + y**2)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (z*((-4 - 6*y**2 + 30*x**2*(1 - x**2 + y**2))*SorH(10,r) + (2 + 15*x**4 + 3*y**2 - 15*x**2*(1 + y**2))*SorH(11,r)*sqrt(3) + r*(2*(7*x**4 + y**2 - x**2*(5 + 7*y**2))*SorH(10,r,1) - (y**2 + x**2*(-5 + 7*x**2 - 7*y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*(x - y)*(x + y)*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*(6*(-3 + 5*x**2)*(2*y**2 + z**2)*SorH(10,r) + 3*(2 + 5*x**4 + 3*y**2 - x**2*(7 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(-2*(-3 + 7*x**2)*(2*y**2 + z**2)*SorH(10,r,1) + (-3*y**2 + 7*x**2*(1 - x**2 + y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*y*(2*(3 + 12*x**4 + 6*y**2 - 2*x**2*(7 + 6*y**2))*SorH(12,r) - 8*(3 + 6*y**2 + 2*x**2*(-7 + 6*x**2 - 6*y**2))*SorH(13,r) + 18*SorH(14,r) - 84*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 36*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 28*r*x**2*SorH(13,r,1) + 36*r*x**4*SorH(13,r,1) + 12*r*y**2*SorH(13,r,1) - 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**4*SorH(13,r,2) + 4*r**2*x**2*y**2*SorH(13,r,2) + 21*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (y*z*((6 - 4*y**2 - 8*z**2 + 12*x**2*(-5 + 6*x**2 + 2*y**2 + 4*z**2))*SorH(12,r) - 4*(3 + 2*y**2 - 2*z**2 + 6*x**2*(-5 + 6*x**2 - 2*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 60*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 15*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 30*r*x**2*SorH(13,r,1) + 54*r*x**4*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 18*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 6*r**2*x**4*SorH(13,r,2) + 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + 15*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: ((4*(y**4 + 3*x**2*(1 - 3*x**2 + 2*x**4 - 2*y**4) + z**2 + 2*(6*x**4 + y**2 - x**2*(5 + 6*y**2))*z**2)*SorH(12,r) - 8*(1 + 2*y**2 + 2*x**2*(-5 + 6*x**2 - 6*y**2))*z**2*SorH(13,r) - 12*x**2*SorH(14,r) + 36*x**4*SorH(14,r) - 24*x**6*SorH(14,r) - 4*y**4*SorH(14,r) + 24*x**2*y**4*SorH(14,r) + 4*z**2*SorH(14,r) - 40*x**2*z**2*SorH(14,r) + 48*x**4*z**2*SorH(14,r) + 8*y**2*z**2*SorH(14,r) - 48*x**2*y**2*z**2*SorH(14,r) + 9*r*x**4*SorH(12,r,1) - 9*r*x**6*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 9*r*x**2*y**4*SorH(12,r,1) + 10*r*x**2*z**2*SorH(12,r,1) - 18*r*x**4*z**2*SorH(12,r,1) - 2*r*y**2*z**2*SorH(12,r,1) + 18*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**6*SorH(12,r,2) - r**2*x**2*y**4*SorH(12,r,2) + 2*r**2*x**4*z**2*SorH(12,r,2) - 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 20*r*x**2*z**2*SorH(13,r,1) + 36*r*x**4*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - 36*r*x**2*y**2*z**2*SorH(13,r,1) - 4*r**2*x**4*z**2*SorH(13,r,2) + 4*r**2*x**2*y**2*z**2*SorH(13,r,2) - 9*r*x**4*SorH(14,r,1) + 9*r*x**6*SorH(14,r,1) + r*y**4*SorH(14,r,1) - 9*r*x**2*y**4*SorH(14,r,1) + 10*r*x**2*z**2*SorH(14,r,1) - 18*r*x**4*z**2*SorH(14,r,1) - 2*r*y**2*z**2*SorH(14,r,1) + 18*r*x**2*y**2*z**2*SorH(14,r,1) - r**2*x**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*z*((-6*(-1 + 6*y**2 + 4*z**2) + 4*x**2*(-7 + 6*x**2 + 18*y**2 + 12*z**2))*SorH(12,r) + 4*(3 + 12*x**4 + 18*y**2 + 6*z**2 - 2*x**2*(7 + 18*y**2 + 6*z**2))*SorH(13,r) - 18*SorH(14,r) + 84*x**2*SorH(14,r) - 72*x**4*SorH(14,r) - 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + 3*r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) + 14*r*x**2*SorH(13,r,1) - 18*r*x**4*SorH(13,r,1) - 18*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 6*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 2*r**2*x**4*SorH(13,r,2) - 6*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) - 21*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (4*(6*x**6 - y**2 + 2*z**2 - 3*x**4*(3 + 4*y**2 - 8*z**2) - (y**2 + 2*z**2)**2 + x**2*(3 + 10*y**2 + 6*y**4 + 4*(-5 + 6*y**2)*z**2 + 24*z**4))*SorH(12,r) + 8*(4*(1 - 10*x**2 + 12*x**4)*y**2 + (1 - 2*y**2 + 2*x**2*(-5 + 6*x**2 + 6*y**2))*z**2)*SorH(13,r) + 36*x**2*SorH(14,r) - 108*x**4*SorH(14,r) + 72*x**6*SorH(14,r) - 12*y**2*SorH(14,r) + 120*x**2*y**2*SorH(14,r) - 144*x**4*y**2*SorH(14,r) - 12*y**4*SorH(14,r) + 72*x**2*y**4*SorH(14,r) + 9*r*x**4*SorH(12,r,1) - 9*r*x**6*SorH(12,r,1) - 10*r*x**2*y**2*SorH(12,r,1) + 18*r*x**4*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + 20*r*x**2*z**2*SorH(12,r,1) - 36*r*x**4*z**2*SorH(12,r,1) + 4*r*y**2*z**2*SorH(12,r,1) - 36*r*x**2*y**2*z**2*SorH(12,r,1) + 4*r*z**4*SorH(12,r,1) - 36*r*x**2*z**4*SorH(12,r,1) + r**2*x**6*SorH(12,r,2) - 2*r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + 4*r**2*x**4*z**2*SorH(12,r,2) + 4*r**2*x**2*y**2*z**2*SorH(12,r,2) + 4*r**2*x**2*z**4*SorH(12,r,2) + 80*r*x**2*y**2*SorH(13,r,1) - 144*r*x**4*y**2*SorH(13,r,1) + 20*r*x**2*z**2*SorH(13,r,1) - 36*r*x**4*z**2*SorH(13,r,1) + 4*r*y**2*z**2*SorH(13,r,1) - 36*r*x**2*y**2*z**2*SorH(13,r,1) + 16*r**2*x**4*y**2*SorH(13,r,2) + 4*r**2*x**4*z**2*SorH(13,r,2) + 4*r**2*x**2*y**2*z**2*SorH(13,r,2) + 27*r*x**4*SorH(14,r,1) - 27*r*x**6*SorH(14,r,1) - 30*r*x**2*y**2*SorH(14,r,1) + 54*r*x**4*y**2*SorH(14,r,1) + 3*r*y**4*SorH(14,r,1) - 27*r*x**2*y**4*SorH(14,r,1) + 3*r**2*x**2*(x**2 - y**2)**2*SorH(14,r,2))/(4.*r**2), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: x*y*(-(SorH(0,r,1)/r) + SorH(0,r,2)), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: (x*(-1 + 3*y**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x*y**2*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(2,r) + r*(-3*SorH(2,r,1) + r*SorH(2,r,2))))/r**2, \
	(0,0,1,1) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*y*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**2*y*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (((1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(3,r) + r*((x**2 + y**2 - 5*x**2*y**2)*SorH(3,r,1) + r*x**2*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(3,r) + r*((1 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (x*y*(-8*(-1 + x**2 + y**2 - 2*z**2)*SorH(3,r) - 4*r*SorH(3,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(3,r,1) - r*SorH(3,r,2))))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(3,r) + r*((1 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*SorH(3,r) + r*(-5*SorH(3,r,1) + r*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*y**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x*y**2*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (x*y*((-4 + 8*x**2 + 8*z**2)*SorH(5,r) + (-4 + 8*y**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*z**2)*SorH(5,r,1) + r*(x**2 + z**2)*SorH(5,r,2) + (2 - 5*y**2)*SorH(6,r,1) + r*y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: ((-1 + 2*y**2 + x**2*(2 - 8*y**2))*SorH(5,r) + (1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(6,r) + r*((-y**2 + x**2*(-1 + 5*y**2))*SorH(5,r,1) + (x**2 + y**2 - 5*x**2*y**2)*SorH(6,r,1) + r*x**2*y**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (y*((-2 + 3*y**2 - 3*z**2 + 3*x**2*(-1 + 5*x**2 - 5*y**2 + 5*z**2))*SorH(7,r) + (2 - 3*y**2 + 3*x**2*(-2 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 - y**2 + z**2)*SorH(7,r,1)) + (y**2 + x**2*(2 - 7*y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*((x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(7,r,1) + r*(x**2 - y**2 + z**2)*SorH(7,r,2) + (2 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(x*((2 + 3*x**2*(-1 + 5*y**2) + 6*z**2 + 15*y**2*(-1 + y**2 - 2*z**2))*SorH(8,r) + 6*(-1 + 5*y**2)*z**2*SorH(7,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - 2*z**2 + y**2*(5 - 7*y**2 + 14*z**2))*SorH(8,r,1) + 2*(1 - 7*y**2)*z**2*SorH(7,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(7,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(x*(2*(4 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-4 + 5*z**2))*SorH(7,r) + (-2 + 3*x**2 - 3*(1 + 5*x**2)*y**2 + 15*y**4)*SorH(8,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(4 - 7*z**2))*SorH(7,r,1) + (x - y)*(x + y)*(-1 + 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(7,r,2) + (-x**2 + y**2)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(4,r) + r*(-3*SorH(4,r,1) + r*SorH(4,r,2))))/r**2, \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (x*y*(8*(-1 + x**2 + y**2)*SorH(5,r) + 8*z**2*SorH(6,r) + r*((4 - 5*x**2 - 5*y**2)*SorH(5,r,1) + r*(x**2 + y**2)*SorH(5,r,2) + z**2*(-5*SorH(6,r,1) + r*SorH(6,r,2)))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(7,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (x*((2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 15*y**2*(1 + z**2))*SorH(7,r) + 3*(-1 + 5*y**2)*z**2*SorH(8,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - z**2 + y**2*(5 - 7*y**2 + 7*z**2))*SorH(7,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((1 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (x*y*z*(3*(4 - 5*x**2 - 5*y**2 + 10*z**2)*SorH(8,r) + 6*(-4 + 5*x**2 + 5*y**2)*SorH(7,r)*sqrt(3) + r*((-4 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(8,r,1) - 2*(-4 + 7*x**2 + 7*y**2)*SorH(7,r,1)*sqrt(3) + r*(-((x**2 + y**2 - 2*z**2)*SorH(8,r,2)) + 2*(x**2 + y**2)*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (y*((2 - 3*y**2 + 3*z**2 + 15*x**2*(-1 + x**2 + y**2 - z**2))*SorH(7,r) + 3*(-1 + 5*x**2)*z**2*SorH(8,r)*sqrt(3) + r*((-7*x**4 + (y - z)*(y + z) + x**2*(5 - 7*y**2 + 7*z**2))*SorH(7,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((1 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*z*(-30*SorH(7,r) + 15*SorH(8,r)*sqrt(3) + r*(14*SorH(7,r,1) - 2*r*SorH(7,r,2) - 7*SorH(8,r,1)*sqrt(3) + r*SorH(8,r,2)*sqrt(3))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*y*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**2*y*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: ((-1 + 2*y**2 + x**2*(2 - 8*y**2))*SorH(5,r) + (1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(6,r) + r*((-y**2 + x**2*(-1 + 5*y**2))*SorH(5,r,1) + (x**2 + y**2 - 5*x**2*y**2)*SorH(6,r,1) + r*x**2*y**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (x*y*((-4 + 8*y**2 + 8*z**2)*SorH(5,r) + (-4 + 8*x**2)*SorH(6,r) + r*((2 - 5*y**2 - 5*z**2)*SorH(5,r,1) + r*(y**2 + z**2)*SorH(5,r,2) + (2 - 5*x**2)*SorH(6,r,1) + r*x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (x*((-2 + x**2*(3 - 15*y**2) - 3*z**2 + 3*y**2*(-1 + 5*y**2 + 5*z**2))*SorH(7,r) + (2 - 6*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(-x**2 + y**2 + z**2)*SorH(7,r,1)) + (x**2 + 2*y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*((-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(7,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(y*((2 - 3*y**2 + 6*z**2 + 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r) + 6*(-1 + 5*x**2)*z**2*SorH(7,r)*sqrt(3) + r*((-7*x**4 + y**2 - 2*z**2 + x**2*(5 - 7*y**2 + 14*z**2))*SorH(8,r,1) + 2*(1 - 7*x**2)*z**2*SorH(7,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(7,r,1) + r*(-x**2 + y**2 + z**2)*SorH(7,r,2) + (2 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (y*(2*(4 - 6*y**2 - 3*z**2 + 3*x**2*(-4 + 10*y**2 + 5*z**2))*SorH(7,r) + (-2 + 15*x**4 + 3*y**2 - 3*x**2*(1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(4 - 14*y**2 - 7*z**2))*SorH(7,r,1) - (-1 + 7*x**2)*(x - y)*(x + y)*SorH(8,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (((1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(9,r) + r*((x**2 + y**2 - 5*x**2*y**2)*SorH(9,r,1) + r*x**2*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (y*((-2 + 3*y**2 - 3*z**2 + 3*x**2*(-1 + 5*x**2 - 5*y**2 + 5*z**2))*SorH(10,r) + (2 - 3*y**2 + 3*x**2*(-2 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 - y**2 + z**2)*SorH(10,r,1)) + (y**2 + x**2*(2 - 7*y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*((x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(10,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (x*((-2 + x**2*(3 - 15*y**2) - 3*z**2 + 3*y**2*(-1 + 5*y**2 + 5*z**2))*SorH(10,r) + (2 - 6*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(-x**2 + y**2 + z**2)*SorH(10,r,1)) + (x**2 + 2*y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*((-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(1 - 4*z**2 + 6*z**4 + y**2*(-2 + 6*z**2) + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 8*(-1 - 2*z**2 + 3*((x**2 - y**2)**2 + (x**2 + y**2)*z**2))*SorH(13,r) + 12*SorH(14,r) - 24*x**2*SorH(14,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 9*r*z**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + r**2*z**4*SorH(12,r,2) - 9*r*x**4*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 4*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + z**2 + x**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*y**2 - 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (((4*x**4*(-1 + 6*y**2) + 2*z**2 + y**2*(3 - 4*y**2 - 8*z**2) + x**2*(3 - 8*z**2 + 24*y**2*(-1 + y**2 + 2*z**2)))*SorH(12,r) + 4*(-1 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*z**2*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 24*x**4*y**2*SorH(14,r) + 4*y**4*SorH(14,r) - 24*x**2*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 18*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 4*r*x**2*z**2*SorH(13,r,1) - 4*r*y**2*z**2*SorH(13,r,1) + 36*r*x**2*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*y**2*z**2*SorH(13,r,2) - r*x**4*SorH(14,r,1) - 6*r*x**2*y**2*SorH(14,r,1) + 9*r*x**4*y**2*SorH(14,r,1) - r*y**4*SorH(14,r,1) + 9*r*x**2*y**4*SorH(14,r,1) + 2*r*x**2*z**2*SorH(14,r,1) + 2*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) - r**2*x**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (x*z*(4*(-6*y**4 + z**2 + y**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + x**2*(6 - 36*y**2) - 2*z**2 + 6*y**2*(1 + 2*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*y**4*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((3 - 4*y**2 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + 4*(-3 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*SorH(13,r) + 9*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) - 4*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(9,r) + r*((1 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(10,r,1) + r*(x**2 - y**2 + z**2)*SorH(10,r,2) + (2 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (x*((2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 15*y**2*(1 + z**2))*SorH(10,r) + 3*(-1 + 5*y**2)*z**2*SorH(11,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - z**2 + y**2*(5 - 7*y**2 + 7*z**2))*SorH(10,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((1 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(10,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + z**2 + x**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*y**2 - 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (x*y*(4*(1 + 6*x**4 - 4*z**2 + 6*x**2*(-1 + y**2 + z**2) + y**2*(-2 + 6*z**2))*SorH(12,r) + 4*(1 - 6*y**2 + 2*z**2 + 6*(y**2 - z**2)**2 + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(13,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + 3*r*x**2*(2 - 3*x**2)*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) + 6*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(x*z*((2 - 20*y**2 + 24*y**4 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + (-4 + x**2*(8 - 48*y**2) - 8*z**2 + 8*y**2*(5 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 20*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 8*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 5*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 10*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 5*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: ((-3*y**2 + 4*y**4 + x**4*(4 - 24*y**2) - 3*x**2*(1 - 8*y**2 + 8*y**4))*SorH(12,r) + (4*x**4*(-1 + 6*y**2) - 3*z**2 + y**2*(3 - 4*y**2 + 12*z**2) + 3*x**2*(1 + 4*z**2 + 8*y**2*(-1 + y**2 - 3*z**2)))*SorH(13,r) + 3*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*y**2*SorH(12,r,1) + 9*r*x**4*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 9*r*x**2*y**4*SorH(12,r,1) - r**2*x**4*y**2*SorH(12,r,2) - r**2*x**2*y**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*z**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (x*z*(2*(3 + 6*x**2*(-1 + 6*y**2) - 4*z**2 + 6*y**2*(-3 + 2*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + x**2*(6 - 36*y**2) + 2*z**2 + 6*y**2*(1 + 2*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + 3*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 18*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 6*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (x*y*(-8*(-1 + x**2 + y**2 - 2*z**2)*SorH(9,r) - 4*r*SorH(9,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(9,r,1) - r*SorH(9,r,2))))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(x*((2 + 3*x**2*(-1 + 5*y**2) + 6*z**2 + 15*y**2*(-1 + y**2 - 2*z**2))*SorH(11,r) + 6*(-1 + 5*y**2)*z**2*SorH(10,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - 2*z**2 + y**2*(5 - 7*y**2 + 14*z**2))*SorH(11,r,1) + 2*(1 - 7*y**2)*z**2*SorH(10,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (x*y*z*(3*(4 - 5*x**2 - 5*y**2 + 10*z**2)*SorH(11,r) + 6*(-4 + 5*x**2 + 5*y**2)*SorH(10,r)*sqrt(3) + r*((-4 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(11,r,1) - 2*(-4 + 7*x**2 + 7*y**2)*SorH(10,r,1)*sqrt(3) + r*(-((x**2 + y**2 - 2*z**2)*SorH(11,r,2)) + 2*(x**2 + y**2)*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(y*((2 - 3*y**2 + 6*z**2 + 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(11,r) + 6*(-1 + 5*x**2)*z**2*SorH(10,r)*sqrt(3) + r*((-7*x**4 + y**2 - 2*z**2 + x**2*(5 - 7*y**2 + 14*z**2))*SorH(11,r,1) + 2*(1 - 7*x**2)*z**2*SorH(10,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (((4*x**4*(-1 + 6*y**2) + 2*z**2 + y**2*(3 - 4*y**2 - 8*z**2) + x**2*(3 - 8*z**2 + 24*y**2*(-1 + y**2 + 2*z**2)))*SorH(12,r) + 4*(-1 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*z**2*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 24*x**4*y**2*SorH(14,r) + 4*y**4*SorH(14,r) - 24*x**2*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 18*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 4*r*x**2*z**2*SorH(13,r,1) - 4*r*y**2*z**2*SorH(13,r,1) + 36*r*x**2*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*y**2*z**2*SorH(13,r,2) - r*x**4*SorH(14,r,1) - 6*r*x**2*y**2*SorH(14,r,1) + 9*r*x**4*y**2*SorH(14,r,1) - r*y**4*SorH(14,r,1) + 9*r*x**2*y**4*SorH(14,r,1) + 2*r*x**2*z**2*SorH(14,r,1) + 2*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) - r**2*x**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(x*z*((2 - 20*y**2 + 24*y**4 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + (-4 + x**2*(8 - 48*y**2) - 8*z**2 + 8*y**2*(5 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 20*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 8*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 5*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 10*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 5*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (x*y*(24*(-1 + x**2 + y**2)*(-1 + 3*x**2 + 3*y**2)*SorH(12,r) + 96*(-2 + 3*x**2 + 3*y**2)*z**2*SorH(13,r) + 8*SorH(14,r) - 32*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 32*y**2*SorH(14,r) + 48*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 64*z**2*SorH(14,r) - 96*x**2*z**2*SorH(14,r) - 96*y**2*z**2*SorH(14,r) + 96*z**4*SorH(14,r) + 24*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + 24*r*y**2*SorH(12,r,1) - 54*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + 6*r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 48*r*z**2*SorH(13,r,1) - 108*r*x**2*z**2*SorH(13,r,1) - 108*r*y**2*z**2*SorH(13,r,1) + 12*r**2*x**2*z**2*SorH(13,r,2) + 12*r**2*y**2*z**2*SorH(13,r,2) + 8*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + 8*r*y**2*SorH(14,r,1) - 18*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 16*r*z**2*SorH(14,r,1) + 36*r*x**2*z**2*SorH(14,r,1) + 36*r*y**2*z**2*SorH(14,r,1) - 36*r*z**4*SorH(14,r,1) + r**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2)))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(y*z*((2 - 4*y**2 + 4*x**2*(-5 + 6*x**2 + 6*y**2))*SorH(12,r) + (-4 + 8*y**2 - 8*z**2 + 8*x**2*(5 - 6*x**2 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 20*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 4*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 8*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 5*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 10*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 5*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*(-2 + 3*x**2 + 3*y**2 + 6*z**2)*SorH(12,r) - 96*z**2*SorH(13,r) - 8*(-2 + 3*x**2 + 3*y**2)*SorH(14,r) + 48*z**2*SorH(14,r) + r*(4 - 9*x**2 - 9*y**2)*SorH(12,r,1) - 18*r*z**2*SorH(12,r,1) + r**2*x**2*SorH(12,r,2) + r**2*y**2*SorH(12,r,2) + 2*r**2*z**2*SorH(12,r,2) + 36*r*z**2*SorH(13,r,1) - 4*r**2*z**2*SorH(13,r,2) - 4*r*SorH(14,r,1) + 9*r*x**2*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) - 18*r*z**2*SorH(14,r,1) - r**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(9,r) + r*((1 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(10,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (y*((2 - 3*y**2 + 3*z**2 + 15*x**2*(-1 + x**2 + y**2 - z**2))*SorH(10,r) + 3*(-1 + 5*x**2)*z**2*SorH(11,r)*sqrt(3) + r*((-7*x**4 + (y - z)*(y + z) + x**2*(5 - 7*y**2 + 7*z**2))*SorH(10,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((1 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(10,r,1) + r*(-x**2 + y**2 + z**2)*SorH(10,r,2) + (2 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(-6*y**4 + z**2 + y**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + x**2*(6 - 36*y**2) - 2*z**2 + 6*y**2*(1 + 2*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*y**4*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: ((-3*y**2 + 4*y**4 + x**4*(4 - 24*y**2) - 3*x**2*(1 - 8*y**2 + 8*y**4))*SorH(12,r) + (4*x**4*(-1 + 6*y**2) - 3*z**2 + y**2*(3 - 4*y**2 + 12*z**2) + 3*x**2*(1 + 4*z**2 + 8*y**2*(-1 + y**2 - 3*z**2)))*SorH(13,r) + 3*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*y**2*SorH(12,r,1) + 9*r*x**4*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 9*r*x**2*y**4*SorH(12,r,1) - r**2*x**4*y**2*SorH(12,r,2) - r**2*x**2*y**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*z**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(y*z*((2 - 4*y**2 + 4*x**2*(-5 + 6*x**2 + 6*y**2))*SorH(12,r) + (-4 + 8*y**2 - 8*z**2 + 8*x**2*(5 - 6*x**2 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 20*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 4*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 8*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 5*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 10*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 5*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (x*y*(4*(1 - 4*z**2 + 6*y**2*(-1 + y**2 + z**2) + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 - 2*y**2 + 2*z**2 + 6*(x**2*(-1 + x**2 + y**2) + (-2*x**2 + y**2)*z**2 + z**4))*SorH(13,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 6*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 6*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(y*z*(2*(3 - 6*y**2 - 4*z**2 + 6*x**2*(-3 + 2*x**2 + 6*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + 6*y**2 + 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 72*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 9*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + 3*r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 18*r*x**4*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 2*r**2*x**4*SorH(13,r,2) - 6*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*SorH(9,r) + r*(-5*SorH(9,r,1) + r*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: -(x*(2*(4 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-4 + 5*z**2))*SorH(10,r) + (-2 + 3*x**2 - 3*(1 + 5*x**2)*y**2 + 15*y**4)*SorH(11,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(4 - 7*z**2))*SorH(10,r,1) + (x - y)*(x + y)*(-1 + 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(10,r,2) + (-x**2 + y**2)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*z*(-30*SorH(10,r) + 15*SorH(11,r)*sqrt(3) + r*(14*SorH(10,r,1) - 2*r*SorH(10,r,2) - 7*SorH(11,r,1)*sqrt(3) + r*SorH(11,r,2)*sqrt(3))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (y*(2*(4 - 6*y**2 - 3*z**2 + 3*x**2*(-4 + 10*y**2 + 5*z**2))*SorH(10,r) + (-2 + 15*x**4 + 3*y**2 - 3*x**2*(1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(4 - 14*y**2 - 7*z**2))*SorH(10,r,1) - (-1 + 7*x**2)*(x - y)*(x + y)*SorH(11,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((3 - 4*y**2 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + 4*(-3 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*SorH(13,r) + 9*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) - 4*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (x*z*(2*(3 + 6*x**2*(-1 + 6*y**2) - 4*z**2 + 6*y**2*(-3 + 2*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + x**2*(6 - 36*y**2) + 2*z**2 + 6*y**2*(1 + 2*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + 3*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 18*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 6*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*(-2 + 3*x**2 + 3*y**2 + 6*z**2)*SorH(12,r) - 96*z**2*SorH(13,r) - 8*(-2 + 3*x**2 + 3*y**2)*SorH(14,r) + 48*z**2*SorH(14,r) + r*(4 - 9*x**2 - 9*y**2)*SorH(12,r,1) - 18*r*z**2*SorH(12,r,1) + r**2*x**2*SorH(12,r,2) + r**2*y**2*SorH(12,r,2) + 2*r**2*z**2*SorH(12,r,2) + 36*r*z**2*SorH(13,r,1) - 4*r**2*z**2*SorH(13,r,2) - 4*r*SorH(14,r,1) + 9*r*x**2*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) - 18*r*z**2*SorH(14,r,1) - r**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(y*z*(2*(3 - 6*y**2 - 4*z**2 + 6*x**2*(-3 + 2*x**2 + 6*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + 6*y**2 + 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 72*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 9*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + 3*r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 18*r*x**4*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 2*r**2*x**4*SorH(13,r,2) - 6*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (x*y*(8*(-1 - 8*z**2 + 3*((x**2 - y**2)**2 + 4*(x**2 + y**2)*z**2 + 4*z**4))*SorH(12,r) + 32*(2 - 4*y**2 + 4*x**2*(-1 + 3*y**2) + (-2 + 3*x**2 + 3*y**2)*z**2)*SorH(13,r) - 24*SorH(14,r) + 72*x**4*SorH(14,r) - 144*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) - 9*r*x**4*SorH(12,r,1) + 18*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 16*r*z**2*SorH(12,r,1) - 36*r*x**2*z**2*SorH(12,r,1) - 36*r*y**2*z**2*SorH(12,r,1) - 36*r*z**4*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - 2*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 4*r**2*x**2*z**2*SorH(12,r,2) + 4*r**2*y**2*z**2*SorH(12,r,2) + 4*r**2*z**4*SorH(12,r,2) + 32*r*x**2*SorH(13,r,1) + 32*r*y**2*SorH(13,r,1) - 144*r*x**2*y**2*SorH(13,r,1) + 16*r*z**2*SorH(13,r,1) - 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) + 16*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) - 27*r*x**4*SorH(14,r,1) + 54*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*SorH(14,r,2)))/(4.*r**2), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: x*z*(-(SorH(0,r,1)/r) + SorH(0,r,2)), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(2,r) + r*(-3*SorH(2,r,1) + r*SorH(2,r,2))))/r**2, \
	(0,0,1,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x*z**2*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*z*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**2*z*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(3,r) + r*((1 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(3,r) + r*((1 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (x*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(3,r) + 2*r*SorH(3,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(3,r,1) - r*SorH(3,r,2))))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(3,r) + r*((x**2 + z**2 - 5*x**2*z**2)*SorH(3,r,1) + r*x**2*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*x**2 - 8*y**2)*SorH(3,r) + 2*r*SorH(3,r,1) + r*(x - y)*(x + y)*(-5*SorH(3,r,1) + r*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(4,r) + r*(-3*SorH(4,r,1) + r*SorH(4,r,2))))/r**2, \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (x*z*(8*(-1 + x**2 + z**2)*SorH(5,r) + 8*y**2*SorH(6,r) + r*((4 - 5*x**2 - 5*z**2)*SorH(5,r,1) + r*(x**2 + z**2)*SorH(5,r,2) + y**2*(-5*SorH(6,r,1) + r*SorH(6,r,2)))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (z*((2 + 3*y**2 - 3*z**2 + 15*x**2*(-1 + x**2 - y**2 + z**2))*SorH(7,r) + 3*(-1 + 5*x**2)*y**2*SorH(8,r)*sqrt(3) + r*((-7*x**4 - y**2 + z**2 + x**2*(5 + 7*y**2 - 7*z**2))*SorH(7,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((1 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (x*((2 - 3*x**2 + 3*y**2 + 15*(-1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(7,r) + 3*y**2*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((x**2 - y**2 + (5 - 7*x**2 + 7*y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((1 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(8,r) + 6*(-2 + 5*z**2)*SorH(7,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(8,r,1)) + 2*(2 - 7*z**2)*SorH(7,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(7,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: (x*y*z*(-6*(-6 + 10*x**2 + 5*z**2)*SorH(7,r) + 3*(-2 + 5*x**2 - 5*y**2)*SorH(8,r)*sqrt(3) + r*(2*(-6 + 14*x**2 + 7*z**2)*SorH(7,r,1) - 2*r*(2*x**2 + z**2)*SorH(7,r,2) + (2 - 7*x**2 + 7*y**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,2)*sqrt(3))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x*z**2*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*x**2 + 8*y**2)*SorH(5,r) + (-4 + 8*z**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*y**2)*SorH(5,r,1) + r*(x**2 + y**2)*SorH(5,r,2) + (2 - 5*z**2)*SorH(6,r,1) + r*z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + x**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + x**2*(-1 + 5*z**2))*SorH(5,r,1) + (x**2 + z**2 - 5*x**2*z**2)*SorH(6,r,1) + r*x**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(7,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(7,r) + 3*(-2 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(7,r,1) + r*(x**2 + y**2 - z**2)*SorH(7,r,2) + (2 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(8,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(7,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(8,r,1) + 2*r*z**4*SorH(8,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(8,r,2) + 2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (z*((-2 - 3*y**2 + 3*z**2 + 3*x**2*(-1 + 5*x**2 + 5*y**2 - 5*z**2))*SorH(7,r) + (2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 + y**2 - z**2)*SorH(7,r,1)) + (z**2 + x**2*(2 - 7*z**2))*SorH(8,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (x*(2*(-2 + 3*x**2 - 3*y**2 + 3*(2 - 5*x**2 + 5*y**2)*z**2)*SorH(7,r) + (2 - 3*x**2 + 3*y**2 + 3*(-2 + 5*x**2 - 5*y**2)*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (-2 + 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1) + (x**2 - y**2 + (2 - 7*x**2 + 7*y**2)*z**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*z*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**2*z*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + x**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + x**2*(-1 + 5*z**2))*SorH(5,r,1) + (x**2 + z**2 - 5*x**2*z**2)*SorH(6,r,1) + r*x**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*y**2 + 8*z**2)*SorH(5,r) + (-4 + 8*x**2)*SorH(6,r) + r*((2 - 5*y**2 - 5*z**2)*SorH(5,r,1) + r*(y**2 + z**2)*SorH(5,r,2) + (2 - 5*x**2)*SorH(6,r,1) + r*x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(7,r,1) + r*(-x**2 + y**2 + z**2)*SorH(7,r,2) + (2 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(7,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(z*((-4 - 3*y**2 + 6*z**2 + 3*x**2*(1 + 5*x**2 + 5*y**2 - 10*z**2))*SorH(8,r) + 2*(2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(7,r)*sqrt(3) + r*(-((7*x**4 - y**2 + 2*z**2 + x**2*(1 + 7*y**2 - 14*z**2))*SorH(8,r,1)) + 2*(z**2 + x**2*(2 - 7*z**2))*SorH(7,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 - 3*y**2 - 3*(1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(7,r) + (2 - 6*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*((x**2 - y**2 - z**2)*(-1 + 7*z**2)*SorH(7,r,1) + (x**2 + 2*z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*((-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (z*(2*(2 - 6*y**2 - 3*z**2 + 3*x**2*(-2 + 10*y**2 + 5*z**2))*SorH(7,r) + 3*(5*x**4 + y**2 - x**2*(3 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(2 - 14*y**2 - 7*z**2))*SorH(7,r,1) - (y**2 + x**2*(-3 + 7*x**2 - 7*y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(9,r) + r*((1 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (z*((2 + 3*y**2 - 3*z**2 + 15*x**2*(-1 + x**2 - y**2 + z**2))*SorH(10,r) + 3*(-1 + 5*x**2)*y**2*SorH(11,r)*sqrt(3) + r*((-7*x**4 - y**2 + z**2 + x**2*(5 + 7*y**2 - 7*z**2))*SorH(10,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((1 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(10,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(10,r,1) + r*(-x**2 + y**2 + z**2)*SorH(10,r,2) + (2 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(1 - 4*y**2 + 6*(-1 + y**2)*z**2 + 6*z**4 + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 + 2*y**2 - 2*z**2 + 6*(x**4 + x**2*(-1 - 2*y**2 + z**2) + y**2*(y**2 + z**2)))*SorH(13,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 9*r*z**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + r**2*z**4*SorH(12,r,2) + 6*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*y**2 + 3*(1 + 4*y**2)*z**2 - 4*z**4 + 4*x**4*(-1 + 6*z**2) + 3*x**2*(1 + 4*y**2 - 8*(1 + 3*y**2)*z**2 + 8*z**4))*SorH(13,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - r**2*x**2*z**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + 6*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + r**2*x**4*z**2*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (y*z*(4*(-1 + 6*x**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 4*x**2 + 2*(-1 + 6*x**2)*z**2)*SorH(13,r) + 4*SorH(14,r) - 4*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 8*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) - r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + y**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*x**2 - 2*y**2 + 6*(1 - 6*x**2 + 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - r*y**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*y**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) - 3*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (y*z*(4*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(12,r) - 16*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 12*r*x**2*SorH(13,r,1) + 36*r*x**4*SorH(13,r,1) + 4*r*y**2*SorH(13,r,1) - 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**4*SorH(13,r,2) + 4*r**2*x**2*y**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(9,r) + r*((1 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (x*((2 - 3*x**2 + 3*y**2 + 15*(-1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(10,r) + 3*y**2*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((x**2 - y**2 + (5 - 7*x**2 + 7*y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((1 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(10,r) + 3*(-2 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(10,r,1) + r*(x**2 + y**2 - z**2)*SorH(10,r,2) + (2 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(10,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*y**2 + 3*(1 + 4*y**2)*z**2 - 4*z**4 + 4*x**4*(-1 + 6*z**2) + 3*x**2*(1 + 4*y**2 - 8*(1 + 3*y**2)*z**2 + 8*z**4))*SorH(13,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - r**2*x**2*z**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + 6*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + r**2*x**4*z**2*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (x*z*(4*(1 + 6*x**4 - 2*z**2 + 6*x**2*(-1 + y**2 + z**2) + y**2*(-4 + 6*z**2))*SorH(12,r) + 4*(1 + 2*y**2 - 6*z**2 + 6*(y**2 - z**2)**2 + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(13,r) - 24*y**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + 3*r*x**2*(2 - 3*x**2)*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + y**2 + x**2*(3 - 6*y**2))*SorH(12,r) + 2*(-3 - 2*y**2 + 6*z**2 + 6*x**2*(1 + 2*x**2 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (x*y*(2*(3 - 6*x**2 - 2*y**2 + 12*(-2 + 3*x**2 + y**2)*z**2 + 24*z**4)*SorH(12,r) - 4*(3 - 6*x**2 + 2*y**2 + 6*(-3 + 6*x**2 - 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 72*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 27*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + 3*r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) + 54*r*x**2*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) - 6*r**2*x**2*z**2*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(x - y)*(x + y)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (x*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(9,r) + 2*r*SorH(9,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(9,r,1) - r*SorH(9,r,2))))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(11,r) + 6*(-2 + 5*z**2)*SorH(10,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(11,r,1)) + 2*(2 - 7*z**2)*SorH(10,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(11,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(10,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(11,r,1) + 2*r*z**4*SorH(11,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(11,r,2) + 2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(z*((-4 - 3*y**2 + 6*z**2 + 3*x**2*(1 + 5*x**2 + 5*y**2 - 10*z**2))*SorH(11,r) + 2*(2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(10,r)*sqrt(3) + r*(-((7*x**4 - y**2 + 2*z**2 + x**2*(1 + 7*y**2 - 14*z**2))*SorH(11,r,1)) + 2*(z**2 + x**2*(2 - 7*z**2))*SorH(10,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(-1 + 6*x**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 4*x**2 + 2*(-1 + 6*x**2)*z**2)*SorH(13,r) + 4*SorH(14,r) - 4*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 8*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) - r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (x*z*(24*(x**2 + y**2)*(-2 + 3*x**2 + 3*y**2)*SorH(12,r) + 48*(1 - 2*x**2 - 2*y**2 + 2*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(13,r) - 16*SorH(14,r) + 16*x**2*SorH(14,r) + 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 48*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 32*z**2*SorH(14,r) - 96*x**2*z**2*SorH(14,r) - 96*y**2*z**2*SorH(14,r) + 96*z**4*SorH(14,r) + 12*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + 12*r*y**2*SorH(12,r,1) - 54*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + 6*r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 24*r*x**2*SorH(13,r,1) + 24*r*y**2*SorH(13,r,1) + 24*r*z**2*SorH(13,r,1) - 108*r*x**2*z**2*SorH(13,r,1) - 108*r*y**2*z**2*SorH(13,r,1) + 12*r**2*x**2*z**2*SorH(13,r,2) + 12*r**2*y**2*z**2*SorH(13,r,2) - 4*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 18*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 8*r*z**2*SorH(14,r,1) + 36*r*x**2*z**2*SorH(14,r,1) + 36*r*y**2*z**2*SorH(14,r,1) - 36*r*z**4*SorH(14,r,1) + r**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2)))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(((y**2 + x**2*(3 - 4*x**2 - 4*y**2) + 4*(6*x**4 - y**2 + x**2*(-3 + 6*y**2))*z**2)*SorH(12,r) - 2*(y**2 - (3 + 4*y**2)*z**2 + 4*z**4 + 4*x**4*(-1 + 6*z**2) + x**2*(3 - 24*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 3*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 6*z**2*SorH(14,r) + 12*x**2*z**2*SorH(14,r) + 24*x**4*z**2*SorH(14,r) - 4*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*x**2*z**4*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + r*x**4*SorH(14,r,1) + r*x**2*y**2*SorH(14,r,1) - 3*r*x**2*z**2*SorH(14,r,1) - 9*r*x**4*z**2*SorH(14,r,1) + r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*x**2*z**4*SorH(14,r,1) + r**2*x**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (x*z*(8*(-1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(1 - 2*x**2 + 2*y**2 + 2*(-1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) + 8*SorH(14,r) - 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 8*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 4*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) - 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(9,r) + r*((x**2 + z**2 - 5*x**2*z**2)*SorH(9,r,1) + r*x**2*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(10,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (z*((-2 - 3*y**2 + 3*z**2 + 3*x**2*(-1 + 5*x**2 + 5*y**2 - 5*z**2))*SorH(10,r) + (2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 + y**2 - z**2)*SorH(10,r,1)) + (z**2 + x**2*(2 - 7*z**2))*SorH(11,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 - 3*y**2 - 3*(1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(10,r) + (2 - 6*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*((x**2 - y**2 - z**2)*(-1 + 7*z**2)*SorH(10,r,1) + (x**2 + 2*z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*((-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + y**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*x**2 - 2*y**2 + 6*(1 - 6*x**2 + 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - r*y**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*y**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) - 3*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + y**2 + x**2*(3 - 6*y**2))*SorH(12,r) + 2*(-3 - 2*y**2 + 6*z**2 + 6*x**2*(1 + 2*x**2 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(((y**2 + x**2*(3 - 4*x**2 - 4*y**2) + 4*(6*x**4 - y**2 + x**2*(-3 + 6*y**2))*z**2)*SorH(12,r) - 2*(y**2 - (3 + 4*y**2)*z**2 + 4*z**4 + 4*x**4*(-1 + 6*z**2) + x**2*(3 - 24*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 3*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 6*z**2*SorH(14,r) + 12*x**2*z**2*SorH(14,r) + 24*x**4*z**2*SorH(14,r) - 4*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*x**2*z**4*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + r*x**4*SorH(14,r,1) + r*x**2*y**2*SorH(14,r,1) - 3*r*x**2*z**2*SorH(14,r,1) - 9*r*x**4*z**2*SorH(14,r,1) + r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*x**2*z**4*SorH(14,r,1) + r**2*x**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (x*z*(4*(1 + 6*y**4 - 2*z**2 + y**2*(-4 + 6*z**2) + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 8*(-1 + 3*x**4 + 3*z**4 + 3*x**2*(y**2 - 2*z**2) + y**2*(-2 + 3*z**2))*SorH(13,r) + 12*SorH(14,r) - 24*x**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 9*r*x**4*SorH(13,r,1) + 4*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: ((-3*y**2 + 6*(-1 + 2*y**2)*z**2 + 8*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 4*y**2 + 12*(-1 + 2*y**2)*z**2 + 16*z**4))*SorH(12,r) + 2*(x**4*(4 - 24*z**2) + 3*(y**2 + z**2) - 4*(3*y**2*z**2 + z**4) + 3*x**2*(-1 + 8*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 9*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 12*x**2*y**2*SorH(14,r) - 36*x**2*z**2*SorH(14,r) + 72*x**4*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) - 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 3*r*x**2*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - 3*r*y**2*z**2*SorH(12,r,1) + 27*r*x**2*y**2*z**2*SorH(12,r,1) - 2*r*z**4*SorH(12,r,1) + 18*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - 3*r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r**2*x**2*z**4*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) - 54*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) + 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**4*SorH(14,r,1) - 3*r*x**2*y**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) - 27*r*x**4*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) + 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*x**2 - 8*y**2)*SorH(9,r) + 2*r*SorH(9,r,1) + r*(x - y)*(x + y)*(-5*SorH(9,r,1) + r*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(-6*(-6 + 10*x**2 + 5*z**2)*SorH(10,r) + 3*(-2 + 5*x**2 - 5*y**2)*SorH(11,r)*sqrt(3) + r*(2*(-6 + 14*x**2 + 7*z**2)*SorH(10,r,1) - 2*r*(2*x**2 + z**2)*SorH(10,r,2) + (2 - 7*x**2 + 7*y**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,2)*sqrt(3))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (x*(2*(-2 + 3*x**2 - 3*y**2 + 3*(2 - 5*x**2 + 5*y**2)*z**2)*SorH(10,r) + (2 - 3*x**2 + 3*y**2 + 3*(-2 + 5*x**2 - 5*y**2)*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (-2 + 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1) + (x**2 - y**2 + (2 - 7*x**2 + 7*y**2)*z**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (z*(2*(2 - 6*y**2 - 3*z**2 + 3*x**2*(-2 + 10*y**2 + 5*z**2))*SorH(10,r) + 3*(5*x**4 + y**2 - x**2*(3 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(2 - 14*y**2 - 7*z**2))*SorH(10,r,1) - (y**2 + x**2*(-3 + 7*x**2 - 7*y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(12,r) - 16*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 12*r*x**2*SorH(13,r,1) + 36*r*x**4*SorH(13,r,1) + 4*r*y**2*SorH(13,r,1) - 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**4*SorH(13,r,2) + 4*r**2*x**2*y**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (x*y*(2*(3 - 6*x**2 - 2*y**2 + 12*(-2 + 3*x**2 + y**2)*z**2 + 24*z**4)*SorH(12,r) - 4*(3 - 6*x**2 + 2*y**2 + 6*(-3 + 6*x**2 - 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 72*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 27*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + 3*r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) + 54*r*x**2*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) - 6*r**2*x**2*z**2*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(x - y)*(x + y)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (x*z*(8*(-1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(1 - 2*x**2 + 2*y**2 + 2*(-1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) + 8*SorH(14,r) - 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 8*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 4*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) - 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: ((-3*y**2 + 6*(-1 + 2*y**2)*z**2 + 8*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 4*y**2 + 12*(-1 + 2*y**2)*z**2 + 16*z**4))*SorH(12,r) + 2*(x**4*(4 - 24*z**2) + 3*(y**2 + z**2) - 4*(3*y**2*z**2 + z**4) + 3*x**2*(-1 + 8*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 9*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 12*x**2*y**2*SorH(14,r) - 36*x**2*z**2*SorH(14,r) + 72*x**4*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) - 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 3*r*x**2*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - 3*r*y**2*z**2*SorH(12,r,1) + 27*r*x**2*y**2*z**2*SorH(12,r,1) - 2*r*z**4*SorH(12,r,1) + 18*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - 3*r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r**2*x**2*z**4*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) - 54*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) + 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**4*SorH(14,r,1) - 3*r*x**2*y**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) - 27*r*x**4*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) + 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (x*z*(8*(-2*(-1 + y**2 + 6*z**2) + 3*(x**4 - 2*x**2*(1 + y**2 - 2*z**2) + (y**2 + 2*z**2)**2))*SorH(12,r) + 16*(1 - 2*z**2 + 2*y**2*(-5 + 3*z**2) + x**2*(-2 + 24*y**2 + 6*z**2))*SorH(13,r) - 48*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 48*y**2*SorH(14,r) - 144*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) + 12*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) + 18*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 24*r*z**2*SorH(12,r,1) - 36*r*x**2*z**2*SorH(12,r,1) - 36*r*y**2*z**2*SorH(12,r,1) - 36*r*z**4*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - 2*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 4*r**2*x**2*z**2*SorH(12,r,2) + 4*r**2*y**2*z**2*SorH(12,r,2) + 4*r**2*z**4*SorH(12,r,2) + 8*r*x**2*SorH(13,r,1) + 40*r*y**2*SorH(13,r,1) - 144*r*x**2*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) - 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) + 16*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 12*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 12*r*y**2*SorH(14,r,1) + 54*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*SorH(14,r,2)))/(4.*r**2), \
},
],\
[\
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: x*y*(-(SorH(0,r,1)/r) + SorH(0,r,2)), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: (x*(-1 + 3*y**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x*y**2*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(2,r) + r*(-3*SorH(2,r,1) + r*SorH(2,r,2))))/r**2, \
	(0,0,1,1) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*y*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**2*y*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (((1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(3,r) + r*((x**2 + y**2 - 5*x**2*y**2)*SorH(3,r,1) + r*x**2*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(3,r) + r*((1 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (x*y*(-8*(-1 + x**2 + y**2 - 2*z**2)*SorH(3,r) - 4*r*SorH(3,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(3,r,1) - r*SorH(3,r,2))))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(3,r) + r*((1 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*SorH(3,r) + r*(-5*SorH(3,r,1) + r*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*y**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x*y**2*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (x*y*((-4 + 8*x**2 + 8*z**2)*SorH(5,r) + (-4 + 8*y**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*z**2)*SorH(5,r,1) + r*(x**2 + z**2)*SorH(5,r,2) + (2 - 5*y**2)*SorH(6,r,1) + r*y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: ((-1 + 2*y**2 + x**2*(2 - 8*y**2))*SorH(5,r) + (1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(6,r) + r*((-y**2 + x**2*(-1 + 5*y**2))*SorH(5,r,1) + (x**2 + y**2 - 5*x**2*y**2)*SorH(6,r,1) + r*x**2*y**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (y*((-2 + 3*y**2 - 3*z**2 + 3*x**2*(-1 + 5*x**2 - 5*y**2 + 5*z**2))*SorH(7,r) + (2 - 3*y**2 + 3*x**2*(-2 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 - y**2 + z**2)*SorH(7,r,1)) + (y**2 + x**2*(2 - 7*y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*((x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(7,r,1) + r*(x**2 - y**2 + z**2)*SorH(7,r,2) + (2 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(x*((2 + 3*x**2*(-1 + 5*y**2) + 6*z**2 + 15*y**2*(-1 + y**2 - 2*z**2))*SorH(8,r) + 6*(-1 + 5*y**2)*z**2*SorH(7,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - 2*z**2 + y**2*(5 - 7*y**2 + 14*z**2))*SorH(8,r,1) + 2*(1 - 7*y**2)*z**2*SorH(7,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(7,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(x*(2*(4 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-4 + 5*z**2))*SorH(7,r) + (-2 + 3*x**2 - 3*(1 + 5*x**2)*y**2 + 15*y**4)*SorH(8,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(4 - 7*z**2))*SorH(7,r,1) + (x - y)*(x + y)*(-1 + 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(7,r,2) + (-x**2 + y**2)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(4,r) + r*(-3*SorH(4,r,1) + r*SorH(4,r,2))))/r**2, \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (x*y*(8*(-1 + x**2 + y**2)*SorH(5,r) + 8*z**2*SorH(6,r) + r*((4 - 5*x**2 - 5*y**2)*SorH(5,r,1) + r*(x**2 + y**2)*SorH(5,r,2) + z**2*(-5*SorH(6,r,1) + r*SorH(6,r,2)))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(7,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (x*((2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 15*y**2*(1 + z**2))*SorH(7,r) + 3*(-1 + 5*y**2)*z**2*SorH(8,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - z**2 + y**2*(5 - 7*y**2 + 7*z**2))*SorH(7,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((1 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (x*y*z*(3*(4 - 5*x**2 - 5*y**2 + 10*z**2)*SorH(8,r) + 6*(-4 + 5*x**2 + 5*y**2)*SorH(7,r)*sqrt(3) + r*((-4 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(8,r,1) - 2*(-4 + 7*x**2 + 7*y**2)*SorH(7,r,1)*sqrt(3) + r*(-((x**2 + y**2 - 2*z**2)*SorH(8,r,2)) + 2*(x**2 + y**2)*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (y*((2 - 3*y**2 + 3*z**2 + 15*x**2*(-1 + x**2 + y**2 - z**2))*SorH(7,r) + 3*(-1 + 5*x**2)*z**2*SorH(8,r)*sqrt(3) + r*((-7*x**4 + (y - z)*(y + z) + x**2*(5 - 7*y**2 + 7*z**2))*SorH(7,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((1 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*z*(-30*SorH(7,r) + 15*SorH(8,r)*sqrt(3) + r*(14*SorH(7,r,1) - 2*r*SorH(7,r,2) - 7*SorH(8,r,1)*sqrt(3) + r*SorH(8,r,2)*sqrt(3))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*y*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**2*y*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: ((-1 + 2*y**2 + x**2*(2 - 8*y**2))*SorH(5,r) + (1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(6,r) + r*((-y**2 + x**2*(-1 + 5*y**2))*SorH(5,r,1) + (x**2 + y**2 - 5*x**2*y**2)*SorH(6,r,1) + r*x**2*y**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (x*y*((-4 + 8*y**2 + 8*z**2)*SorH(5,r) + (-4 + 8*x**2)*SorH(6,r) + r*((2 - 5*y**2 - 5*z**2)*SorH(5,r,1) + r*(y**2 + z**2)*SorH(5,r,2) + (2 - 5*x**2)*SorH(6,r,1) + r*x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (x*((-2 + x**2*(3 - 15*y**2) - 3*z**2 + 3*y**2*(-1 + 5*y**2 + 5*z**2))*SorH(7,r) + (2 - 6*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(-x**2 + y**2 + z**2)*SorH(7,r,1)) + (x**2 + 2*y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*((-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(7,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(8,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(y*((2 - 3*y**2 + 6*z**2 + 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(8,r) + 6*(-1 + 5*x**2)*z**2*SorH(7,r)*sqrt(3) + r*((-7*x**4 + y**2 - 2*z**2 + x**2*(5 - 7*y**2 + 14*z**2))*SorH(8,r,1) + 2*(1 - 7*x**2)*z**2*SorH(7,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(7,r,1) + r*(-x**2 + y**2 + z**2)*SorH(7,r,2) + (2 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (y*(2*(4 - 6*y**2 - 3*z**2 + 3*x**2*(-4 + 10*y**2 + 5*z**2))*SorH(7,r) + (-2 + 15*x**4 + 3*y**2 - 3*x**2*(1 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(4 - 14*y**2 - 7*z**2))*SorH(7,r,1) - (-1 + 7*x**2)*(x - y)*(x + y)*SorH(8,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (((1 - 2*y**2 + x**2*(-2 + 8*y**2))*SorH(9,r) + r*((x**2 + y**2 - 5*x**2*y**2)*SorH(9,r,1) + r*x**2*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (y*((-2 + 3*y**2 - 3*z**2 + 3*x**2*(-1 + 5*x**2 - 5*y**2 + 5*z**2))*SorH(10,r) + (2 - 3*y**2 + 3*x**2*(-2 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 - y**2 + z**2)*SorH(10,r,1)) + (y**2 + x**2*(2 - 7*y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*((x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(10,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (x*((-2 + x**2*(3 - 15*y**2) - 3*z**2 + 3*y**2*(-1 + 5*y**2 + 5*z**2))*SorH(10,r) + (2 - 6*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(-x**2 + y**2 + z**2)*SorH(10,r,1)) + (x**2 + 2*y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*((-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(1 - 4*z**2 + 6*z**4 + y**2*(-2 + 6*z**2) + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 8*(-1 - 2*z**2 + 3*((x**2 - y**2)**2 + (x**2 + y**2)*z**2))*SorH(13,r) + 12*SorH(14,r) - 24*x**2*SorH(14,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 9*r*z**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + r**2*z**4*SorH(12,r,2) - 9*r*x**4*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 4*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + z**2 + x**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*y**2 - 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (((4*x**4*(-1 + 6*y**2) + 2*z**2 + y**2*(3 - 4*y**2 - 8*z**2) + x**2*(3 - 8*z**2 + 24*y**2*(-1 + y**2 + 2*z**2)))*SorH(12,r) + 4*(-1 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*z**2*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 24*x**4*y**2*SorH(14,r) + 4*y**4*SorH(14,r) - 24*x**2*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 18*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 4*r*x**2*z**2*SorH(13,r,1) - 4*r*y**2*z**2*SorH(13,r,1) + 36*r*x**2*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*y**2*z**2*SorH(13,r,2) - r*x**4*SorH(14,r,1) - 6*r*x**2*y**2*SorH(14,r,1) + 9*r*x**4*y**2*SorH(14,r,1) - r*y**4*SorH(14,r,1) + 9*r*x**2*y**4*SorH(14,r,1) + 2*r*x**2*z**2*SorH(14,r,1) + 2*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) - r**2*x**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (x*z*(4*(-6*y**4 + z**2 + y**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + x**2*(6 - 36*y**2) - 2*z**2 + 6*y**2*(1 + 2*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*y**4*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((3 - 4*y**2 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + 4*(-3 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*SorH(13,r) + 9*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) - 4*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(9,r) + r*((1 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(10,r,1) + r*(x**2 - y**2 + z**2)*SorH(10,r,2) + (2 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (x*((2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 15*y**2*(1 + z**2))*SorH(10,r) + 3*(-1 + 5*y**2)*z**2*SorH(11,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - z**2 + y**2*(5 - 7*y**2 + 7*z**2))*SorH(10,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((1 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(10,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + z**2 + x**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*y**2 - 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (x*y*(4*(1 + 6*x**4 - 4*z**2 + 6*x**2*(-1 + y**2 + z**2) + y**2*(-2 + 6*z**2))*SorH(12,r) + 4*(1 - 6*y**2 + 2*z**2 + 6*(y**2 - z**2)**2 + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(13,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + 3*r*x**2*(2 - 3*x**2)*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) + 6*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(x*z*((2 - 20*y**2 + 24*y**4 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + (-4 + x**2*(8 - 48*y**2) - 8*z**2 + 8*y**2*(5 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 20*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 8*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 5*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 10*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 5*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: ((-3*y**2 + 4*y**4 + x**4*(4 - 24*y**2) - 3*x**2*(1 - 8*y**2 + 8*y**4))*SorH(12,r) + (4*x**4*(-1 + 6*y**2) - 3*z**2 + y**2*(3 - 4*y**2 + 12*z**2) + 3*x**2*(1 + 4*z**2 + 8*y**2*(-1 + y**2 - 3*z**2)))*SorH(13,r) + 3*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*y**2*SorH(12,r,1) + 9*r*x**4*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 9*r*x**2*y**4*SorH(12,r,1) - r**2*x**4*y**2*SorH(12,r,2) - r**2*x**2*y**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*z**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (x*z*(2*(3 + 6*x**2*(-1 + 6*y**2) - 4*z**2 + 6*y**2*(-3 + 2*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + x**2*(6 - 36*y**2) + 2*z**2 + 6*y**2*(1 + 2*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + 3*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 18*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 6*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (x*y*(-8*(-1 + x**2 + y**2 - 2*z**2)*SorH(9,r) - 4*r*SorH(9,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(9,r,1) - r*SorH(9,r,2))))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(x*((2 + 3*x**2*(-1 + 5*y**2) + 6*z**2 + 15*y**2*(-1 + y**2 - 2*z**2))*SorH(11,r) + 6*(-1 + 5*y**2)*z**2*SorH(10,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - 2*z**2 + y**2*(5 - 7*y**2 + 14*z**2))*SorH(11,r,1) + 2*(1 - 7*y**2)*z**2*SorH(10,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (x*y*z*(3*(4 - 5*x**2 - 5*y**2 + 10*z**2)*SorH(11,r) + 6*(-4 + 5*x**2 + 5*y**2)*SorH(10,r)*sqrt(3) + r*((-4 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(11,r,1) - 2*(-4 + 7*x**2 + 7*y**2)*SorH(10,r,1)*sqrt(3) + r*(-((x**2 + y**2 - 2*z**2)*SorH(11,r,2)) + 2*(x**2 + y**2)*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(y*((2 - 3*y**2 + 6*z**2 + 15*x**2*(-1 + x**2 + y**2 - 2*z**2))*SorH(11,r) + 6*(-1 + 5*x**2)*z**2*SorH(10,r)*sqrt(3) + r*((-7*x**4 + y**2 - 2*z**2 + x**2*(5 - 7*y**2 + 14*z**2))*SorH(11,r,1) + 2*(1 - 7*x**2)*z**2*SorH(10,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (((4*x**4*(-1 + 6*y**2) + 2*z**2 + y**2*(3 - 4*y**2 - 8*z**2) + x**2*(3 - 8*z**2 + 24*y**2*(-1 + y**2 + 2*z**2)))*SorH(12,r) + 4*(-1 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*z**2*SorH(13,r) - 3*x**2*SorH(14,r) + 4*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 24*x**4*y**2*SorH(14,r) + 4*y**4*SorH(14,r) - 24*x**2*y**4*SorH(14,r) + 2*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) - 8*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) + 2*r*y**2*z**2*SorH(12,r,1) - 18*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 4*r*x**2*z**2*SorH(13,r,1) - 4*r*y**2*z**2*SorH(13,r,1) + 36*r*x**2*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*y**2*z**2*SorH(13,r,2) - r*x**4*SorH(14,r,1) - 6*r*x**2*y**2*SorH(14,r,1) + 9*r*x**4*y**2*SorH(14,r,1) - r*y**4*SorH(14,r,1) + 9*r*x**2*y**4*SorH(14,r,1) + 2*r*x**2*z**2*SorH(14,r,1) + 2*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) - r**2*x**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(x*z*((2 - 20*y**2 + 24*y**4 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + (-4 + x**2*(8 - 48*y**2) - 8*z**2 + 8*y**2*(5 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 20*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 8*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 5*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 10*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 5*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (x*y*(24*(-1 + x**2 + y**2)*(-1 + 3*x**2 + 3*y**2)*SorH(12,r) + 96*(-2 + 3*x**2 + 3*y**2)*z**2*SorH(13,r) + 8*SorH(14,r) - 32*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 32*y**2*SorH(14,r) + 48*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 64*z**2*SorH(14,r) - 96*x**2*z**2*SorH(14,r) - 96*y**2*z**2*SorH(14,r) + 96*z**4*SorH(14,r) + 24*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + 24*r*y**2*SorH(12,r,1) - 54*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + 6*r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 48*r*z**2*SorH(13,r,1) - 108*r*x**2*z**2*SorH(13,r,1) - 108*r*y**2*z**2*SorH(13,r,1) + 12*r**2*x**2*z**2*SorH(13,r,2) + 12*r**2*y**2*z**2*SorH(13,r,2) + 8*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + 8*r*y**2*SorH(14,r,1) - 18*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 16*r*z**2*SorH(14,r,1) + 36*r*x**2*z**2*SorH(14,r,1) + 36*r*y**2*z**2*SorH(14,r,1) - 36*r*z**4*SorH(14,r,1) + r**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2)))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(y*z*((2 - 4*y**2 + 4*x**2*(-5 + 6*x**2 + 6*y**2))*SorH(12,r) + (-4 + 8*y**2 - 8*z**2 + 8*x**2*(5 - 6*x**2 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 20*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 4*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 8*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 5*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 10*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 5*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*(-2 + 3*x**2 + 3*y**2 + 6*z**2)*SorH(12,r) - 96*z**2*SorH(13,r) - 8*(-2 + 3*x**2 + 3*y**2)*SorH(14,r) + 48*z**2*SorH(14,r) + r*(4 - 9*x**2 - 9*y**2)*SorH(12,r,1) - 18*r*z**2*SorH(12,r,1) + r**2*x**2*SorH(12,r,2) + r**2*y**2*SorH(12,r,2) + 2*r**2*z**2*SorH(12,r,2) + 36*r*z**2*SorH(13,r,1) - 4*r**2*z**2*SorH(13,r,2) - 4*r*SorH(14,r,1) + 9*r*x**2*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) - 18*r*z**2*SorH(14,r,1) - r**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(9,r) + r*((1 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (z*((-2 + 6*y**2 + x**2*(6 - 30*y**2))*SorH(10,r) + (1 - 3*y**2 + 3*x**2*(-1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-y**2 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 + y**2 - 7*x**2*y**2)*SorH(11,r,1)*sqrt(3) + r*x**2*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (y*((2 - 3*y**2 + 3*z**2 + 15*x**2*(-1 + x**2 + y**2 - z**2))*SorH(10,r) + 3*(-1 + 5*x**2)*z**2*SorH(11,r)*sqrt(3) + r*((-7*x**4 + (y - z)*(y + z) + x**2*(5 - 7*y**2 + 7*z**2))*SorH(10,r,1) + r*x**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((1 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(10,r,1) + r*(-x**2 + y**2 + z**2)*SorH(10,r,2) + (2 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(-6*y**4 + z**2 + y**2*(3 - 6*z**2))*SorH(12,r) + 2*(-3 + x**2*(6 - 36*y**2) - 2*z**2 + 6*y**2*(1 + 2*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 3*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*y**4*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: ((-3*y**2 + 4*y**4 + x**4*(4 - 24*y**2) - 3*x**2*(1 - 8*y**2 + 8*y**4))*SorH(12,r) + (4*x**4*(-1 + 6*y**2) - 3*z**2 + y**2*(3 - 4*y**2 + 12*z**2) + 3*x**2*(1 + 4*z**2 + 8*y**2*(-1 + y**2 - 3*z**2)))*SorH(13,r) + 3*z**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*y**2*SorH(12,r,1) + 9*r*x**4*y**2*SorH(12,r,1) - r*y**4*SorH(12,r,1) + 9*r*x**2*y**4*SorH(12,r,1) - r**2*x**4*y**2*SorH(12,r,2) - r**2*x**2*y**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*z**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(y*z*((2 - 4*y**2 + 4*x**2*(-5 + 6*x**2 + 6*y**2))*SorH(12,r) + (-4 + 8*y**2 - 8*z**2 + 8*x**2*(5 - 6*x**2 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 20*x**2*SorH(14,r) + 24*x**4*SorH(14,r) - 4*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 8*z**2*SorH(14,r) - 48*x**2*z**2*SorH(14,r) + 5*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) - 10*r*x**2*SorH(13,r,1) + 18*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) - 2*r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*x**2*z**2*SorH(13,r,2) + 5*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*x**2*z**2*SorH(14,r,1) + r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (x*y*(4*(1 - 4*z**2 + 6*y**2*(-1 + y**2 + z**2) + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 - 2*y**2 + 2*z**2 + 6*(x**2*(-1 + x**2 + y**2) + (-2*x**2 + y**2)*z**2 + z**4))*SorH(13,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 6*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 6*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(y*z*(2*(3 - 6*y**2 - 4*z**2 + 6*x**2*(-3 + 2*x**2 + 6*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + 6*y**2 + 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 72*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 9*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + 3*r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 18*r*x**4*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 2*r**2*x**4*SorH(13,r,2) - 6*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*SorH(9,r) + r*(-5*SorH(9,r,1) + r*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: -(x*(2*(4 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-4 + 5*z**2))*SorH(10,r) + (-2 + 3*x**2 - 3*(1 + 5*x**2)*y**2 + 15*y**4)*SorH(11,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(4 - 7*z**2))*SorH(10,r,1) + (x - y)*(x + y)*(-1 + 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(10,r,2) + (-x**2 + y**2)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*z*(-30*SorH(10,r) + 15*SorH(11,r)*sqrt(3) + r*(14*SorH(10,r,1) - 2*r*SorH(10,r,2) - 7*SorH(11,r,1)*sqrt(3) + r*SorH(11,r,2)*sqrt(3))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (y*(2*(4 - 6*y**2 - 3*z**2 + 3*x**2*(-4 + 10*y**2 + 5*z**2))*SorH(10,r) + (-2 + 15*x**4 + 3*y**2 - 3*x**2*(1 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(4 - 14*y**2 - 7*z**2))*SorH(10,r,1) - (-1 + 7*x**2)*(x - y)*(x + y)*SorH(11,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((3 - 4*y**2 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + 4*(-3 + 4*x**2 + 4*(1 - 6*x**2)*y**2)*SorH(13,r) + 9*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) - 4*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (x*z*(2*(3 + 6*x**2*(-1 + 6*y**2) - 4*z**2 + 6*y**2*(-3 + 2*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + x**2*(6 - 36*y**2) + 2*z**2 + 6*y**2*(1 + 2*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + 3*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 18*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 6*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(8*(-2 + 3*x**2 + 3*y**2 + 6*z**2)*SorH(12,r) - 96*z**2*SorH(13,r) - 8*(-2 + 3*x**2 + 3*y**2)*SorH(14,r) + 48*z**2*SorH(14,r) + r*(4 - 9*x**2 - 9*y**2)*SorH(12,r,1) - 18*r*z**2*SorH(12,r,1) + r**2*x**2*SorH(12,r,2) + r**2*y**2*SorH(12,r,2) + 2*r**2*z**2*SorH(12,r,2) + 36*r*z**2*SorH(13,r,1) - 4*r**2*z**2*SorH(13,r,2) - 4*r*SorH(14,r,1) + 9*r*x**2*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) - 18*r*z**2*SorH(14,r,1) - r**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(y*z*(2*(3 - 6*y**2 - 4*z**2 + 6*x**2*(-3 + 2*x**2 + 6*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + 6*y**2 + 2*z**2 + 6*x**2*(1 + 2*x**2 - 6*y**2 - 2*z**2))*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 72*x**4*SorH(14,r) - 12*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 9*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + 3*r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 18*r*x**4*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 2*r**2*x**4*SorH(13,r,2) - 6*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 27*r*x**4*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (x*y*(8*(-1 - 8*z**2 + 3*((x**2 - y**2)**2 + 4*(x**2 + y**2)*z**2 + 4*z**4))*SorH(12,r) + 32*(2 - 4*y**2 + 4*x**2*(-1 + 3*y**2) + (-2 + 3*x**2 + 3*y**2)*z**2)*SorH(13,r) - 24*SorH(14,r) + 72*x**4*SorH(14,r) - 144*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) - 9*r*x**4*SorH(12,r,1) + 18*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 16*r*z**2*SorH(12,r,1) - 36*r*x**2*z**2*SorH(12,r,1) - 36*r*y**2*z**2*SorH(12,r,1) - 36*r*z**4*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - 2*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 4*r**2*x**2*z**2*SorH(12,r,2) + 4*r**2*y**2*z**2*SorH(12,r,2) + 4*r**2*z**4*SorH(12,r,2) + 32*r*x**2*SorH(13,r,1) + 32*r*y**2*SorH(13,r,1) - 144*r*x**2*y**2*SorH(13,r,1) + 16*r*z**2*SorH(13,r,1) - 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) + 16*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) - 27*r*x**4*SorH(14,r,1) + 54*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*SorH(14,r,2)))/(4.*r**2), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: -(((-1 + y**2)*SorH(0,r,1))/r) + y**2*SorH(0,r,2), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: (3*y*(-1 + y**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y**3*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: ((-1 + 3*y**2)*z*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y**2*z*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: (x*(-1 + 3*y**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x*y**2*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*y*((-6 + 8*y**2)*SorH(3,r) + r*((3 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (y*z*((-6 + 8*y**2)*SorH(3,r) + r*((3 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: -(2*(-1 + 4*y**2)*(-1 + x**2 + y**2 - 2*z**2)*SorH(3,r) + r*((x**2 + 5*y**2 - 5*x**2*y**2 - 5*y**4 + 2*(-1 + 5*y**2)*z**2)*SorH(3,r,1) + r*y**2*(x**2 + y**2 - 2*z**2)*SorH(3,r,2)))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(3,r) + r*((1 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: ((2*(1 + x**2 - y**2)*(-1 + 4*y**2)*SorH(3,r) + r*((x**2 - 5*(1 + x**2)*y**2 + 5*y**4)*SorH(3,r,1) + r*(x - y)*y**2*(x + y)*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: (3*y*(-1 + y**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y**3*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (2*(-1 + 4*y**2)*(x**2 + z**2)*SorH(5,r) + 2*(1 - 5*y**2 + 4*y**4)*SorH(6,r) + r*(-((-1 + 5*y**2)*(x**2 + z**2)*SorH(5,r,1)) + y**2*(r*(x**2 + z**2)*SorH(5,r,2) - 5*(-1 + y**2)*SorH(6,r,1) + r*y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (y*z*((6 - 8*y**2)*SorH(5,r) + (-6 + 8*y**2)*SorH(6,r) + r*((-3 + 5*y**2)*SorH(5,r,1) + (3 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*y*((6 - 8*y**2)*SorH(5,r) + (-6 + 8*y**2)*SorH(6,r) + r*((-3 + 5*y**2)*SorH(5,r,1) + (3 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2*(-1 + 5*y**2) - 3*z**2 + 15*y**2*(1 - y**2 + z**2))*SorH(7,r) + r*(x**2*(1 - 7*y**2) + z**2 + y**2*(-5 + 7*y**2 - 7*z**2))*SorH(7,r,1) + (2 - 15*y**2 + 15*y**4)*SorH(8,r)*sqrt(3) + r*y**2*(r*(x**2 - y**2 + z**2)*SorH(7,r,2) + (5 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (z*((-2 + 3*x**2*(-1 + 5*y**2) - 3*z**2 + 15*y**2*(1 - y**2 + z**2))*SorH(7,r) + r*(x**2*(1 - 7*y**2) + z**2 + y**2*(-5 + 7*y**2 - 7*z**2))*SorH(7,r,1) + (2 - 15*y**2 + 15*y**4)*SorH(8,r)*sqrt(3) + r*y**2*(r*(x**2 - y**2 + z**2)*SorH(7,r,2) + (5 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(y*(3*(2 - 7*y**2 + 5*y**4 + x**2*(-3 + 5*y**2) + 2*(3 - 5*y**2)*z**2)*SorH(8,r) + 6*(-3 + 5*y**2)*z**2*SorH(7,r)*sqrt(3) + r*((x**2*(3 - 7*y**2) - 6*z**2 - 7*y**2*(-1 + y**2 - 2*z**2))*SorH(8,r,1) + 2*(3 - 7*y**2)*z**2*SorH(7,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*y**2)*SorH(7,r) + 3*(-3 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*SorH(7,r,1) + (3 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: (y*(-6*(-3 + 5*y**2)*(2*x**2 + z**2)*SorH(7,r) - 3*(2 - 7*y**2 + 5*y**4 + x**2*(3 - 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*(2*x**2 + z**2)*SorH(7,r,1) + (3*x**2 - 7*(1 + x**2)*y**2 + 7*y**4)*SorH(8,r,1)*sqrt(3) + r*y**2*(-2*(2*x**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*y**2)*z*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y**2*z*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (y*z*((6 - 8*y**2)*SorH(5,r) + (-6 + 8*y**2)*SorH(6,r) + r*((-3 + 5*y**2)*SorH(5,r,1) + (3 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (2*(-1 + x**2 + y**2)*(-1 + 4*y**2)*SorH(5,r) + 2*(-1 + 4*y**2)*z**2*SorH(6,r) + r*((x**2 - 5*(-1 + x**2)*y**2 - 5*y**4)*SorH(5,r,1) + (1 - 5*y**2)*z**2*SorH(6,r,1) + r*y**2*((x**2 + y**2)*SorH(5,r,2) + z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*y**2)*SorH(7,r) + 3*(-3 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*SorH(7,r,1) + (3 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (y*(3*(2 + 5*y**4 + x**2*(-3 + 5*y**2) + 3*z**2 - y**2*(7 + 5*z**2))*SorH(7,r) + 3*(-3 + 5*y**2)*z**2*SorH(8,r)*sqrt(3) + r*((x**2*(3 - 7*y**2) - 3*z**2 + 7*y**2*(1 - y**2 + z**2))*SorH(7,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((3 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (z*((-2 + x**2*(3 - 15*y**2) - 6*z**2 - 15*y**2*(-1 + y**2 - 2*z**2))*SorH(8,r) + 2*(2 - 3*x**2 + 15*(-1 + x**2)*y**2 + 15*y**4)*SorH(7,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + 2*z**2 + y**2*(-5 + 7*y**2 - 14*z**2))*SorH(8,r,1) + 2*(5*y**2 - 7*y**4 + x**2*(1 - 7*y**2))*SorH(7,r,1)*sqrt(3) + r*y**2*(-((x**2 + y**2 - 2*z**2)*SorH(8,r,2)) + 2*(x**2 + y**2)*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*((2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 15*y**2*(1 + z**2))*SorH(7,r) + 3*(-1 + 5*y**2)*z**2*SorH(8,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - z**2 + y**2*(5 - 7*y**2 + 7*z**2))*SorH(7,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*((1 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (z*(2*(2 + 3*x**2 - 15*(1 + x**2)*y**2 + 15*y**4)*SorH(7,r) + (-2 - 3*x**2 + 15*(1 + x**2)*y**2 - 15*y**4)*SorH(8,r)*sqrt(3) + r*(2*(5*y**2 - 7*y**4 + x**2*(-1 + 7*y**2))*SorH(7,r,1) + (x**2 - (5 + 7*x**2)*y**2 + 7*y**4)*SorH(8,r,1)*sqrt(3) + r*y**2*(-x**2 + y**2)*(2*SorH(7,r,2) - SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*y**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x*y**2*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*y*((6 - 8*y**2)*SorH(5,r) + (-6 + 8*y**2)*SorH(6,r) + r*((-3 + 5*y**2)*SorH(5,r,1) + (3 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (2*(-1 + 4*y**2)*(-1 + y**2 + z**2)*SorH(5,r) + 2*x**2*(-1 + 4*y**2)*SorH(6,r) + r*((z**2 - 5*y**2*(-1 + y**2 + z**2))*SorH(5,r,1) + x**2*(1 - 5*y**2)*SorH(6,r,1) + r*y**2*((y**2 + z**2)*SorH(5,r,2) + x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (y*(3*(2 + 5*y**4 + x**2*(3 - 5*y**2) - 3*z**2 + y**2*(-7 + 5*z**2))*SorH(7,r) + 3*x**2*(-3 + 5*y**2)*SorH(8,r)*sqrt(3) + r*((x**2*(-3 + 7*y**2) + 3*z**2 - 7*y**2*(-1 + y**2 + z**2))*SorH(7,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((3 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*y**2)*SorH(7,r) + 3*(-3 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*SorH(7,r,1) + (3 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(x*((2 + 3*x**2*(-1 + 5*y**2) + 6*z**2 + 15*y**2*(-1 + y**2 - 2*z**2))*SorH(8,r) + 6*(-1 + 5*y**2)*z**2*SorH(7,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - 2*z**2 + y**2*(5 - 7*y**2 + 14*z**2))*SorH(8,r,1) + 2*(1 - 7*y**2)*z**2*SorH(7,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (z*((2 + x**2*(3 - 15*y**2) - 3*z**2 + 15*y**2*(-1 + y**2 + z**2))*SorH(7,r) + 3*x**2*(-1 + 5*y**2)*SorH(8,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + z**2 + y**2*(5 - 7*y**2 - 7*z**2))*SorH(7,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((1 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*((8 - 6*z**2 + 30*y**2*(-2 + 2*y**2 + z**2))*SorH(7,r) + (-2 - 3*x**2 + 15*(1 + x**2)*y**2 - 15*y**4)*SorH(8,r)*sqrt(3) + r*(2*(-14*y**4 + z**2 + y**2*(10 - 7*z**2))*SorH(7,r,1) + (x**2 - (5 + 7*x**2)*y**2 + 7*y**4)*SorH(8,r,1)*sqrt(3) + r*y**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*y*((-6 + 8*y**2)*SorH(9,r) + r*((3 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2*(-1 + 5*y**2) - 3*z**2 + 15*y**2*(1 - y**2 + z**2))*SorH(10,r) + r*(x**2*(1 - 7*y**2) + z**2 + y**2*(-5 + 7*y**2 - 7*z**2))*SorH(10,r,1) + (2 - 15*y**2 + 15*y**4)*SorH(11,r)*sqrt(3) + r*y**2*(r*(x**2 - y**2 + z**2)*SorH(10,r,2) + (5 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*y**2)*SorH(10,r) + 3*(-3 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*SorH(10,r,1) + (3 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (y*(3*(2 + 5*y**4 + x**2*(3 - 5*y**2) - 3*z**2 + y**2*(-7 + 5*z**2))*SorH(10,r) + 3*x**2*(-3 + 5*y**2)*SorH(11,r)*sqrt(3) + r*((x**2*(-3 + 7*y**2) + 3*z**2 - 7*y**2*(-1 + y**2 + z**2))*SorH(10,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((3 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (2*(x**2 + z**2)*(1 - 2*z**2 + 2*y**2*(-5 + 6*y**2 + 6*z**2))*SorH(12,r) + 2*(2*(1 + x**2 - y**2)*(3*y**2 - 6*y**4 + x**2*(-1 + 6*y**2)) + (1 - 2*x**2 + 2*(-5 + 6*x**2)*y**2 + 12*y**4)*z**2)*SorH(13,r) + 6*x**2*SorH(14,r) - 60*x**2*y**2*SorH(14,r) + 72*x**2*y**4*SorH(14,r) + 5*r*x**2*y**2*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 5*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r*z**4*SorH(12,r,1) - 9*r*y**2*z**4*SorH(12,r,1) + r**2*x**2*y**4*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + r**2*y**2*z**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) - 10*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) + 9*r*y**4*SorH(13,r,1) + 18*r*x**2*y**4*SorH(13,r,1) - 9*r*y**6*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) + 5*r*y**2*z**2*SorH(13,r,1) - 9*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) - 2*r**2*x**2*y**4*SorH(13,r,2) + r**2*y**6*SorH(13,r,2) + r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + 15*r*x**2*y**2*SorH(14,r,1) - 27*r*x**2*y**4*SorH(14,r,1) + 3*r**2*x**2*y**4*SorH(14,r,2))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*z*(-4*(-1 + 6*y**2)*(x**2 + z**2)*SorH(12,r) + (-6 + 4*x**2*(-1 + 6*y**2) - 4*z**2 + 12*y**2*(5 - 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 60*y**2*SorH(14,r) + 72*y**4*SorH(14,r) - r*x**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 15*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) + 27*r*y**4*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 15*r*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*y**4*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*y*(2*(3 + 6*x**2*(-1 + 2*y**2) - 12*z**2 + 2*y**2*(-7 + 6*y**2 + 12*z**2))*SorH(12,r) + 48*(1 - 2*y**2)*z**2*SorH(13,r) + 6*(-1 + 2*x**2)*SorH(14,r) + 28*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*y**4*SorH(14,r) - 24*z**2*SorH(14,r) + 48*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 12*r*z**2*SorH(13,r,1) + 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*y**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) - 7*r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 18*r*y**2*z**2*SorH(14,r,1) - r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (y*z*(-2*(3 - 6*z**2 + 2*y**2*(-7 + 6*y**2 + 6*z**2))*SorH(12,r) + (6 + x**2*(36 - 72*y**2) - 12*z**2 + 4*y**2*(-7 + 6*y**2 + 6*z**2))*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 7*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*y**4*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) - 9*r*x**2*SorH(13,r,1) + 7*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 3*r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*y*(2*(-3 - 6*x**2 + 2*(7 + 6*x**2)*y**2 - 12*y**4)*SorH(12,r) + 8*(3 + 6*x**2 - 2*(7 + 6*x**2)*y**2 + 12*y**4)*SorH(13,r) - 18*SorH(14,r) - 36*x**2*SorH(14,r) + 84*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) - 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) - 12*r*x**2*SorH(13,r,1) + 28*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 36*r*y**4*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*y**4*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 21*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (y*z*((-6 + 8*y**2)*SorH(9,r) + r*((3 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (z*((-2 + 3*x**2*(-1 + 5*y**2) - 3*z**2 + 15*y**2*(1 - y**2 + z**2))*SorH(10,r) + r*(x**2*(1 - 7*y**2) + z**2 + y**2*(-5 + 7*y**2 - 7*z**2))*SorH(10,r,1) + (2 - 15*y**2 + 15*y**4)*SorH(11,r)*sqrt(3) + r*y**2*(r*(x**2 - y**2 + z**2)*SorH(10,r,2) + (5 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (y*(3*(2 + 5*y**4 + x**2*(-3 + 5*y**2) + 3*z**2 - y**2*(7 + 5*z**2))*SorH(10,r) + 3*(-3 + 5*y**2)*z**2*SorH(11,r)*sqrt(3) + r*((x**2*(3 - 7*y**2) - 3*z**2 + 7*y**2*(1 - y**2 + z**2))*SorH(10,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((3 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*y**2)*SorH(10,r) + 3*(-3 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*SorH(10,r,1) + (3 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*z*(-4*(-1 + 6*y**2)*(x**2 + z**2)*SorH(12,r) + (-6 + 4*x**2*(-1 + 6*y**2) - 4*z**2 + 12*y**2*(5 - 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) - 60*y**2*SorH(14,r) + 72*y**4*SorH(14,r) - r*x**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 15*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) + 27*r*y**4*SorH(13,r,1) + r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 15*r*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*y**4*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (2*(1 - 2*x**2 + 2*(-5 + 6*x**2)*y**2 + 12*y**4)*(x**2 + z**2)*SorH(12,r) + 2*(2*(-1 + y**2 - z**2)*(6*y**4 + z**2 - 3*y**2*(1 + 2*z**2)) + x**2*(1 - 2*z**2 + 2*y**2*(-5 + 6*y**2 + 6*z**2)))*SorH(13,r) + 6*z**2*SorH(14,r) - 60*y**2*z**2*SorH(14,r) + 72*y**4*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) + 5*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 5*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) + r**2*x**2*y**4*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + 5*r*x**2*y**2*SorH(13,r,1) + 9*r*y**4*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) - 9*r*y**6*SorH(13,r,1) + r*x**2*z**2*SorH(13,r,1) - 10*r*y**2*z**2*SorH(13,r,1) - 9*r*x**2*y**2*z**2*SorH(13,r,1) + 18*r*y**4*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) + r**2*x**2*y**4*SorH(13,r,2) + r**2*y**6*SorH(13,r,2) + r**2*x**2*y**2*z**2*SorH(13,r,2) - 2*r**2*y**4*z**2*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 15*r*y**2*z**2*SorH(14,r,1) - 27*r*y**4*z**2*SorH(14,r,1) + 3*r**2*y**4*z**2*SorH(14,r,2))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(y*z*(2*(3 - 14*y**2 + 12*y**4 + 6*x**2*(-1 + 2*y**2))*SorH(12,r) - 4*(3 + 6*x**2*(-1 + 2*y**2) + 6*z**2 + 2*y**2*(-7 + 6*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 28*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 24*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 14*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 7*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 6*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*y*(-2*(3 - 14*y**2 + 12*y**4 + 6*x**2*(-1 + 2*y**2))*SorH(12,r) + 2*(3 + 6*x**2*(-1 + 2*y**2) + 18*z**2 + 2*y**2*(-7 + 6*y**2 - 18*z**2))*SorH(13,r) - 36*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) - 7*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 3*r*x**2*SorH(13,r,1) + 7*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 9*r*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + 9*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (y*z*((6 + 36*x**2*(-1 + 2*y**2) - 24*z**2 + 4*y**2*(-7 + 6*y**2 + 12*z**2))*SorH(12,r) + 4*(3 + x**2*(18 - 36*y**2) + 6*z**2 + 2*y**2*(-7 + 6*y**2 - 6*z**2))*SorH(13,r) - 18*SorH(14,r) - 36*x**2*SorH(14,r) + 84*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 9*r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + 3*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 18*r*x**2*SorH(13,r,1) + 14*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 18*r*y**4*SorH(13,r,1) - 6*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 6*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 21*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: -(2*(-1 + 4*y**2)*(-1 + x**2 + y**2 - 2*z**2)*SorH(9,r) + r*((x**2 + 5*y**2 - 5*x**2*y**2 - 5*y**4 + 2*(-1 + 5*y**2)*z**2)*SorH(9,r,1) + r*y**2*(x**2 + y**2 - 2*z**2)*SorH(9,r,2)))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(y*(3*(2 - 7*y**2 + 5*y**4 + x**2*(-3 + 5*y**2) + 2*(3 - 5*y**2)*z**2)*SorH(11,r) + 6*(-3 + 5*y**2)*z**2*SorH(10,r)*sqrt(3) + r*((x**2*(3 - 7*y**2) - 6*z**2 - 7*y**2*(-1 + y**2 - 2*z**2))*SorH(11,r,1) + 2*(3 - 7*y**2)*z**2*SorH(10,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (z*((-2 + x**2*(3 - 15*y**2) - 6*z**2 - 15*y**2*(-1 + y**2 - 2*z**2))*SorH(11,r) + 2*(2 - 3*x**2 + 15*(-1 + x**2)*y**2 + 15*y**4)*SorH(10,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + 2*z**2 + y**2*(-5 + 7*y**2 - 14*z**2))*SorH(11,r,1) + 2*(5*y**2 - 7*y**4 + x**2*(1 - 7*y**2))*SorH(10,r,1)*sqrt(3) + r*y**2*(-((x**2 + y**2 - 2*z**2)*SorH(11,r,2)) + 2*(x**2 + y**2)*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(x*((2 + 3*x**2*(-1 + 5*y**2) + 6*z**2 + 15*y**2*(-1 + y**2 - 2*z**2))*SorH(11,r) + 6*(-1 + 5*y**2)*z**2*SorH(10,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - 2*z**2 + y**2*(5 - 7*y**2 + 14*z**2))*SorH(11,r,1) + 2*(1 - 7*y**2)*z**2*SorH(10,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*y*(2*(3 + 6*x**2*(-1 + 2*y**2) - 12*z**2 + 2*y**2*(-7 + 6*y**2 + 12*z**2))*SorH(12,r) + 48*(1 - 2*y**2)*z**2*SorH(13,r) + 6*(-1 + 2*x**2)*SorH(14,r) + 28*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*y**4*SorH(14,r) - 24*z**2*SorH(14,r) + 48*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 12*r*z**2*SorH(13,r,1) + 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*y**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) - 7*r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 18*r*y**2*z**2*SorH(14,r,1) - r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(y*z*(2*(3 - 14*y**2 + 12*y**4 + 6*x**2*(-1 + 2*y**2))*SorH(12,r) - 4*(3 + 6*x**2*(-1 + 2*y**2) + 6*z**2 + 2*y**2*(-7 + 6*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 28*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 24*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 14*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 7*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 6*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (12*(-1 + x**2 + y**2)*(-3*y**2 + 6*y**4 + x**2*(-1 + 6*y**2))*SorH(12,r) + 24*(1 - 2*x**2 + 2*(-5 + 6*x**2)*y**2 + 12*y**4)*z**2*SorH(13,r) + 4*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 40*x**2*y**2*SorH(14,r) + 24*x**4*y**2*SorH(14,r) - 36*y**4*SorH(14,r) + 48*x**2*y**4*SorH(14,r) + 24*y**6*SorH(14,r) - 8*z**2*SorH(14,r) + 16*x**2*z**2*SorH(14,r) + 80*y**2*z**2*SorH(14,r) - 96*x**2*y**2*z**2*SorH(14,r) - 96*y**4*z**2*SorH(14,r) - 16*z**4*SorH(14,r) + 96*y**2*z**4*SorH(14,r) + 3*r*x**4*SorH(12,r,1) + 30*r*x**2*y**2*SorH(12,r,1) - 27*r*x**4*y**2*SorH(12,r,1) + 27*r*y**4*SorH(12,r,1) - 54*r*x**2*y**4*SorH(12,r,1) - 27*r*y**6*SorH(12,r,1) + 3*r**2*x**4*y**2*SorH(12,r,2) + 6*r**2*x**2*y**4*SorH(12,r,2) + 3*r**2*y**6*SorH(12,r,2) + 12*r*x**2*z**2*SorH(13,r,1) + 60*r*y**2*z**2*SorH(13,r,1) - 108*r*x**2*y**2*z**2*SorH(13,r,1) - 108*r*y**4*z**2*SorH(13,r,1) + 12*r**2*x**2*y**2*z**2*SorH(13,r,2) + 12*r**2*y**4*z**2*SorH(13,r,2) + r*x**4*SorH(14,r,1) + 10*r*x**2*y**2*SorH(14,r,1) - 9*r*x**4*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) - 18*r*x**2*y**4*SorH(14,r,1) - 9*r*y**6*SorH(14,r,1) - 4*r*x**2*z**2*SorH(14,r,1) - 20*r*y**2*z**2*SorH(14,r,1) + 36*r*x**2*y**2*z**2*SorH(14,r,1) + 36*r*y**4*z**2*SorH(14,r,1) + 4*r*z**4*SorH(14,r,1) - 36*r*y**2*z**4*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(x*z*((2 - 20*y**2 + 24*y**4 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + (-4 + x**2*(8 - 48*y**2) - 8*z**2 + 8*y**2*(5 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 20*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 8*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 5*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 10*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 5*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: ((4*(-x**4 - 3*y**2 + 6*x**4*y**2 + 9*y**4 - 6*y**6 + (-1 - 2*x**2 + 2*(5 + 6*x**2)*y**2 - 12*y**4)*z**2)*SorH(12,r) + 8*(1 + 2*x**2 - 2*(5 + 6*x**2)*y**2 + 12*y**4)*z**2*SorH(13,r) + 4*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 24*x**4*y**2*SorH(14,r) - 36*y**4*SorH(14,r) + 24*y**6*SorH(14,r) - 4*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + 40*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) - 48*y**4*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 9*r*y**6*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 10*r*y**2*z**2*SorH(12,r,1) - 18*r*x**2*y**2*z**2*SorH(12,r,1) + 18*r*y**4*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) - r**2*y**6*SorH(12,r,2) + 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r**2*y**4*z**2*SorH(12,r,2) - 4*r*x**2*z**2*SorH(13,r,1) + 20*r*y**2*z**2*SorH(13,r,1) + 36*r*x**2*y**2*z**2*SorH(13,r,1) - 36*r*y**4*z**2*SorH(13,r,1) - 4*r**2*x**2*y**2*z**2*SorH(13,r,2) + 4*r**2*y**4*z**2*SorH(13,r,2) - r*x**4*SorH(14,r,1) + 9*r*x**4*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) - 9*r*y**6*SorH(14,r,1) + 2*r*x**2*z**2*SorH(14,r,1) - 10*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) + 18*r*y**4*z**2*SorH(14,r,1) + r**2*y**2*(-x**2 + y**2)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(9,r) + r*((1 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*y**2)*SorH(10,r) + 3*(-3 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*SorH(10,r,1) + (3 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*((2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 15*y**2*(1 + z**2))*SorH(10,r) + 3*(-1 + 5*y**2)*z**2*SorH(11,r)*sqrt(3) + r*((x**2*(1 - 7*y**2) - z**2 + y**2*(5 - 7*y**2 + 7*z**2))*SorH(10,r,1) + r*y**2*(x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*((1 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (z*((2 + x**2*(3 - 15*y**2) - 3*z**2 + 15*y**2*(-1 + y**2 + z**2))*SorH(10,r) + 3*x**2*(-1 + 5*y**2)*SorH(11,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + z**2 + y**2*(5 - 7*y**2 - 7*z**2))*SorH(10,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((1 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (y*z*(-2*(3 - 6*z**2 + 2*y**2*(-7 + 6*y**2 + 6*z**2))*SorH(12,r) + (6 + x**2*(36 - 72*y**2) - 12*z**2 + 4*y**2*(-7 + 6*y**2 + 6*z**2))*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 7*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*y**4*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) - 9*r*x**2*SorH(13,r,1) + 7*r*y**2*SorH(13,r,1) + 27*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 3*r*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 3*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*y*(-2*(3 - 14*y**2 + 12*y**4 + 6*x**2*(-1 + 2*y**2))*SorH(12,r) + 2*(3 + 6*x**2*(-1 + 2*y**2) + 18*z**2 + 2*y**2*(-7 + 6*y**2 - 18*z**2))*SorH(13,r) - 36*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) - 7*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 3*r*x**2*SorH(13,r,1) + 7*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 9*r*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + 9*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(x*z*((2 - 20*y**2 + 24*y**4 + 4*x**2*(-1 + 6*y**2))*SorH(12,r) + (-4 + x**2*(8 - 48*y**2) - 8*z**2 + 8*y**2*(5 - 6*y**2 + 6*z**2))*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 20*y**2*SorH(14,r) + 24*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) + 8*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 5*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 10*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) + 18*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) - 2*r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*y**4*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 5*r*y**2*SorH(14,r,1) - 9*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 2*r*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) + r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (2*(z**2 + 2*y**2*(3 + 6*y**4 - 5*z**2 + y**2*(-9 + 6*z**2)) + x**2*(1 - 2*z**2 + 2*y**2*(-5 + 6*y**2 + 6*z**2)))*SorH(12,r) + 2*(2*x**4*(-1 + 6*y**2) + x**2*(1 + 4*z**2 + 2*y**2*(-5 + 6*y**2 - 12*z**2)) + z**2*(1 - 2*z**2 + 2*y**2*(-5 + 6*y**2 + 6*z**2)))*SorH(13,r) - 12*x**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) + 5*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 9*r*x**2*y**4*SorH(12,r,1) - 9*r*y**6*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 5*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r**2*x**2*y**4*SorH(12,r,2) + r**2*y**6*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + r*x**4*SorH(13,r,1) + 5*r*x**2*y**2*SorH(13,r,1) - 9*r*x**4*y**2*SorH(13,r,1) - 9*r*x**2*y**4*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 5*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) + r**2*x**4*y**2*SorH(13,r,2) + r**2*x**2*y**4*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*z*((6 + 4*x**2*(-1 + 6*y**2) - 8*z**2 + 12*y**2*(-5 + 6*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + 2*x**2*(-1 + 6*y**2) + 2*z**2 - 6*y**2*(-5 + 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 60*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) + r*x**2*SorH(12,r,1) + 15*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 30*r*y**2*SorH(13,r,1) - 18*r*x**2*y**2*SorH(13,r,1) + 54*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) + 2*r**2*x**2*y**2*SorH(13,r,2) - 6*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 15*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*y**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: ((2*(1 + x**2 - y**2)*(-1 + 4*y**2)*SorH(9,r) + r*((x**2 - 5*(1 + x**2)*y**2 + 5*y**4)*SorH(9,r,1) + r*(x - y)*y**2*(x + y)*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (y*(-6*(-3 + 5*y**2)*(2*x**2 + z**2)*SorH(10,r) - 3*(2 - 7*y**2 + 5*y**4 + x**2*(3 - 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*y**2)*(2*x**2 + z**2)*SorH(10,r,1) + (3*x**2 - 7*(1 + x**2)*y**2 + 7*y**4)*SorH(11,r,1)*sqrt(3) + r*y**2*(-2*(2*x**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (z*(2*(2 + 3*x**2 - 15*(1 + x**2)*y**2 + 15*y**4)*SorH(10,r) + (-2 - 3*x**2 + 15*(1 + x**2)*y**2 - 15*y**4)*SorH(11,r)*sqrt(3) + r*(2*(5*y**2 - 7*y**4 + x**2*(-1 + 7*y**2))*SorH(10,r,1) + (x**2 - (5 + 7*x**2)*y**2 + 7*y**4)*SorH(11,r,1)*sqrt(3) + r*y**2*(-x**2 + y**2)*(2*SorH(10,r,2) - SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*((8 - 6*z**2 + 30*y**2*(-2 + 2*y**2 + z**2))*SorH(10,r) + (-2 - 3*x**2 + 15*(1 + x**2)*y**2 - 15*y**4)*SorH(11,r)*sqrt(3) + r*(2*(-14*y**4 + z**2 + y**2*(10 - 7*z**2))*SorH(10,r,1) + (x**2 - (5 + 7*x**2)*y**2 + 7*y**4)*SorH(11,r,1)*sqrt(3) + r*y**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*y*(2*(-3 - 6*x**2 + 2*(7 + 6*x**2)*y**2 - 12*y**4)*SorH(12,r) + 8*(3 + 6*x**2 - 2*(7 + 6*x**2)*y**2 + 12*y**4)*SorH(13,r) - 18*SorH(14,r) - 36*x**2*SorH(14,r) + 84*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) - 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) - 12*r*x**2*SorH(13,r,1) + 28*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 36*r*y**4*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*y**4*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 21*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (y*z*((6 + 36*x**2*(-1 + 2*y**2) - 24*z**2 + 4*y**2*(-7 + 6*y**2 + 12*z**2))*SorH(12,r) + 4*(3 + x**2*(18 - 36*y**2) + 6*z**2 + 2*y**2*(-7 + 6*y**2 - 6*z**2))*SorH(13,r) - 18*SorH(14,r) - 36*x**2*SorH(14,r) + 84*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + 9*r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 27*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + 3*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 18*r*x**2*SorH(13,r,1) + 14*r*y**2*SorH(13,r,1) + 54*r*x**2*y**2*SorH(13,r,1) - 18*r*y**4*SorH(13,r,1) - 6*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 6*r**2*x**2*y**2*SorH(13,r,2) + 2*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 21*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: ((4*(-x**4 - 3*y**2 + 6*x**4*y**2 + 9*y**4 - 6*y**6 + (-1 - 2*x**2 + 2*(5 + 6*x**2)*y**2 - 12*y**4)*z**2)*SorH(12,r) + 8*(1 + 2*x**2 - 2*(5 + 6*x**2)*y**2 + 12*y**4)*z**2*SorH(13,r) + 4*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 24*x**4*y**2*SorH(14,r) - 36*y**4*SorH(14,r) + 24*y**6*SorH(14,r) - 4*z**2*SorH(14,r) - 8*x**2*z**2*SorH(14,r) + 40*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) - 48*y**4*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 9*r*y**6*SorH(12,r,1) + 2*r*x**2*z**2*SorH(12,r,1) - 10*r*y**2*z**2*SorH(12,r,1) - 18*r*x**2*y**2*z**2*SorH(12,r,1) + 18*r*y**4*z**2*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) - r**2*y**6*SorH(12,r,2) + 2*r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r**2*y**4*z**2*SorH(12,r,2) - 4*r*x**2*z**2*SorH(13,r,1) + 20*r*y**2*z**2*SorH(13,r,1) + 36*r*x**2*y**2*z**2*SorH(13,r,1) - 36*r*y**4*z**2*SorH(13,r,1) - 4*r**2*x**2*y**2*z**2*SorH(13,r,2) + 4*r**2*y**4*z**2*SorH(13,r,2) - r*x**4*SorH(14,r,1) + 9*r*x**4*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) - 9*r*y**6*SorH(14,r,1) + 2*r*x**2*z**2*SorH(14,r,1) - 10*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) + 18*r*y**4*z**2*SorH(14,r,1) + r**2*y**2*(-x**2 + y**2)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*z*((6 + 4*x**2*(-1 + 6*y**2) - 8*z**2 + 12*y**2*(-5 + 6*y**2 + 4*z**2))*SorH(12,r) + 4*(-3 + 2*x**2*(-1 + 6*y**2) + 2*z**2 - 6*y**2*(-5 + 6*y**2 + 2*z**2))*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 60*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) + r*x**2*SorH(12,r,1) + 15*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 30*r*y**2*SorH(13,r,1) - 18*r*x**2*y**2*SorH(13,r,1) + 54*r*y**4*SorH(13,r,1) - 2*r*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) + 2*r**2*x**2*y**2*SorH(13,r,2) - 6*r**2*y**4*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 15*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*y**2*(-x**2 + y**2)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (4*(x**4*(-1 + 6*y**2) + (-1 + y**2 + 2*z**2)*(-2*z**2 + 3*y**2*(-1 + 2*y**2 + 4*z**2)) + x**2*(-1 - 4*z**2 + 2*y**2*(5 - 6*y**2 + 12*z**2)))*SorH(12,r) + 8*(4*x**2*(1 - 10*y**2 + 12*y**4) + (1 - 2*x**2 + 2*(-5 + 6*x**2)*y**2 + 12*y**4)*z**2)*SorH(13,r) - 12*x**2*SorH(14,r) - 12*x**4*SorH(14,r) + 36*y**2*SorH(14,r) + 120*x**2*y**2*SorH(14,r) + 72*x**4*y**2*SorH(14,r) - 108*y**4*SorH(14,r) - 144*x**2*y**4*SorH(14,r) + 72*y**6*SorH(14,r) + r*x**4*SorH(12,r,1) - 10*r*x**2*y**2*SorH(12,r,1) - 9*r*x**4*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + 18*r*x**2*y**4*SorH(12,r,1) - 9*r*y**6*SorH(12,r,1) + 4*r*x**2*z**2*SorH(12,r,1) + 20*r*y**2*z**2*SorH(12,r,1) - 36*r*x**2*y**2*z**2*SorH(12,r,1) - 36*r*y**4*z**2*SorH(12,r,1) + 4*r*z**4*SorH(12,r,1) - 36*r*y**2*z**4*SorH(12,r,1) + r**2*x**4*y**2*SorH(12,r,2) - 2*r**2*x**2*y**4*SorH(12,r,2) + r**2*y**6*SorH(12,r,2) + 4*r**2*x**2*y**2*z**2*SorH(12,r,2) + 4*r**2*y**4*z**2*SorH(12,r,2) + 4*r**2*y**2*z**4*SorH(12,r,2) + 80*r*x**2*y**2*SorH(13,r,1) - 144*r*x**2*y**4*SorH(13,r,1) + 4*r*x**2*z**2*SorH(13,r,1) + 20*r*y**2*z**2*SorH(13,r,1) - 36*r*x**2*y**2*z**2*SorH(13,r,1) - 36*r*y**4*z**2*SorH(13,r,1) + 16*r**2*x**2*y**4*SorH(13,r,2) + 4*r**2*x**2*y**2*z**2*SorH(13,r,2) + 4*r**2*y**4*z**2*SorH(13,r,2) + 3*r*x**4*SorH(14,r,1) - 30*r*x**2*y**2*SorH(14,r,1) - 27*r*x**4*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 54*r*x**2*y**4*SorH(14,r,1) - 27*r*y**6*SorH(14,r,1) + 3*r**2*y**2*(x**2 - y**2)**2*SorH(14,r,2))/(4.*r**2), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: y*z*(-(SorH(0,r,1)/r) + SorH(0,r,2)), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: ((-1 + 3*y**2)*z*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y**2*z*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: (y*(-1 + 3*z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y*z**2*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(2,r) + r*(-3*SorH(2,r,1) + r*SorH(2,r,2))))/r**2, \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(3,r) + r*((1 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(3,r) + r*((y**2 + z**2 - 5*y**2*z**2)*SorH(3,r,1) + r*y**2*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (y*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(3,r) + 2*r*SorH(3,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(3,r,1) - r*SorH(3,r,2))))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(3,r) + r*((1 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (y*z*((4 + 8*x**2 - 8*y**2)*SorH(3,r) - 2*r*SorH(3,r,1) + r*(x - y)*(x + y)*(-5*SorH(3,r,1) + r*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*y**2)*z*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y**2*z*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (y*z*((-4 + 8*x**2 + 8*z**2)*SorH(5,r) + (-4 + 8*y**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*z**2)*SorH(5,r,1) + r*(x**2 + z**2)*SorH(5,r,2) + (2 - 5*y**2)*SorH(6,r,1) + r*y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + y**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + y**2*(-1 + 5*z**2))*SorH(5,r,1) + (y**2 + z**2 - 5*y**2*z**2)*SorH(6,r,1) + r*y**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(7,r,1) + r*(x**2 - y**2 + z**2)*SorH(7,r,2) + (2 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (y*((-2 - 3*x**2 + 3*y**2 + 3*(-1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(7,r) + (2 - 6*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(-((x**2 - y**2 + z**2)*(-1 + 7*z**2)*SorH(7,r,1)) + (y**2 + 2*z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*((x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(z*((-4 + 3*y**2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 6*(1 - 5*y**2)*z**2)*SorH(8,r) + 2*(2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(7,r)*sqrt(3) + r*(-((y**2 + 7*y**4 + x**2*(-1 + 7*y**2) + 2*z**2 - 14*y**2*z**2)*SorH(8,r,1)) + 2*(z**2 + y**2*(2 - 7*z**2))*SorH(7,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(7,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(z*(2*(2 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(7,r) + 3*(x**2 - (3 + 5*x**2)*y**2 + 5*y**4)*SorH(8,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(2 - 7*z**2))*SorH(7,r,1) + (-x**2 + (3 + 7*x**2)*y**2 - 7*y**4)*SorH(8,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(7,r,2) + (-x**2 + y**2)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (y*(-1 + 3*z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y*z**2*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + y**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + y**2*(-1 + 5*z**2))*SorH(5,r,1) + (y**2 + z**2 - 5*y**2*z**2)*SorH(6,r,1) + r*y**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (y*z*((-4 + 8*x**2 + 8*y**2)*SorH(5,r) + (-4 + 8*z**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*y**2)*SorH(5,r,1) + r*(x**2 + y**2)*SorH(5,r,2) + (2 - 5*z**2)*SorH(6,r,1) + r*z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(7,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (z*((-2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 3*y**2*(1 + 5*z**2))*SorH(7,r) + (2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(x**2 + y**2 - z**2)*SorH(7,r,1)) + (z**2 + y**2*(2 - 7*z**2))*SorH(8,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (y*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(8,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(7,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(8,r,1) + 2*r*z**4*SorH(8,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(8,r,2) + 2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(7,r) + 3*(-2 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(7,r,1) + r*(x**2 + y**2 - z**2)*SorH(7,r,2) + (2 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (y*(2*(2 + 3*x**2 - 3*y**2 - 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(7,r) + (-2 - 3*x**2 + 3*y**2 + 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (2 + 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1) + (x**2 - y**2 + (-2 - 7*x**2 + 7*y**2)*z**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(4,r) + r*(-3*SorH(4,r,1) + r*SorH(4,r,2))))/r**2, \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (y*z*(8*(-1 + y**2 + z**2)*SorH(5,r) + 8*x**2*SorH(6,r) + r*((4 - 5*y**2 - 5*z**2)*SorH(5,r,1) + r*(y**2 + z**2)*SorH(5,r,2) + x**2*(-5*SorH(6,r,1) + r*SorH(6,r,2)))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (z*((2 + x**2*(3 - 15*y**2) - 3*z**2 + 15*y**2*(-1 + y**2 + z**2))*SorH(7,r) + 3*x**2*(-1 + 5*y**2)*SorH(8,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + z**2 + y**2*(5 - 7*y**2 - 7*z**2))*SorH(7,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((1 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(7,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(8,r) + 6*(-2 + 5*z**2)*SorH(7,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(8,r,1)) + 2*(2 - 7*z**2)*SorH(7,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (y*((2 + 3*x**2 - 3*y**2 - 15*(1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(7,r) + 3*x**2*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((-x**2 + y**2 + (5 + 7*x**2 - 7*y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((1 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*y*z*(6*(-6 + 10*y**2 + 5*z**2)*SorH(7,r) + 3*(2 + 5*x**2 - 5*y**2)*SorH(8,r)*sqrt(3) + r*(-2*(-6 + 14*y**2 + 7*z**2)*SorH(7,r,1) + 2*r*(2*y**2 + z**2)*SorH(7,r,2) + (-2 - 7*x**2 + 7*y**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,2)*sqrt(3))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(9,r) + r*((1 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(10,r,1) + r*(x**2 - y**2 + z**2)*SorH(10,r,2) + (2 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(10,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (z*((2 + x**2*(3 - 15*y**2) - 3*z**2 + 15*y**2*(-1 + y**2 + z**2))*SorH(10,r) + 3*x**2*(-1 + 5*y**2)*SorH(11,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + z**2 + y**2*(5 - 7*y**2 - 7*z**2))*SorH(10,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((1 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(1 - 2*y**2 + 6*(-1 + y**2)*z**2 + 6*z**4 + x**2*(-4 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 + 6*x**4 - 2*z**2 + 6*y**2*(-1 + y**2 + z**2) + x**2*(2 - 12*y**2 + 6*z**2))*SorH(13,r) - 24*x**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 9*r*z**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + r**2*z**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 6*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + x**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 - 2*x**2 + 6*y**2 + 6*(1 + 2*x**2 - 6*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*z*(4*(-1 + 6*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 2*z**2 + 4*y**2*(-1 + 3*z**2))*SorH(13,r) + 4*(1 + x**2)*SorH(14,r) - 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*y**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*y**2*z**2*SorH(13,r,2) - r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*y**2*z**2*SorH(14,r,1) - r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + y**4*(4 - 24*z**2) - 3*y**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*x**2 + 3*y**2 + 12*x**2*y**2 - 4*y**4 + 3*(1 + 4*x**2 - 8*(1 + 3*x**2)*y**2 + 8*y**4)*z**2 + 4*(-1 + 6*y**2)*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*y**4*SorH(12,r,1) - 6*r*y**2*z**2*SorH(12,r,1) + 9*r*y**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*y**2*z**4*SorH(12,r,1) - r**2*y**4*z**2*SorH(12,r,2) - r**2*y**2*z**4*SorH(12,r,2) - 3*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(-1 + 6*y**2))*SorH(12,r) + 16*(x**2 - 3*(1 + 2*x**2)*y**2 + 6*y**4)*SorH(13,r) - 12*x**2*SorH(14,r) + 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) + 12*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 36*r*y**4*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*y**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(9,r) + r*((y**2 + z**2 - 5*y**2*z**2)*SorH(9,r,1) + r*y**2*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (y*((-2 - 3*x**2 + 3*y**2 + 3*(-1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(10,r) + (2 - 6*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(-((x**2 - y**2 + z**2)*(-1 + 7*z**2)*SorH(10,r,1)) + (y**2 + 2*z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*((x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (z*((-2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 3*y**2*(1 + 5*z**2))*SorH(10,r) + (2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(x**2 + y**2 - z**2)*SorH(10,r,1)) + (z**2 + y**2*(2 - 7*z**2))*SorH(11,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(10,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + x**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 - 2*x**2 + 6*y**2 + 6*(1 + 2*x**2 - 6*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(1 + 6*x**4 - 2*z**2 + y**2*(-2 + 6*z**2) + x**2*(-4 + 6*y**2 + 6*z**2))*SorH(12,r) + 8*(-1 + 3*(y**2 - z**2)**2 + x**2*(-2 + 3*y**2 + 3*z**2))*SorH(13,r) + 12*SorH(14,r) - 24*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + r*x**2*(4 - 9*x**2)*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 4*r*x**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(((y**2*(3 - 4*y**2 + 12*(-1 + 2*y**2)*z**2) + x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) - 2*(x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + x**2*SorH(14,r) + 3*y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 6*z**2*SorH(14,r) - 4*x**2*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 24*y**4*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*y**2*z**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 3*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) - 2*r*x**2*y**2*SorH(13,r,1) - 2*r*y**4*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 18*r*y**4*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*y**2*z**4*SorH(13,r,1) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) - 2*r**2*y**4*z**2*SorH(13,r,2) + 2*r**2*y**2*z**4*SorH(13,r,2) + r*x**2*y**2*SorH(14,r,1) + r*y**4*SorH(14,r,1) + r*x**2*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 9*r*y**4*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*y**2*z**4*SorH(14,r,1) + r**2*y**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(1 - 6*y**2))*SorH(12,r) + 2*(-3 + 2*x**2*(-1 + 6*y**2) + 6*z**2 + 6*y**2*(1 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*y**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: ((3*y**2 - 4*y**4 + 6*(1 - 6*y**2 + 4*y**4)*z**2 + 8*(-1 + 6*y**2)*z**4 + 3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) + 2*(-3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 36*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - 72*y**4*z**2*SorH(14,r) + 3*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - 27*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) - 18*r*y**2*z**4*SorH(12,r,1) + 3*r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + 2*r**2*y**2*z**4*SorH(12,r,2) - 6*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 6*r*x**2*z**2*SorH(13,r,1) + 54*r*x**2*y**2*z**2*SorH(13,r,1) - 18*r*y**4*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 18*r*y**2*z**4*SorH(13,r,1) - 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*y**4*z**2*SorH(13,r,2) - 2*r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) - 3*r*y**4*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 27*r*y**4*z**2*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (y*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(9,r) + 2*r*SorH(9,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(9,r,1) - r*SorH(9,r,2))))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(z*((-4 + 3*y**2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 6*(1 - 5*y**2)*z**2)*SorH(11,r) + 2*(2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(10,r)*sqrt(3) + r*(-((y**2 + 7*y**4 + x**2*(-1 + 7*y**2) + 2*z**2 - 14*y**2*z**2)*SorH(11,r,1)) + 2*(z**2 + y**2*(2 - 7*z**2))*SorH(10,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (y*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(11,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(10,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(11,r,1) + 2*r*z**4*SorH(11,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(11,r,2) + 2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(11,r) + 6*(-2 + 5*z**2)*SorH(10,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(11,r,1)) + 2*(2 - 7*z**2)*SorH(10,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(-1 + 6*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 2*z**2 + 4*y**2*(-1 + 3*z**2))*SorH(13,r) + 4*(1 + x**2)*SorH(14,r) - 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*y**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*y**2*z**2*SorH(13,r,2) - r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*y**2*z**2*SorH(14,r,1) - r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(((y**2*(3 - 4*y**2 + 12*(-1 + 2*y**2)*z**2) + x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) - 2*(x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + x**2*SorH(14,r) + 3*y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 6*z**2*SorH(14,r) - 4*x**2*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 24*y**4*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*y**2*z**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 3*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) - 2*r*x**2*y**2*SorH(13,r,1) - 2*r*y**4*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 18*r*y**4*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*y**2*z**4*SorH(13,r,1) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) - 2*r**2*y**4*z**2*SorH(13,r,2) + 2*r**2*y**2*z**4*SorH(13,r,2) + r*x**2*y**2*SorH(14,r,1) + r*y**4*SorH(14,r,1) + r*x**2*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 9*r*y**4*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*y**2*z**4*SorH(14,r,1) + r**2*y**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (y*z*(24*(x**2 + y**2)*(-2 + 3*x**2 + 3*y**2)*SorH(12,r) + 48*(1 - 2*x**2 - 2*y**2 + 2*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(13,r) - 16*SorH(14,r) + 16*x**2*SorH(14,r) + 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 48*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 32*z**2*SorH(14,r) - 96*x**2*z**2*SorH(14,r) - 96*y**2*z**2*SorH(14,r) + 96*z**4*SorH(14,r) + 12*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + 12*r*y**2*SorH(12,r,1) - 54*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + 6*r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 24*r*x**2*SorH(13,r,1) + 24*r*y**2*SorH(13,r,1) + 24*r*z**2*SorH(13,r,1) - 108*r*x**2*z**2*SorH(13,r,1) - 108*r*y**2*z**2*SorH(13,r,1) + 12*r**2*x**2*z**2*SorH(13,r,2) + 12*r**2*y**2*z**2*SorH(13,r,2) - 4*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 18*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 8*r*z**2*SorH(14,r,1) + 36*r*x**2*z**2*SorH(14,r,1) + 36*r*y**2*z**2*SorH(14,r,1) - 36*r*z**4*SorH(14,r,1) + r**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2)))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (y*z*(8*(1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(-1 - 2*x**2 + 2*y**2 + 2*(1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) - 8*SorH(14,r) - 16*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 24*y**4*SorH(14,r) + 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 8*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 4*r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(9,r) + r*((1 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(10,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(10,r) + 3*(-2 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(10,r,1) + r*(x**2 + y**2 - z**2)*SorH(10,r,2) + (2 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (y*((2 + 3*x**2 - 3*y**2 - 15*(1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(10,r) + 3*x**2*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((-x**2 + y**2 + (5 + 7*x**2 - 7*y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((1 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + y**4*(4 - 24*z**2) - 3*y**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*x**2 + 3*y**2 + 12*x**2*y**2 - 4*y**4 + 3*(1 + 4*x**2 - 8*(1 + 3*x**2)*y**2 + 8*y**4)*z**2 + 4*(-1 + 6*y**2)*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*y**4*SorH(12,r,1) - 6*r*y**2*z**2*SorH(12,r,1) + 9*r*y**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*y**2*z**4*SorH(12,r,1) - r**2*y**4*z**2*SorH(12,r,2) - r**2*y**2*z**4*SorH(12,r,2) - 3*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(1 - 6*y**2))*SorH(12,r) + 2*(-3 + 2*x**2*(-1 + 6*y**2) + 6*z**2 + 6*y**2*(1 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*y**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (y*z*(4*(1 - 2*z**2 + 6*y**2*(-1 + y**2 + z**2) + x**2*(-4 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 + 6*x**4 - 2*y**2 + 6*(-1 + y**2)*z**2 + 6*z**4 + 2*x**2*(1 + 3*y**2 - 6*z**2))*SorH(13,r) - 24*x**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) + 6*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*y*(2*(3 - 2*x**2 - 6*y**2 + 12*(-2 + x**2 + 3*y**2)*z**2 + 24*z**4)*SorH(12,r) + 4*(-3 - 2*x**2 + 6*y**2 + 6*(3 + 2*x**2 - 6*y**2)*z**2 - 12*z**4)*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) - 72*x**2*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 27*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + 3*r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) + 54*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) + 2*r**2*x**2*z**2*SorH(13,r,2) - 6*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) + 27*r*x**2*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(-x**2 + y**2)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (y*z*((4 + 8*x**2 - 8*y**2)*SorH(9,r) - 2*r*SorH(9,r,1) + r*(x - y)*(x + y)*(-5*SorH(9,r,1) + r*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: -(z*(2*(2 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(10,r) + 3*(x**2 - (3 + 5*x**2)*y**2 + 5*y**4)*SorH(11,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(2 - 7*z**2))*SorH(10,r,1) + (-x**2 + (3 + 7*x**2)*y**2 - 7*y**4)*SorH(11,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(10,r,2) + (-x**2 + y**2)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (y*(2*(2 + 3*x**2 - 3*y**2 - 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(10,r) + (-2 - 3*x**2 + 3*y**2 + 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (2 + 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1) + (x**2 - y**2 + (-2 - 7*x**2 + 7*y**2)*z**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(-6 + 10*y**2 + 5*z**2)*SorH(10,r) + 3*(2 + 5*x**2 - 5*y**2)*SorH(11,r)*sqrt(3) + r*(-2*(-6 + 14*y**2 + 7*z**2)*SorH(10,r,1) + 2*r*(2*y**2 + z**2)*SorH(10,r,2) + (-2 - 7*x**2 + 7*y**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,2)*sqrt(3))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(-1 + 6*y**2))*SorH(12,r) + 16*(x**2 - 3*(1 + 2*x**2)*y**2 + 6*y**4)*SorH(13,r) - 12*x**2*SorH(14,r) + 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) + 12*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 36*r*y**4*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*y**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: ((3*y**2 - 4*y**4 + 6*(1 - 6*y**2 + 4*y**4)*z**2 + 8*(-1 + 6*y**2)*z**4 + 3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) + 2*(-3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 36*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - 72*y**4*z**2*SorH(14,r) + 3*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - 27*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) - 18*r*y**2*z**4*SorH(12,r,1) + 3*r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + 2*r**2*y**2*z**4*SorH(12,r,2) - 6*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 6*r*x**2*z**2*SorH(13,r,1) + 54*r*x**2*y**2*z**2*SorH(13,r,1) - 18*r*y**4*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 18*r*y**2*z**4*SorH(13,r,1) - 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*y**4*z**2*SorH(13,r,2) - 2*r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) - 3*r*y**4*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 27*r*y**4*z**2*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (y*z*(8*(1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(-1 - 2*x**2 + 2*y**2 + 2*(1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) - 8*SorH(14,r) - 16*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 24*y**4*SorH(14,r) + 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 8*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 4*r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*y*(2*(3 - 2*x**2 - 6*y**2 + 12*(-2 + x**2 + 3*y**2)*z**2 + 24*z**4)*SorH(12,r) + 4*(-3 - 2*x**2 + 6*y**2 + 6*(3 + 2*x**2 - 6*y**2)*z**2 - 12*z**4)*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) - 72*x**2*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 27*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + 3*r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) + 54*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) + 2*r**2*x**2*z**2*SorH(13,r,2) - 6*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) + 27*r*x**2*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(-x**2 + y**2)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (y*z*(8*(2 + 3*x**4 - 6*y**2 - 12*z**2 - 2*x**2*(1 + 3*y**2 - 6*z**2) + 3*(y**2 + 2*z**2)**2)*SorH(12,r) + 16*(1 - 2*z**2 + 2*x**2*(-5 + 12*y**2 + 3*z**2) + y**2*(-2 + 6*z**2))*SorH(13,r) + 48*x**2*SorH(14,r) + 72*x**4*SorH(14,r) - 48*y**2*SorH(14,r) - 144*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) + 4*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 12*r*y**2*SorH(12,r,1) + 18*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 24*r*z**2*SorH(12,r,1) - 36*r*x**2*z**2*SorH(12,r,1) - 36*r*y**2*z**2*SorH(12,r,1) - 36*r*z**4*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - 2*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 4*r**2*x**2*z**2*SorH(12,r,2) + 4*r**2*y**2*z**2*SorH(12,r,2) + 4*r**2*z**4*SorH(12,r,2) + 40*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) - 144*r*x**2*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) - 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) + 16*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) - 12*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) + 12*r*y**2*SorH(14,r,1) + 54*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*SorH(14,r,2)))/(4.*r**2), \
},
],\
[\
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: x*z*(-(SorH(0,r,1)/r) + SorH(0,r,2)), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(2,r) + r*(-3*SorH(2,r,1) + r*SorH(2,r,2))))/r**2, \
	(0,0,1,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x*z**2*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*z*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x**2*z*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(3,r) + r*((1 - 5*x**2)*SorH(3,r,1) + r*x**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(3,r) + r*((1 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (x*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(3,r) + 2*r*SorH(3,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(3,r,1) - r*SorH(3,r,2))))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(3,r) + r*((x**2 + z**2 - 5*x**2*z**2)*SorH(3,r,1) + r*x**2*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*x**2 - 8*y**2)*SorH(3,r) + 2*r*SorH(3,r,1) + r*(x - y)*(x + y)*(-5*SorH(3,r,1) + r*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(4,r) + r*(-3*SorH(4,r,1) + r*SorH(4,r,2))))/r**2, \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (x*z*(8*(-1 + x**2 + z**2)*SorH(5,r) + 8*y**2*SorH(6,r) + r*((4 - 5*x**2 - 5*z**2)*SorH(5,r,1) + r*(x**2 + z**2)*SorH(5,r,2) + y**2*(-5*SorH(6,r,1) + r*SorH(6,r,2)))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (z*((2 + 3*y**2 - 3*z**2 + 15*x**2*(-1 + x**2 - y**2 + z**2))*SorH(7,r) + 3*(-1 + 5*x**2)*y**2*SorH(8,r)*sqrt(3) + r*((-7*x**4 - y**2 + z**2 + x**2*(5 + 7*y**2 - 7*z**2))*SorH(7,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((1 - 7*x**2)*SorH(8,r,1) + r*x**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (x*((2 - 3*x**2 + 3*y**2 + 15*(-1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(7,r) + 3*y**2*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((x**2 - y**2 + (5 - 7*x**2 + 7*y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((1 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(8,r) + 6*(-2 + 5*z**2)*SorH(7,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(8,r,1)) + 2*(2 - 7*z**2)*SorH(7,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(7,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: (x*y*z*(-6*(-6 + 10*x**2 + 5*z**2)*SorH(7,r) + 3*(-2 + 5*x**2 - 5*y**2)*SorH(8,r)*sqrt(3) + r*(2*(-6 + 14*x**2 + 7*z**2)*SorH(7,r,1) - 2*r*(2*x**2 + z**2)*SorH(7,r,2) + (2 - 7*x**2 + 7*y**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,2)*sqrt(3))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x*z**2*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*x**2 + 8*y**2)*SorH(5,r) + (-4 + 8*z**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*y**2)*SorH(5,r,1) + r*(x**2 + y**2)*SorH(5,r,2) + (2 - 5*z**2)*SorH(6,r,1) + r*z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + x**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + x**2*(-1 + 5*z**2))*SorH(5,r,1) + (x**2 + z**2 - 5*x**2*z**2)*SorH(6,r,1) + r*x**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(7,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(7,r) + 3*(-2 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(7,r,1) + r*(x**2 + y**2 - z**2)*SorH(7,r,2) + (2 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(8,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(7,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(8,r,1) + 2*r*z**4*SorH(8,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(8,r,2) + 2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (z*((-2 - 3*y**2 + 3*z**2 + 3*x**2*(-1 + 5*x**2 + 5*y**2 - 5*z**2))*SorH(7,r) + (2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 + y**2 - z**2)*SorH(7,r,1)) + (z**2 + x**2*(2 - 7*z**2))*SorH(8,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (x*(2*(-2 + 3*x**2 - 3*y**2 + 3*(2 - 5*x**2 + 5*y**2)*z**2)*SorH(7,r) + (2 - 3*x**2 + 3*y**2 + 3*(-2 + 5*x**2 - 5*y**2)*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (-2 + 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1) + (x**2 - y**2 + (2 - 7*x**2 + 7*y**2)*z**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*x**2)*z*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x**2*z*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (y*z*((2 - 8*x**2)*SorH(5,r) + (-2 + 8*x**2)*SorH(6,r) + r*((-1 + 5*x**2)*SorH(5,r,1) + (1 - 5*x**2)*SorH(6,r,1) + r*x**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + x**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + x**2*(-1 + 5*z**2))*SorH(5,r,1) + (x**2 + z**2 - 5*x**2*z**2)*SorH(6,r,1) + r*x**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*y**2 + 8*z**2)*SorH(5,r) + (-4 + 8*x**2)*SorH(6,r) + r*((2 - 5*y**2 - 5*z**2)*SorH(5,r,1) + r*(y**2 + z**2)*SorH(5,r,2) + (2 - 5*x**2)*SorH(6,r,1) + r*x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*x**2)*SorH(8,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(7,r,1) + r*(-x**2 + y**2 + z**2)*SorH(7,r,2) + (2 - 7*x**2)*SorH(8,r,1)*sqrt(3) + r*x**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(7,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(z*((-4 - 3*y**2 + 6*z**2 + 3*x**2*(1 + 5*x**2 + 5*y**2 - 10*z**2))*SorH(8,r) + 2*(2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(7,r)*sqrt(3) + r*(-((7*x**4 - y**2 + 2*z**2 + x**2*(1 + 7*y**2 - 14*z**2))*SorH(8,r,1)) + 2*(z**2 + x**2*(2 - 7*z**2))*SorH(7,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 - 3*y**2 - 3*(1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(7,r) + (2 - 6*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*((x**2 - y**2 - z**2)*(-1 + 7*z**2)*SorH(7,r,1) + (x**2 + 2*z**2 - 7*x**2*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*((-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (z*(2*(2 - 6*y**2 - 3*z**2 + 3*x**2*(-2 + 10*y**2 + 5*z**2))*SorH(7,r) + 3*(5*x**4 + y**2 - x**2*(3 + 5*y**2))*SorH(8,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(2 - 14*y**2 - 7*z**2))*SorH(7,r,1) - (y**2 + x**2*(-3 + 7*x**2 - 7*y**2))*SorH(8,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (y*z*((-2 + 8*x**2)*SorH(9,r) + r*((1 - 5*x**2)*SorH(9,r,1) + r*x**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (z*((2 + 3*y**2 - 3*z**2 + 15*x**2*(-1 + x**2 - y**2 + z**2))*SorH(10,r) + 3*(-1 + 5*x**2)*y**2*SorH(11,r)*sqrt(3) + r*((-7*x**4 - y**2 + z**2 + x**2*(5 + 7*y**2 - 7*z**2))*SorH(10,r,1) + r*x**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((1 - 7*x**2)*SorH(11,r,1) + r*x**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(10,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(-x**2 + y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*x**2)*SorH(11,r)*sqrt(3) + r*(7*(x**2 - y**2 - z**2)*SorH(10,r,1) + r*(-x**2 + y**2 + z**2)*SorH(10,r,2) + (2 - 7*x**2)*SorH(11,r,1)*sqrt(3) + r*x**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(1 - 4*y**2 + 6*(-1 + y**2)*z**2 + 6*z**4 + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 + 2*y**2 - 2*z**2 + 6*(x**4 + x**2*(-1 - 2*y**2 + z**2) + y**2*(y**2 + z**2)))*SorH(13,r) - 24*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 9*r*z**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + r**2*z**4*SorH(12,r,2) + 6*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*y**2 + 3*(1 + 4*y**2)*z**2 - 4*z**4 + 4*x**4*(-1 + 6*z**2) + 3*x**2*(1 + 4*y**2 - 8*(1 + 3*y**2)*z**2 + 8*z**4))*SorH(13,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - r**2*x**2*z**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + 6*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + r**2*x**4*z**2*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (y*z*(4*(-1 + 6*x**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 4*x**2 + 2*(-1 + 6*x**2)*z**2)*SorH(13,r) + 4*SorH(14,r) - 4*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 8*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) - r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + y**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*x**2 - 2*y**2 + 6*(1 - 6*x**2 + 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - r*y**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*y**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) - 3*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (y*z*(4*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(12,r) - 16*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 12*r*x**2*SorH(13,r,1) + 36*r*x**4*SorH(13,r,1) + 4*r*y**2*SorH(13,r,1) - 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**4*SorH(13,r,2) + 4*r**2*x**2*y**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(9,r) + r*((1 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (x*((2 - 3*x**2 + 3*y**2 + 15*(-1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(10,r) + 3*y**2*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((x**2 - y**2 + (5 - 7*x**2 + 7*y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((1 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(10,r) + 3*(-2 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(10,r,1) + r*(x**2 + y**2 - z**2)*SorH(10,r,2) + (2 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(10,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*y**2 + 3*(1 + 4*y**2)*z**2 - 4*z**4 + 4*x**4*(-1 + 6*z**2) + 3*x**2*(1 + 4*y**2 - 8*(1 + 3*y**2)*z**2 + 8*z**4))*SorH(13,r) + 3*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 6*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - r**2*x**2*z**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) - 3*r*x**2*y**2*SorH(13,r,1) + 6*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) - 3*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + r**2*x**4*z**2*SorH(13,r,2) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (x*z*(4*(1 + 6*x**4 - 2*z**2 + 6*x**2*(-1 + y**2 + z**2) + y**2*(-4 + 6*z**2))*SorH(12,r) + 4*(1 + 2*y**2 - 6*z**2 + 6*(y**2 - z**2)**2 + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(13,r) - 24*y**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + 3*r*x**2*(2 - 3*x**2)*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + y**2 + x**2*(3 - 6*y**2))*SorH(12,r) + 2*(-3 - 2*y**2 + 6*z**2 + 6*x**2*(1 + 2*x**2 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (x*y*(2*(3 - 6*x**2 - 2*y**2 + 12*(-2 + 3*x**2 + y**2)*z**2 + 24*z**4)*SorH(12,r) - 4*(3 - 6*x**2 + 2*y**2 + 6*(-3 + 6*x**2 - 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 72*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 27*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + 3*r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) + 54*r*x**2*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) - 6*r**2*x**2*z**2*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(x - y)*(x + y)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (x*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(9,r) + 2*r*SorH(9,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(9,r,1) - r*SorH(9,r,2))))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(11,r) + 6*(-2 + 5*z**2)*SorH(10,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(11,r,1)) + 2*(2 - 7*z**2)*SorH(10,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(11,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(10,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(11,r,1) + 2*r*z**4*SorH(11,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(11,r,2) + 2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(z*((-4 - 3*y**2 + 6*z**2 + 3*x**2*(1 + 5*x**2 + 5*y**2 - 10*z**2))*SorH(11,r) + 2*(2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(10,r)*sqrt(3) + r*(-((7*x**4 - y**2 + 2*z**2 + x**2*(1 + 7*y**2 - 14*z**2))*SorH(11,r,1)) + 2*(z**2 + x**2*(2 - 7*z**2))*SorH(10,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(-1 + 6*x**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 4*x**2 + 2*(-1 + 6*x**2)*z**2)*SorH(13,r) + 4*SorH(14,r) - 4*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 8*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) + 7*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) - r**2*x**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (x*z*(24*(x**2 + y**2)*(-2 + 3*x**2 + 3*y**2)*SorH(12,r) + 48*(1 - 2*x**2 - 2*y**2 + 2*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(13,r) - 16*SorH(14,r) + 16*x**2*SorH(14,r) + 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 48*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 32*z**2*SorH(14,r) - 96*x**2*z**2*SorH(14,r) - 96*y**2*z**2*SorH(14,r) + 96*z**4*SorH(14,r) + 12*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + 12*r*y**2*SorH(12,r,1) - 54*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + 6*r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 24*r*x**2*SorH(13,r,1) + 24*r*y**2*SorH(13,r,1) + 24*r*z**2*SorH(13,r,1) - 108*r*x**2*z**2*SorH(13,r,1) - 108*r*y**2*z**2*SorH(13,r,1) + 12*r**2*x**2*z**2*SorH(13,r,2) + 12*r**2*y**2*z**2*SorH(13,r,2) - 4*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 18*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 8*r*z**2*SorH(14,r,1) + 36*r*x**2*z**2*SorH(14,r,1) + 36*r*y**2*z**2*SorH(14,r,1) - 36*r*z**4*SorH(14,r,1) + r**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2)))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(((y**2 + x**2*(3 - 4*x**2 - 4*y**2) + 4*(6*x**4 - y**2 + x**2*(-3 + 6*y**2))*z**2)*SorH(12,r) - 2*(y**2 - (3 + 4*y**2)*z**2 + 4*z**4 + 4*x**4*(-1 + 6*z**2) + x**2*(3 - 24*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 3*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 6*z**2*SorH(14,r) + 12*x**2*z**2*SorH(14,r) + 24*x**4*z**2*SorH(14,r) - 4*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*x**2*z**4*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + r*x**4*SorH(14,r,1) + r*x**2*y**2*SorH(14,r,1) - 3*r*x**2*z**2*SorH(14,r,1) - 9*r*x**4*z**2*SorH(14,r,1) + r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*x**2*z**4*SorH(14,r,1) + r**2*x**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (x*z*(8*(-1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(1 - 2*x**2 + 2*y**2 + 2*(-1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) + 8*SorH(14,r) - 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 8*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 4*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) - 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + x**2*(-2 + 8*z**2))*SorH(9,r) + r*((x**2 + z**2 - 5*x**2*z**2)*SorH(9,r,1) + r*x**2*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (y*((-2 + 6*z**2 + x**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + x**2*(-1 + 7*z**2))*SorH(10,r,1) + (x**2 + z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*x**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (z*((-2 - 3*y**2 + 3*z**2 + 3*x**2*(-1 + 5*x**2 + 5*y**2 - 5*z**2))*SorH(10,r) + (2 - 3*z**2 + 3*x**2*(-2 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*x**2)*(x**2 + y**2 - z**2)*SorH(10,r,1)) + (z**2 + x**2*(2 - 7*z**2))*SorH(11,r,1)*sqrt(3) + r*x**2*((x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (x*((-2 + 3*x**2 - 3*y**2 - 3*(1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(10,r) + (2 - 6*z**2 + 3*x**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*((x**2 - y**2 - z**2)*(-1 + 7*z**2)*SorH(10,r,1) + (x**2 + 2*z**2 - 7*x**2*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*((-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + y**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 + 6*x**2 - 2*y**2 + 6*(1 - 6*x**2 + 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - r*y**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*y**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) - 3*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(-6*x**4 + y**2 + x**2*(3 - 6*y**2))*SorH(12,r) + 2*(-3 - 2*y**2 + 6*z**2 + 6*x**2*(1 + 2*x**2 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*x**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) + 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) - r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 3*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 3*r**2*x**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(((y**2 + x**2*(3 - 4*x**2 - 4*y**2) + 4*(6*x**4 - y**2 + x**2*(-3 + 6*y**2))*z**2)*SorH(12,r) - 2*(y**2 - (3 + 4*y**2)*z**2 + 4*z**4 + 4*x**4*(-1 + 6*z**2) + x**2*(3 - 24*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 3*x**2*SorH(14,r) - 4*x**4*SorH(14,r) + y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 6*z**2*SorH(14,r) + 12*x**2*z**2*SorH(14,r) + 24*x**4*z**2*SorH(14,r) - 4*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*x**2*z**4*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) - 2*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + r*x**4*SorH(14,r,1) + r*x**2*y**2*SorH(14,r,1) - 3*r*x**2*z**2*SorH(14,r,1) - 9*r*x**4*z**2*SorH(14,r,1) + r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*x**2*z**4*SorH(14,r,1) + r**2*x**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (x*z*(4*(1 + 6*y**4 - 2*z**2 + y**2*(-4 + 6*z**2) + x**2*(-2 + 6*y**2 + 6*z**2))*SorH(12,r) + 8*(-1 + 3*x**4 + 3*z**4 + 3*x**2*(y**2 - 2*z**2) + y**2*(-2 + 3*z**2))*SorH(13,r) + 12*SorH(14,r) - 24*x**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) + 2*r*x**2*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 9*r*x**4*SorH(13,r,1) + 4*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: ((-3*y**2 + 6*(-1 + 2*y**2)*z**2 + 8*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 4*y**2 + 12*(-1 + 2*y**2)*z**2 + 16*z**4))*SorH(12,r) + 2*(x**4*(4 - 24*z**2) + 3*(y**2 + z**2) - 4*(3*y**2*z**2 + z**4) + 3*x**2*(-1 + 8*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 9*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 12*x**2*y**2*SorH(14,r) - 36*x**2*z**2*SorH(14,r) + 72*x**4*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) - 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 3*r*x**2*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - 3*r*y**2*z**2*SorH(12,r,1) + 27*r*x**2*y**2*z**2*SorH(12,r,1) - 2*r*z**4*SorH(12,r,1) + 18*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - 3*r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r**2*x**2*z**4*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) - 54*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) + 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**4*SorH(14,r,1) - 3*r*x**2*y**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) - 27*r*x**4*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) + 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (x*z*((-4 + 8*x**2 - 8*y**2)*SorH(9,r) + 2*r*SorH(9,r,1) + r*(x - y)*(x + y)*(-5*SorH(9,r,1) + r*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(-6*(-6 + 10*x**2 + 5*z**2)*SorH(10,r) + 3*(-2 + 5*x**2 - 5*y**2)*SorH(11,r)*sqrt(3) + r*(2*(-6 + 14*x**2 + 7*z**2)*SorH(10,r,1) - 2*r*(2*x**2 + z**2)*SorH(10,r,2) + (2 - 7*x**2 + 7*y**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,2)*sqrt(3))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (x*(2*(-2 + 3*x**2 - 3*y**2 + 3*(2 - 5*x**2 + 5*y**2)*z**2)*SorH(10,r) + (2 - 3*x**2 + 3*y**2 + 3*(-2 + 5*x**2 - 5*y**2)*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (-2 + 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1) + (x**2 - y**2 + (2 - 7*x**2 + 7*y**2)*z**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (z*(2*(2 - 6*y**2 - 3*z**2 + 3*x**2*(-2 + 10*y**2 + 5*z**2))*SorH(10,r) + 3*(5*x**4 + y**2 - x**2*(3 + 5*y**2))*SorH(11,r)*sqrt(3) + r*(2*(2*y**2 + z**2 + x**2*(2 - 14*y**2 - 7*z**2))*SorH(10,r,1) - (y**2 + x**2*(-3 + 7*x**2 - 7*y**2))*SorH(11,r,1)*sqrt(3) + r*x**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(12,r) - 16*(6*x**4 + y**2 - 3*x**2*(1 + 2*y**2))*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 12*y**2*SorH(14,r) - 72*x**2*y**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*x**2*y**2*SorH(12,r,2) - 12*r*x**2*SorH(13,r,1) + 36*r*x**4*SorH(13,r,1) + 4*r*y**2*SorH(13,r,1) - 36*r*x**2*y**2*SorH(13,r,1) - 4*r**2*x**4*SorH(13,r,2) + 4*r**2*x**2*y**2*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (x*y*(2*(3 - 6*x**2 - 2*y**2 + 12*(-2 + 3*x**2 + y**2)*z**2 + 24*z**4)*SorH(12,r) - 4*(3 - 6*x**2 + 2*y**2 + 6*(-3 + 6*x**2 - 2*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*x**2*SorH(14,r) + 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 72*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 27*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + 3*r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) + 54*r*x**2*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) - 6*r**2*x**2*z**2*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(x - y)*(x + y)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (x*z*(8*(-1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(1 - 2*x**2 + 2*y**2 + 2*(-1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) + 8*SorH(14,r) - 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 8*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 4*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) - 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: ((-3*y**2 + 6*(-1 + 2*y**2)*z**2 + 8*z**4 + x**4*(4 - 24*z**2) - 3*x**2*(1 - 4*y**2 + 12*(-1 + 2*y**2)*z**2 + 16*z**4))*SorH(12,r) + 2*(x**4*(4 - 24*z**2) + 3*(y**2 + z**2) - 4*(3*y**2*z**2 + z**4) + 3*x**2*(-1 + 8*z**4 + 4*y**2*(-1 + 6*z**2)))*SorH(13,r) + 9*x**2*SorH(14,r) - 12*x**4*SorH(14,r) - 3*y**2*SorH(14,r) + 12*x**2*y**2*SorH(14,r) - 36*x**2*z**2*SorH(14,r) + 72*x**4*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) - 72*x**2*y**2*z**2*SorH(14,r) - r*x**4*SorH(12,r,1) - 3*r*x**2*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) + 9*r*x**4*z**2*SorH(12,r,1) - 3*r*y**2*z**2*SorH(12,r,1) + 27*r*x**2*y**2*z**2*SorH(12,r,1) - 2*r*z**4*SorH(12,r,1) + 18*r*x**2*z**4*SorH(12,r,1) - r**2*x**4*z**2*SorH(12,r,2) - 3*r**2*x**2*y**2*z**2*SorH(12,r,2) - 2*r**2*x**2*z**4*SorH(12,r,2) - 2*r*x**4*SorH(13,r,1) + 6*r*x**2*y**2*SorH(13,r,1) + 18*r*x**4*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) - 54*r*x**2*y**2*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*x**2*z**4*SorH(13,r,1) - 2*r**2*x**4*z**2*SorH(13,r,2) + 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*x**2*z**4*SorH(13,r,2) + 3*r*x**4*SorH(14,r,1) - 3*r*x**2*y**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) - 27*r*x**4*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) + 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*(x - y)*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (x*z*(8*(-2*(-1 + y**2 + 6*z**2) + 3*(x**4 - 2*x**2*(1 + y**2 - 2*z**2) + (y**2 + 2*z**2)**2))*SorH(12,r) + 16*(1 - 2*z**2 + 2*y**2*(-5 + 3*z**2) + x**2*(-2 + 24*y**2 + 6*z**2))*SorH(13,r) - 48*x**2*SorH(14,r) + 72*x**4*SorH(14,r) + 48*y**2*SorH(14,r) - 144*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) + 12*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 4*r*y**2*SorH(12,r,1) + 18*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 24*r*z**2*SorH(12,r,1) - 36*r*x**2*z**2*SorH(12,r,1) - 36*r*y**2*z**2*SorH(12,r,1) - 36*r*z**4*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - 2*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 4*r**2*x**2*z**2*SorH(12,r,2) + 4*r**2*y**2*z**2*SorH(12,r,2) + 4*r**2*z**4*SorH(12,r,2) + 8*r*x**2*SorH(13,r,1) + 40*r*y**2*SorH(13,r,1) - 144*r*x**2*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) - 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) + 16*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 12*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) - 12*r*y**2*SorH(14,r,1) + 54*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*SorH(14,r,2)))/(4.*r**2), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: y*z*(-(SorH(0,r,1)/r) + SorH(0,r,2)), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: ((-1 + 3*y**2)*z*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y**2*z*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: (y*(-1 + 3*z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y*z**2*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(2,r) + r*(-3*SorH(2,r,1) + r*SorH(2,r,2))))/r**2, \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(3,r) + r*((1 - 5*y**2)*SorH(3,r,1) + r*y**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(3,r) + r*((y**2 + z**2 - 5*y**2*z**2)*SorH(3,r,1) + r*y**2*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (y*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(3,r) + 2*r*SorH(3,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(3,r,1) - r*SorH(3,r,2))))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(3,r) + r*((1 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: (y*z*((4 + 8*x**2 - 8*y**2)*SorH(3,r) - 2*r*SorH(3,r,1) + r*(x - y)*(x + y)*(-5*SorH(3,r,1) + r*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: ((-1 + 3*y**2)*z*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y**2*z*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (y*z*((-4 + 8*x**2 + 8*z**2)*SorH(5,r) + (-4 + 8*y**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*z**2)*SorH(5,r,1) + r*(x**2 + z**2)*SorH(5,r,2) + (2 - 5*y**2)*SorH(6,r,1) + r*y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + y**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + y**2*(-1 + 5*z**2))*SorH(5,r,1) + (y**2 + z**2 - 5*y**2*z**2)*SorH(6,r,1) + r*y**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(7,r) + 3*(-2 + 5*y**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(7,r,1) + r*(x**2 - y**2 + z**2)*SorH(7,r,2) + (2 - 7*y**2)*SorH(8,r,1)*sqrt(3) + r*y**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (y*((-2 - 3*x**2 + 3*y**2 + 3*(-1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(7,r) + (2 - 6*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(-((x**2 - y**2 + z**2)*(-1 + 7*z**2)*SorH(7,r,1)) + (y**2 + 2*z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*((x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: -(z*((-4 + 3*y**2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 6*(1 - 5*y**2)*z**2)*SorH(8,r) + 2*(2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(7,r)*sqrt(3) + r*(-((y**2 + 7*y**4 + x**2*(-1 + 7*y**2) + 2*z**2 - 14*y**2*z**2)*SorH(8,r,1)) + 2*(z**2 + y**2*(2 - 7*z**2))*SorH(7,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(7,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(z*(2*(2 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(7,r) + 3*(x**2 - (3 + 5*x**2)*y**2 + 5*y**4)*SorH(8,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(2 - 7*z**2))*SorH(7,r,1) + (-x**2 + (3 + 7*x**2)*y**2 - 7*y**4)*SorH(8,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(7,r,2) + (-x**2 + y**2)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (y*(-1 + 3*z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y*z**2*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: ((-1 + 2*z**2 + y**2*(2 - 8*z**2))*SorH(5,r) + (1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(6,r) + r*((-z**2 + y**2*(-1 + 5*z**2))*SorH(5,r,1) + (y**2 + z**2 - 5*y**2*z**2)*SorH(6,r,1) + r*y**2*z**2*(-SorH(5,r,2) + SorH(6,r,2))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (y*z*((-4 + 8*x**2 + 8*y**2)*SorH(5,r) + (-4 + 8*z**2)*SorH(6,r) + r*((2 - 5*x**2 - 5*y**2)*SorH(5,r,1) + r*(x**2 + y**2)*SorH(5,r,2) + (2 - 5*z**2)*SorH(6,r,1) + r*z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(7,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (z*((-2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 3*y**2*(1 + 5*z**2))*SorH(7,r) + (2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(x**2 + y**2 - z**2)*SorH(7,r,1)) + (z**2 + y**2*(2 - 7*z**2))*SorH(8,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - z**2)*SorH(7,r,2) + z**2*SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (y*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(8,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(7,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(8,r,1) + 2*r*z**4*SorH(8,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(8,r,2) + 2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(7,r) + 3*(-2 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(7,r,1) + r*(x**2 + y**2 - z**2)*SorH(7,r,2) + (2 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: (y*(2*(2 + 3*x**2 - 3*y**2 - 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(7,r) + (-2 - 3*x**2 + 3*y**2 + 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (2 + 7*x**2 - 7*y**2)*z**2)*SorH(7,r,1) + (x**2 - y**2 + (-2 - 7*x**2 + 7*y**2)*z**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: (x*y*z*(3*SorH(4,r) + r*(-3*SorH(4,r,1) + r*SorH(4,r,2))))/r**2, \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*z*((2 - 8*y**2)*SorH(5,r) + (-2 + 8*y**2)*SorH(6,r) + r*((-1 + 5*y**2)*SorH(5,r,1) + (1 - 5*y**2)*SorH(6,r,1) + r*y**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (y*z*(8*(-1 + y**2 + z**2)*SorH(5,r) + 8*x**2*SorH(6,r) + r*((4 - 5*y**2 - 5*z**2)*SorH(5,r,1) + r*(y**2 + z**2)*SorH(5,r,2) + x**2*(-5*SorH(6,r,1) + r*SorH(6,r,2)))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (z*((2 + x**2*(3 - 15*y**2) - 3*z**2 + 15*y**2*(-1 + y**2 + z**2))*SorH(7,r) + 3*x**2*(-1 + 5*y**2)*SorH(8,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + z**2 + y**2*(5 - 7*y**2 - 7*z**2))*SorH(7,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((1 - 7*y**2)*SorH(8,r,1) + r*y**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(7,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(8,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(7,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(8,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(8,r) + 6*(-2 + 5*z**2)*SorH(7,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(8,r,1)) + 2*(2 - 7*z**2)*SorH(7,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (y*((2 + 3*x**2 - 3*y**2 - 15*(1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(7,r) + 3*x**2*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((-x**2 + y**2 + (5 + 7*x**2 - 7*y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((1 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*y*z*(6*(-6 + 10*y**2 + 5*z**2)*SorH(7,r) + 3*(2 + 5*x**2 - 5*y**2)*SorH(8,r)*sqrt(3) + r*(-2*(-6 + 14*y**2 + 7*z**2)*SorH(7,r,1) + 2*r*(2*y**2 + z**2)*SorH(7,r,2) + (-2 - 7*x**2 + 7*y**2)*SorH(8,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(8,r,2)*sqrt(3))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*z*((-2 + 8*y**2)*SorH(9,r) + r*((1 - 5*y**2)*SorH(9,r,1) + r*y**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 - y**2 + z**2)*SorH(10,r) + 3*(-2 + 5*y**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 - y**2 + z**2)*SorH(10,r,1) + r*(x**2 - y**2 + z**2)*SorH(10,r,2) + (2 - 7*y**2)*SorH(11,r,1)*sqrt(3) + r*y**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(10,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (z*((2 + x**2*(3 - 15*y**2) - 3*z**2 + 15*y**2*(-1 + y**2 + z**2))*SorH(10,r) + 3*x**2*(-1 + 5*y**2)*SorH(11,r)*sqrt(3) + r*((x**2*(-1 + 7*y**2) + z**2 + y**2*(5 - 7*y**2 - 7*z**2))*SorH(10,r,1) + r*y**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((1 - 7*y**2)*SorH(11,r,1) + r*y**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (y*z*(4*(1 - 2*y**2 + 6*(-1 + y**2)*z**2 + 6*z**4 + x**2*(-4 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 + 6*x**4 - 2*z**2 + 6*y**2*(-1 + y**2 + z**2) + x**2*(2 - 12*y**2 + 6*z**2))*SorH(13,r) - 24*x**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 6*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 9*r*z**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + r**2*z**4*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 6*r*y**2*SorH(13,r,1) + 18*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) - 2*r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 3*r**2*x**2*y**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + x**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 - 2*x**2 + 6*y**2 + 6*(1 + 2*x**2 - 6*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*z*(4*(-1 + 6*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 2*z**2 + 4*y**2*(-1 + 3*z**2))*SorH(13,r) + 4*(1 + x**2)*SorH(14,r) - 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*y**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*y**2*z**2*SorH(13,r,2) - r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*y**2*z**2*SorH(14,r,1) - r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + y**4*(4 - 24*z**2) - 3*y**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*x**2 + 3*y**2 + 12*x**2*y**2 - 4*y**4 + 3*(1 + 4*x**2 - 8*(1 + 3*x**2)*y**2 + 8*y**4)*z**2 + 4*(-1 + 6*y**2)*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*y**4*SorH(12,r,1) - 6*r*y**2*z**2*SorH(12,r,1) + 9*r*y**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*y**2*z**4*SorH(12,r,1) - r**2*y**4*z**2*SorH(12,r,2) - r**2*y**2*z**4*SorH(12,r,2) - 3*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(-1 + 6*y**2))*SorH(12,r) + 16*(x**2 - 3*(1 + 2*x**2)*y**2 + 6*y**4)*SorH(13,r) - 12*x**2*SorH(14,r) + 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) + 12*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 36*r*y**4*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*y**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (((1 - 2*z**2 + y**2*(-2 + 8*z**2))*SorH(9,r) + r*((y**2 + z**2 - 5*y**2*z**2)*SorH(9,r,1) + r*y**2*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (y*((-2 - 3*x**2 + 3*y**2 + 3*(-1 + 5*x**2 - 5*y**2)*z**2 + 15*z**4)*SorH(10,r) + (2 - 6*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(-((x**2 - y**2 + z**2)*(-1 + 7*z**2)*SorH(10,r,1)) + (y**2 + 2*z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*((x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (z*((-2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 3*z**2 - 3*y**2*(1 + 5*z**2))*SorH(10,r) + (2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(-((-1 + 7*y**2)*(x**2 + y**2 - z**2)*SorH(10,r,1)) + (z**2 + y**2*(2 - 7*z**2))*SorH(11,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - z**2)*SorH(10,r,2) + z**2*SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(10,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(3*z**2 - 6*z**4 + x**2*(1 - 6*z**2))*SorH(12,r) + 2*(-3 - 2*x**2 + 6*y**2 + 6*(1 + 2*x**2 - 6*y**2)*z**2 + 12*z**4)*SorH(13,r) + 6*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(1 + 6*x**4 - 2*z**2 + y**2*(-2 + 6*z**2) + x**2*(-4 + 6*y**2 + 6*z**2))*SorH(12,r) + 8*(-1 + 3*(y**2 - z**2)**2 + x**2*(-2 + 3*y**2 + 3*z**2))*SorH(13,r) + 12*SorH(14,r) - 24*y**2*SorH(14,r) - 24*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + r*x**2*(4 - 9*x**2)*SorH(12,r,1) + 2*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) + r**2*x**2*y**2*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 4*r*x**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) + r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(((y**2*(3 - 4*y**2 + 12*(-1 + 2*y**2)*z**2) + x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) - 2*(x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + x**2*SorH(14,r) + 3*y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 6*z**2*SorH(14,r) - 4*x**2*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 24*y**4*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*y**2*z**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 3*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) - 2*r*x**2*y**2*SorH(13,r,1) - 2*r*y**4*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 18*r*y**4*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*y**2*z**4*SorH(13,r,1) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) - 2*r**2*y**4*z**2*SorH(13,r,2) + 2*r**2*y**2*z**4*SorH(13,r,2) + r*x**2*y**2*SorH(14,r,1) + r*y**4*SorH(14,r,1) + r*x**2*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 9*r*y**4*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*y**2*z**4*SorH(14,r,1) + r**2*y**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(1 - 6*y**2))*SorH(12,r) + 2*(-3 + 2*x**2*(-1 + 6*y**2) + 6*z**2 + 6*y**2*(1 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*y**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: ((3*y**2 - 4*y**4 + 6*(1 - 6*y**2 + 4*y**4)*z**2 + 8*(-1 + 6*y**2)*z**4 + 3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) + 2*(-3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 36*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - 72*y**4*z**2*SorH(14,r) + 3*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - 27*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) - 18*r*y**2*z**4*SorH(12,r,1) + 3*r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + 2*r**2*y**2*z**4*SorH(12,r,2) - 6*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 6*r*x**2*z**2*SorH(13,r,1) + 54*r*x**2*y**2*z**2*SorH(13,r,1) - 18*r*y**4*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 18*r*y**2*z**4*SorH(13,r,1) - 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*y**4*z**2*SorH(13,r,2) - 2*r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) - 3*r*y**4*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 27*r*y**4*z**2*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (y*z*(-4*(1 + 2*x**2 + 2*y**2 - 4*z**2)*SorH(9,r) + 2*r*SorH(9,r,1) + r*(x**2 + y**2 - 2*z**2)*(5*SorH(9,r,1) - r*SorH(9,r,2))))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: -(z*((-4 + 3*y**2 + 15*y**4 + 3*x**2*(-1 + 5*y**2) + 6*(1 - 5*y**2)*z**2)*SorH(11,r) + 2*(2 - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(10,r)*sqrt(3) + r*(-((y**2 + 7*y**4 + x**2*(-1 + 7*y**2) + 2*z**2 - 14*y**2*z**2)*SorH(11,r,1)) + 2*(z**2 + y**2*(2 - 7*z**2))*SorH(10,r,1)*sqrt(3) + r*y**2*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (y*((-2 + 3*x**2 + 3*y**2 - 3*(4 + 5*x**2 + 5*y**2)*z**2 + 30*z**4)*SorH(11,r) + 2*(2 - 3*x**2 - 3*y**2 + 3*(-2 + 5*x**2 + 5*y**2)*z**2)*SorH(10,r)*sqrt(3) + r*((-x**2 - y**2 + (4 + 7*x**2 + 7*y**2)*z**2 - 14*z**4)*SorH(11,r,1) + 2*r*z**4*SorH(11,r,2) + 2*(x**2 + y**2 + (2 - 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(11,r,2) + 2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: -(x*y*z*(3*(2 + 5*x**2 + 5*y**2 - 10*z**2)*SorH(11,r) + 6*(-2 + 5*z**2)*SorH(10,r)*sqrt(3) + r*(-((2 + 7*x**2 + 7*y**2 - 14*z**2)*SorH(11,r,1)) + 2*(2 - 7*z**2)*SorH(10,r,1)*sqrt(3) + r*((x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(-1 + 6*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 8*(1 - 2*z**2 + 4*y**2*(-1 + 3*z**2))*SorH(13,r) + 4*(1 + x**2)*SorH(14,r) - 4*y**2*SorH(14,r) - 24*x**2*y**2*SorH(14,r) - 24*y**4*SorH(14,r) - 8*z**2*SorH(14,r) + 48*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 7*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*y**2*SorH(13,r,1) - 4*r*z**2*SorH(13,r,1) + 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*y**2*z**2*SorH(13,r,2) - r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) + 9*r*x**2*y**2*SorH(14,r,1) + 9*r*y**4*SorH(14,r,1) + 2*r*z**2*SorH(14,r,1) - 18*r*y**2*z**2*SorH(14,r,1) - r**2*y**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(((y**2*(3 - 4*y**2 + 12*(-1 + 2*y**2)*z**2) + x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) - 2*(x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + x**2*SorH(14,r) + 3*y**2*SorH(14,r) - 4*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) - 6*z**2*SorH(14,r) - 4*x**2*z**2*SorH(14,r) + 12*y**2*z**2*SorH(14,r) + 24*x**2*y**2*z**2*SorH(14,r) + 24*y**4*z**2*SorH(14,r) + 8*z**4*SorH(14,r) - 48*y**2*z**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + r*x**2*z**2*SorH(12,r,1) + 3*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) - 2*r*x**2*y**2*SorH(13,r,1) - 2*r*y**4*SorH(13,r,1) - 2*r*x**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) + 18*r*y**4*z**2*SorH(13,r,1) + 2*r*z**4*SorH(13,r,1) - 18*r*y**2*z**4*SorH(13,r,1) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) - 2*r**2*y**4*z**2*SorH(13,r,2) + 2*r**2*y**2*z**4*SorH(13,r,2) + r*x**2*y**2*SorH(14,r,1) + r*y**4*SorH(14,r,1) + r*x**2*z**2*SorH(14,r,1) - 3*r*y**2*z**2*SorH(14,r,1) - 9*r*x**2*y**2*z**2*SorH(14,r,1) - 9*r*y**4*z**2*SorH(14,r,1) - 2*r*z**4*SorH(14,r,1) + 18*r*y**2*z**4*SorH(14,r,1) + r**2*y**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (y*z*(24*(x**2 + y**2)*(-2 + 3*x**2 + 3*y**2)*SorH(12,r) + 48*(1 - 2*x**2 - 2*y**2 + 2*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(13,r) - 16*SorH(14,r) + 16*x**2*SorH(14,r) + 24*x**4*SorH(14,r) + 16*y**2*SorH(14,r) + 48*x**2*y**2*SorH(14,r) + 24*y**4*SorH(14,r) - 32*z**2*SorH(14,r) - 96*x**2*z**2*SorH(14,r) - 96*y**2*z**2*SorH(14,r) + 96*z**4*SorH(14,r) + 12*r*x**2*SorH(12,r,1) - 27*r*x**4*SorH(12,r,1) + 12*r*y**2*SorH(12,r,1) - 54*r*x**2*y**2*SorH(12,r,1) - 27*r*y**4*SorH(12,r,1) + 3*r**2*x**4*SorH(12,r,2) + 6*r**2*x**2*y**2*SorH(12,r,2) + 3*r**2*y**4*SorH(12,r,2) + 24*r*x**2*SorH(13,r,1) + 24*r*y**2*SorH(13,r,1) + 24*r*z**2*SorH(13,r,1) - 108*r*x**2*z**2*SorH(13,r,1) - 108*r*y**2*z**2*SorH(13,r,1) + 12*r**2*x**2*z**2*SorH(13,r,2) + 12*r**2*y**2*z**2*SorH(13,r,2) - 4*r*x**2*SorH(14,r,1) - 9*r*x**4*SorH(14,r,1) - 4*r*y**2*SorH(14,r,1) - 18*r*x**2*y**2*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) + 8*r*z**2*SorH(14,r,1) + 36*r*x**2*z**2*SorH(14,r,1) + 36*r*y**2*z**2*SorH(14,r,1) - 36*r*z**4*SorH(14,r,1) + r**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2)))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: (y*z*(8*(1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(-1 - 2*x**2 + 2*y**2 + 2*(1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) - 8*SorH(14,r) - 16*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 24*y**4*SorH(14,r) + 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 8*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 4*r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(9,r) + r*((1 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*((-2 + 6*z**2 + y**2*(6 - 30*z**2))*SorH(10,r) + (1 - 3*z**2 + 3*y**2*(-1 + 5*z**2))*SorH(11,r)*sqrt(3) + r*(2*(-z**2 + y**2*(-1 + 7*z**2))*SorH(10,r,1) + (y**2 + z**2 - 7*y**2*z**2)*SorH(11,r,1)*sqrt(3) + r*y**2*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*y*z*(15*(x**2 + y**2 - z**2)*SorH(10,r) + 3*(-2 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(-7*(x**2 + y**2 - z**2)*SorH(10,r,1) + r*(x**2 + y**2 - z**2)*SorH(10,r,2) + (2 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (y*((2 + 3*x**2 - 3*y**2 - 15*(1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(10,r) + 3*x**2*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((-x**2 + y**2 + (5 + 7*x**2 - 7*y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((1 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: ((-3*z**2 + 4*z**4 + y**4*(4 - 24*z**2) - 3*y**2*(1 - 8*z**2 + 8*z**4))*SorH(12,r) + (-3*x**2 + 3*y**2 + 12*x**2*y**2 - 4*y**4 + 3*(1 + 4*x**2 - 8*(1 + 3*x**2)*y**2 + 8*y**4)*z**2 + 4*(-1 + 6*y**2)*z**4)*SorH(13,r) + 3*x**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - r*y**4*SorH(12,r,1) - 6*r*y**2*z**2*SorH(12,r,1) + 9*r*y**4*z**2*SorH(12,r,1) - r*z**4*SorH(12,r,1) + 9*r*y**2*z**4*SorH(12,r,1) - r**2*y**4*z**2*SorH(12,r,2) - r**2*y**2*z**4*SorH(12,r,2) - 3*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) - 3*r*x**2*z**2*SorH(13,r,1) + 6*r*y**2*z**2*SorH(13,r,1) + 27*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + r*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) - 3*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(1 - 6*y**2))*SorH(12,r) + 2*(-3 + 2*x**2*(-1 + 6*y**2) + 6*z**2 + 6*y**2*(1 + 2*y**2 - 6*z**2))*SorH(13,r) + 6*SorH(14,r) - 24*y**2*SorH(14,r) - 12*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) + 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + r*x**2*SorH(13,r,1) - 3*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) - 9*r*y**4*SorH(13,r,1) - 3*r*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) + r**2*x**2*y**2*SorH(13,r,2) + r**2*y**4*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + 6*r*y**2*SorH(14,r,1) + 3*r*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(x*y*(2*(1 - 2*x**2 - 2*y**2 + 4*(-1 + 3*x**2 + 3*y**2)*z**2)*SorH(12,r) - 4*SorH(13,r) - 8*(x**2 + y**2 - z**2)*(-1 + 6*z**2)*SorH(13,r) + 2*SorH(14,r) - 4*x**2*SorH(14,r) - 4*y**2*SorH(14,r) + 16*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 2*r*y**2*SorH(13,r,1) + 2*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + r*x**2*SorH(14,r,1) + r*y**2*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (y*z*(4*(1 - 2*z**2 + 6*y**2*(-1 + y**2 + z**2) + x**2*(-4 + 6*y**2 + 6*z**2))*SorH(12,r) + 4*(1 + 6*x**4 - 2*y**2 + 6*(-1 + y**2)*z**2 + 6*z**4 + 2*x**2*(1 + 3*y**2 - 6*z**2))*SorH(13,r) - 24*x**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) + 6*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 2*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 2*r*x**2*SorH(13,r,1) - 9*r*x**4*SorH(13,r,1) + 2*r*y**2*SorH(13,r,1) - 9*r*x**2*y**2*SorH(13,r,1) + 6*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**4*SorH(13,r,2) + r**2*x**2*y**2*SorH(13,r,2) - 2*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 6*r*x**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*y*(2*(3 - 2*x**2 - 6*y**2 + 12*(-2 + x**2 + 3*y**2)*z**2 + 24*z**4)*SorH(12,r) + 4*(-3 - 2*x**2 + 6*y**2 + 6*(3 + 2*x**2 - 6*y**2)*z**2 - 12*z**4)*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) - 72*x**2*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 27*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + 3*r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) + 54*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) + 2*r**2*x**2*z**2*SorH(13,r,2) - 6*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) + 27*r*x**2*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(-x**2 + y**2)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: (y*z*((4 + 8*x**2 - 8*y**2)*SorH(9,r) - 2*r*SorH(9,r,1) + r*(x - y)*(x + y)*(-5*SorH(9,r,1) + r*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: -(z*(2*(2 + 6*x**2*(-1 + 5*y**2) - 3*z**2 + 3*y**2*(-2 + 5*z**2))*SorH(10,r) + 3*(x**2 - (3 + 5*x**2)*y**2 + 5*y**4)*SorH(11,r)*sqrt(3) + r*(2*(x**2*(2 - 14*y**2) + z**2 + y**2*(2 - 7*z**2))*SorH(10,r,1) + (-x**2 + (3 + 7*x**2)*y**2 - 7*y**4)*SorH(11,r,1)*sqrt(3) + r*y**2*(2*(2*x**2 + z**2)*SorH(10,r,2) + (-x**2 + y**2)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: (y*(2*(2 + 3*x**2 - 3*y**2 - 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(10,r) + (-2 - 3*x**2 + 3*y**2 + 3*(2 + 5*x**2 - 5*y**2)*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-x**2 + y**2 + (2 + 7*x**2 - 7*y**2)*z**2)*SorH(10,r,1) + (x**2 - y**2 + (-2 - 7*x**2 + 7*y**2)*z**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(-6 + 10*y**2 + 5*z**2)*SorH(10,r) + 3*(2 + 5*x**2 - 5*y**2)*SorH(11,r)*sqrt(3) + r*(-2*(-6 + 14*y**2 + 7*z**2)*SorH(10,r,1) + 2*r*(2*y**2 + z**2)*SorH(10,r,2) + (-2 - 7*x**2 + 7*y**2)*SorH(11,r,1)*sqrt(3) + r*(x - y)*(x + y)*SorH(11,r,2)*sqrt(3))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*z*(4*(3*y**2 - 6*y**4 + x**2*(-1 + 6*y**2))*SorH(12,r) + 16*(x**2 - 3*(1 + 2*x**2)*y**2 + 6*y**4)*SorH(13,r) - 12*x**2*SorH(14,r) + 36*y**2*SorH(14,r) + 72*x**2*y**2*SorH(14,r) - 72*y**4*SorH(14,r) + r*x**2*SorH(12,r,1) - 3*r*y**2*SorH(12,r,1) - 9*r*x**2*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) + r**2*x**2*y**2*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) - 4*r*x**2*SorH(13,r,1) + 12*r*y**2*SorH(13,r,1) + 36*r*x**2*y**2*SorH(13,r,1) - 36*r*y**4*SorH(13,r,1) - 4*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*y**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) - 27*r*x**2*y**2*SorH(14,r,1) + 27*r*y**4*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: ((3*y**2 - 4*y**4 + 6*(1 - 6*y**2 + 4*y**4)*z**2 + 8*(-1 + 6*y**2)*z**4 + 3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(12,r) + 2*(-3*x**2*(1 - 4*y**2 + 4*(-1 + 6*y**2)*z**2) + (y - z)*(y + z)*(3 - 4*y**2 + 4*(-1 + 6*y**2)*z**2))*SorH(13,r) + 3*x**2*SorH(14,r) - 9*y**2*SorH(14,r) - 12*x**2*y**2*SorH(14,r) + 12*y**4*SorH(14,r) - 12*x**2*z**2*SorH(14,r) + 36*y**2*z**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) - 72*y**4*z**2*SorH(14,r) + 3*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 3*r*x**2*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - 27*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + 2*r*z**4*SorH(12,r,1) - 18*r*y**2*z**4*SorH(12,r,1) + 3*r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + 2*r**2*y**2*z**4*SorH(12,r,2) - 6*r*x**2*y**2*SorH(13,r,1) + 2*r*y**4*SorH(13,r,1) - 6*r*x**2*z**2*SorH(13,r,1) + 54*r*x**2*y**2*z**2*SorH(13,r,1) - 18*r*y**4*z**2*SorH(13,r,1) - 2*r*z**4*SorH(13,r,1) + 18*r*y**2*z**4*SorH(13,r,1) - 6*r**2*x**2*y**2*z**2*SorH(13,r,2) + 2*r**2*y**4*z**2*SorH(13,r,2) - 2*r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) - 3*r*y**4*SorH(14,r,1) + 3*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 27*r*y**4*z**2*SorH(14,r,1) + 3*r**2*(x - y)*y**2*(x + y)*z**2*SorH(14,r,2))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: (y*z*(8*(1 + 3*x**2 - 3*y**2)*(-1 + x**2 + y**2 + 2*z**2)*SorH(12,r) - 16*(-1 - 2*x**2 + 2*y**2 + 2*(1 + 3*x**2 - 3*y**2)*z**2)*SorH(13,r) - 8*SorH(14,r) - 16*x**2*SorH(14,r) - 24*x**4*SorH(14,r) + 24*y**4*SorH(14,r) + 16*z**2*SorH(14,r) + 48*x**2*z**2*SorH(14,r) - 48*y**2*z**2*SorH(14,r) + 4*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) - 8*r*y**2*SorH(12,r,1) + 9*r*y**4*SorH(12,r,1) - 4*r*z**2*SorH(12,r,1) - 18*r*x**2*z**2*SorH(12,r,1) + 18*r*y**2*z**2*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - r**2*y**4*SorH(12,r,2) + 2*r**2*x**2*z**2*SorH(12,r,2) - 2*r**2*y**2*z**2*SorH(12,r,2) - 8*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) + 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) - 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) + 4*r*x**2*SorH(14,r,1) + 9*r*x**4*SorH(14,r,1) - 9*r*y**4*SorH(14,r,1) - 4*r*z**2*SorH(14,r,1) - 18*r*x**2*z**2*SorH(14,r,1) + 18*r*y**2*z**2*SorH(14,r,1) - r**2*(x - y)*(x + y)*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*y*(2*(3 - 2*x**2 - 6*y**2 + 12*(-2 + x**2 + 3*y**2)*z**2 + 24*z**4)*SorH(12,r) + 4*(-3 - 2*x**2 + 6*y**2 + 6*(3 + 2*x**2 - 6*y**2)*z**2 - 12*z**4)*SorH(13,r) + 6*SorH(14,r) + 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) - 24*z**2*SorH(14,r) - 72*x**2*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) + 12*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 27*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + 3*r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) + 2*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) - 18*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) + 54*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) + 2*r**2*x**2*z**2*SorH(13,r,2) - 6*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) - 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) + 6*r*z**2*SorH(14,r,1) + 27*r*x**2*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(-x**2 + y**2)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (y*z*(8*(2 + 3*x**4 - 6*y**2 - 12*z**2 - 2*x**2*(1 + 3*y**2 - 6*z**2) + 3*(y**2 + 2*z**2)**2)*SorH(12,r) + 16*(1 - 2*z**2 + 2*x**2*(-5 + 12*y**2 + 3*z**2) + y**2*(-2 + 6*z**2))*SorH(13,r) + 48*x**2*SorH(14,r) + 72*x**4*SorH(14,r) - 48*y**2*SorH(14,r) - 144*x**2*y**2*SorH(14,r) + 72*y**4*SorH(14,r) + 4*r*x**2*SorH(12,r,1) - 9*r*x**4*SorH(12,r,1) + 12*r*y**2*SorH(12,r,1) + 18*r*x**2*y**2*SorH(12,r,1) - 9*r*y**4*SorH(12,r,1) + 24*r*z**2*SorH(12,r,1) - 36*r*x**2*z**2*SorH(12,r,1) - 36*r*y**2*z**2*SorH(12,r,1) - 36*r*z**4*SorH(12,r,1) + r**2*x**4*SorH(12,r,2) - 2*r**2*x**2*y**2*SorH(12,r,2) + r**2*y**4*SorH(12,r,2) + 4*r**2*x**2*z**2*SorH(12,r,2) + 4*r**2*y**2*z**2*SorH(12,r,2) + 4*r**2*z**4*SorH(12,r,2) + 40*r*x**2*SorH(13,r,1) + 8*r*y**2*SorH(13,r,1) - 144*r*x**2*y**2*SorH(13,r,1) + 8*r*z**2*SorH(13,r,1) - 36*r*x**2*z**2*SorH(13,r,1) - 36*r*y**2*z**2*SorH(13,r,1) + 16*r**2*x**2*y**2*SorH(13,r,2) + 4*r**2*x**2*z**2*SorH(13,r,2) + 4*r**2*y**2*z**2*SorH(13,r,2) - 12*r*x**2*SorH(14,r,1) - 27*r*x**4*SorH(14,r,1) + 12*r*y**2*SorH(14,r,1) + 54*r*x**2*y**2*SorH(14,r,1) - 27*r*y**4*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*SorH(14,r,2)))/(4.*r**2), \
},
{\
	(0,0,0,0) : lambda r,x,y,z,SorH: -(((-1 + z**2)*SorH(0,r,1))/r) + z**2*SorH(0,r,2), \
	(0,0,1,-1) : lambda r,x,y,z,SorH: (y*(-1 + 3*z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + y*z**2*SorH(2,r,2), \
	(0,0,1,0) : lambda r,x,y,z,SorH: (3*z*(-1 + z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + z**3*SorH(2,r,2), \
	(0,0,1,1) : lambda r,x,y,z,SorH: (x*(-1 + 3*z**2)*(SorH(2,r) - r*SorH(2,r,1)))/r**2 + x*z**2*SorH(2,r,2), \
	(0,0,2,-2) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(3,r) + r*((1 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,-1) : lambda r,x,y,z,SorH: (y*z*((-6 + 8*z**2)*SorH(3,r) + r*((3 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,0) : lambda r,x,y,z,SorH: (-2*(2 + x**2 + y**2 - 2*z**2)*(-1 + 4*z**2)*SorH(3,r) + r*((-x**2 - y**2 + 5*(2 + x**2 + y**2)*z**2 - 10*z**4)*SorH(3,r,1) - r*z**2*(x**2 + y**2 - 2*z**2)*SorH(3,r,2)))/(2.*r**2), \
	(0,0,2,1) : lambda r,x,y,z,SorH: (x*z*((-6 + 8*z**2)*SorH(3,r) + r*((3 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/r**2, \
	(0,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((-2 + 8*z**2)*SorH(3,r) + r*((1 - 5*z**2)*SorH(3,r,1) + r*z**2*SorH(3,r,2)))*sqrt(3))/(2.*r**2), \
	(1,-1,0,0) : lambda r,x,y,z,SorH: (y*(-1 + 3*z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + y*z**2*SorH(4,r,2), \
	(1,-1,1,-1) : lambda r,x,y,z,SorH: (2*(-1 + x**2 + z**2)*(-1 + 4*z**2)*SorH(5,r) + 2*y**2*(-1 + 4*z**2)*SorH(6,r) + r*((x**2 - 5*(-1 + x**2)*z**2 - 5*z**4)*SorH(5,r,1) + y**2*(1 - 5*z**2)*SorH(6,r,1) + r*z**2*((x**2 + z**2)*SorH(5,r,2) + y**2*SorH(6,r,2))))/r**2, \
	(1,-1,1,0) : lambda r,x,y,z,SorH: (y*z*((6 - 8*z**2)*SorH(5,r) + (-6 + 8*z**2)*SorH(6,r) + r*((-3 + 5*z**2)*SorH(5,r,1) + (3 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,1,1) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,-1,2,-2) : lambda r,x,y,z,SorH: (x*((2 - 3*x**2 + 3*y**2 + 15*(-1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(7,r) + 3*y**2*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((x**2 - y**2 + (5 - 7*x**2 + 7*y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((1 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,-1) : lambda r,x,y,z,SorH: (z*(3*(2 - 7*z**2 + 5*z**4 + y**2*(3 - 5*z**2) + x**2*(-3 + 5*z**2))*SorH(7,r) + 3*y**2*(-3 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((3*(x - y)*(x + y) + 7*(1 - x**2 + y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(7,r,2) + y**2*((3 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,-1,2,0) : lambda r,x,y,z,SorH: (y*((4 + 3*x**2 + 3*y**2 - 15*(2 + x**2 + y**2)*z**2 + 30*z**4)*SorH(8,r) - 2*(2 - 15*z**2 + 15*z**4)*SorH(7,r)*sqrt(3) - r*((x**2 + y**2 - (10 + 7*x**2 + 7*y**2)*z**2 + 14*z**4)*SorH(8,r,1) + r*z**2*(x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*(5 - 7*z**2)*SorH(7,r,1)*sqrt(3) + 2*r*z**4*SorH(7,r,2)*sqrt(3))))/(2.*r**2), \
	(1,-1,2,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*z**2)*SorH(7,r) + 3*(-3 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(7,r,1) + (3 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,-1,2,2) : lambda r,x,y,z,SorH: -(y*(2*(2 - 15*z**2 + 15*z**4 + 6*x**2*(-1 + 5*z**2))*SorH(7,r) - 3*(x - y)*(x + y)*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(2*(5*z**2 - 7*z**4 + x**2*(2 - 14*z**2))*SorH(7,r,1) + (x - y)*(x + y)*(-1 + 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*(2*(2*x**2 + z**2)*SorH(7,r,2) + (-x**2 + y**2)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,0,0) : lambda r,x,y,z,SorH: (3*z*(-1 + z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + z**3*SorH(4,r,2), \
	(1,0,1,-1) : lambda r,x,y,z,SorH: (y*z*((6 - 8*z**2)*SorH(5,r) + (-6 + 8*z**2)*SorH(6,r) + r*((-3 + 5*z**2)*SorH(5,r,1) + (3 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,1,0) : lambda r,x,y,z,SorH: (2*(x**2 + y**2)*(-1 + 4*z**2)*SorH(5,r) + 2*(1 - 5*z**2 + 4*z**4)*SorH(6,r) + r*(-((x**2 + y**2)*(-1 + 5*z**2)*SorH(5,r,1)) + z**2*(r*(x**2 + y**2)*SorH(5,r,2) - 5*(-1 + z**2)*SorH(6,r,1) + r*z**2*SorH(6,r,2))))/r**2, \
	(1,0,1,1) : lambda r,x,y,z,SorH: (x*z*((6 - 8*z**2)*SorH(5,r) + (-6 + 8*z**2)*SorH(6,r) + r*((-3 + 5*z**2)*SorH(5,r,1) + (3 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,0,2,-2) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*z**2)*SorH(7,r) + 3*(-3 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(7,r,1) + (3 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,0,2,-1) : lambda r,x,y,z,SorH: (y*((-2 - 3*x**2 - 3*y**2 + 15*(1 + x**2 + y**2)*z**2 - 15*z**4)*SorH(7,r) + r*(x**2 + y**2 - (5 + 7*x**2 + 7*y**2)*z**2 + 7*z**4)*SorH(7,r,1) + (2 - 15*z**2 + 15*z**4)*SorH(8,r)*sqrt(3) + r*z**2*(r*(x**2 + y**2 - z**2)*SorH(7,r,2) + (5 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,0,2,0) : lambda r,x,y,z,SorH: (z*(3*(4 + 3*x**2 + 3*y**2 - (14 + 5*x**2 + 5*y**2)*z**2 + 10*z**4)*SorH(8,r) + 6*(x**2 + y**2)*(-3 + 5*z**2)*SorH(7,r)*sqrt(3) + r*((-3*(x**2 + y**2) + 7*(2 + x**2 + y**2)*z**2 - 14*z**4)*SorH(8,r,1) + 2*r*z**4*SorH(8,r,2) - 2*(x**2 + y**2)*(-3 + 7*z**2)*SorH(7,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(8,r,2) + 2*SorH(7,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,0,2,1) : lambda r,x,y,z,SorH: (x*((-2 - 3*x**2 - 3*y**2 + 15*(1 + x**2 + y**2)*z**2 - 15*z**4)*SorH(7,r) + r*(x**2 + y**2 - (5 + 7*x**2 + 7*y**2)*z**2 + 7*z**4)*SorH(7,r,1) + (2 - 15*z**2 + 15*z**4)*SorH(8,r)*sqrt(3) + r*z**2*(r*(x**2 + y**2 - z**2)*SorH(7,r,2) + (5 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*SorH(8,r,2)*sqrt(3))))/r**2, \
	(1,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*z*(6*(3 - 5*z**2)*SorH(7,r) + 3*(-3 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(7,r,1) + (3 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(1,1,0,0) : lambda r,x,y,z,SorH: (x*(-1 + 3*z**2)*(SorH(4,r) - r*SorH(4,r,1)))/r**2 + x*z**2*SorH(4,r,2), \
	(1,1,1,-1) : lambda r,x,y,z,SorH: (x*y*((2 - 8*z**2)*SorH(5,r) + (-2 + 8*z**2)*SorH(6,r) + r*((-1 + 5*z**2)*SorH(5,r,1) + (1 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,0) : lambda r,x,y,z,SorH: (x*z*((6 - 8*z**2)*SorH(5,r) + (-6 + 8*z**2)*SorH(6,r) + r*((-3 + 5*z**2)*SorH(5,r,1) + (3 - 5*z**2)*SorH(6,r,1) + r*z**2*(-SorH(5,r,2) + SorH(6,r,2)))))/r**2, \
	(1,1,1,1) : lambda r,x,y,z,SorH: (2*(-1 + y**2 + z**2)*(-1 + 4*z**2)*SorH(5,r) + 2*x**2*(-1 + 4*z**2)*SorH(6,r) + r*((y**2 - 5*(-1 + y**2)*z**2 - 5*z**4)*SorH(5,r,1) + x**2*(1 - 5*z**2)*SorH(6,r,1) + r*z**2*((y**2 + z**2)*SorH(5,r,2) + x**2*SorH(6,r,2))))/r**2, \
	(1,1,2,-2) : lambda r,x,y,z,SorH: (y*((2 + 3*x**2 - 3*y**2 - 15*(1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(7,r) + 3*x**2*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((-x**2 + y**2 + (5 + 7*x**2 - 7*y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((1 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,-1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*z**2)*SorH(7,r) + 3*(-3 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(7,r,1) + (3 - 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*(-2*SorH(7,r,2) + SorH(8,r,2)*sqrt(3)))))/r**2, \
	(1,1,2,0) : lambda r,x,y,z,SorH: (x*((4 + 3*x**2 + 3*y**2 - 15*(2 + x**2 + y**2)*z**2 + 30*z**4)*SorH(8,r) - 2*(2 - 15*z**2 + 15*z**4)*SorH(7,r)*sqrt(3) - r*((x**2 + y**2 - (10 + 7*x**2 + 7*y**2)*z**2 + 14*z**4)*SorH(8,r,1) + r*z**2*(x**2 + y**2 - 2*z**2)*SorH(8,r,2) + 2*z**2*(5 - 7*z**2)*SorH(7,r,1)*sqrt(3) + 2*r*z**4*SorH(7,r,2)*sqrt(3))))/(2.*r**2), \
	(1,1,2,1) : lambda r,x,y,z,SorH: (z*(3*(2 - 7*z**2 + 5*z**4 + x**2*(3 - 5*z**2) + y**2*(-3 + 5*z**2))*SorH(7,r) + 3*x**2*(-3 + 5*z**2)*SorH(8,r)*sqrt(3) + r*((-3*(x - y)*(x + y) + 7*(1 + x**2 - y**2)*z**2 - 7*z**4)*SorH(7,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(7,r,2) + x**2*((3 - 7*z**2)*SorH(8,r,1) + r*z**2*SorH(8,r,2))*sqrt(3))))/r**2, \
	(1,1,2,2) : lambda r,x,y,z,SorH: (x*(2*(2 - 15*z**2 + 15*z**4 + 6*y**2*(-1 + 5*z**2))*SorH(7,r) + 3*(x - y)*(x + y)*(-1 + 5*z**2)*SorH(8,r)*sqrt(3) + r*(2*(5*z**2 - 7*z**4 + y**2*(2 - 14*z**2))*SorH(7,r,1) - (x - y)*(x + y)*(-1 + 7*z**2)*SorH(8,r,1)*sqrt(3) + r*z**2*(2*(2*y**2 + z**2)*SorH(7,r,2) + (x - y)*(x + y)*SorH(8,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,-2,0,0) : lambda r,x,y,z,SorH: (x*y*((-2 + 8*z**2)*SorH(9,r) + r*((1 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-2,1,-1) : lambda r,x,y,z,SorH: (x*((2 - 3*x**2 + 3*y**2 + 15*(-1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(10,r) + 3*y**2*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((x**2 - y**2 + (5 - 7*x**2 + 7*y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((1 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,1,0) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*z**2)*SorH(10,r) + 3*(-3 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(10,r,1) + (3 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-2,1,1) : lambda r,x,y,z,SorH: (y*((2 + 3*x**2 - 3*y**2 - 15*(1 + x**2 - y**2)*z**2 + 15*z**4)*SorH(10,r) + 3*x**2*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((-x**2 + y**2 + (5 + 7*x**2 - 7*y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((1 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-2,2,-2) : lambda r,x,y,z,SorH: (2*(x**2 + y**2 - 2*x**2*y**2 + 2*(3 - 5*y**2 + x**2*(-5 + 6*y**2))*z**2 + 6*(-3 + 2*x**2 + 2*y**2)*z**4 + 12*z**6)*SorH(12,r) + 2*(2*x**4*(-1 + 6*z**2) + y**2*(1 - 2*y**2 + 2*(-5 + 6*y**2)*z**2 + 12*z**4) + x**2*(1 + 4*y**2 - 2*(5 + 12*y**2)*z**2 + 12*z**4))*SorH(13,r) - 12*x**2*y**2*SorH(14,r) + 72*x**2*y**2*z**2*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + 5*r*x**2*z**2*SorH(12,r,1) + 5*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - 9*r*x**2*z**4*SorH(12,r,1) - 9*r*y**2*z**4*SorH(12,r,1) - 9*r*z**6*SorH(12,r,1) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*x**2*z**4*SorH(12,r,2) + r**2*y**2*z**4*SorH(12,r,2) + r**2*z**6*SorH(12,r,2) + r*x**4*SorH(13,r,1) - 2*r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + 5*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) + 5*r*y**2*z**2*SorH(13,r,1) + 18*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) + r**2*x**4*z**2*SorH(13,r,2) - 2*r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**2*y**2*SorH(14,r,1) - 27*r*x**2*y**2*z**2*SorH(14,r,1) + 3*r**2*x**2*y**2*z**2*SorH(14,r,2))/r**2, \
	(2,-2,2,-1) : lambda r,x,y,z,SorH: (x*z*(-2*(3 - 14*z**2 + 12*z**4 + 6*x**2*(-1 + 2*z**2))*SorH(12,r) + 2*(3 - 6*x**2 + 18*y**2 + 2*(-7 + 6*x**2 - 18*y**2)*z**2 + 12*z**4)*SorH(13,r) - 36*y**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) - 7*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) + 3*r*x**2*SorH(13,r,1) - 9*r*y**2*SorH(13,r,1) + 7*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 9*r*y**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,0) : lambda r,x,y,z,SorH: (x*y*(4*(1 - x**2 - y**2 + 2*(-5 + 3*x**2 + 3*y**2)*z**2 + 12*z**4)*SorH(12,r) + (-8 + 80*z**2 - 96*z**4)*SorH(13,r) + 4*(1 + x**2 + y**2)*SorH(14,r) - 40*z**2*SorH(14,r) - 24*x**2*z**2*SorH(14,r) - 24*y**2*z**2*SorH(14,r) + 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 10*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 20*r*z**2*SorH(13,r,1) + 36*r*z**4*SorH(13,r,1) - 4*r**2*z**4*SorH(13,r,2) - r*x**2*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 10*r*z**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) + 9*r*y**2*z**2*SorH(14,r,1) - 18*r*z**4*SorH(14,r,1) + r**2*z**2*(-x**2 - y**2 + 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-2,2,1) : lambda r,x,y,z,SorH: (y*z*(-2*(3 - 14*z**2 + 12*z**4 + 6*y**2*(-1 + 2*z**2))*SorH(12,r) + (6*(1 + 6*x**2 - 2*y**2) - 4*(7 + 18*x**2 - 6*y**2)*z**2 + 24*z**4)*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 3*r*y**2*SorH(12,r,1) - 7*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*y**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) - 9*r*x**2*SorH(13,r,1) + 3*r*y**2*SorH(13,r,1) + 7*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) - 3*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-2,2,2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(4*(-1 + 6*z**2)*SorH(12,r) + (16 - 96*z**2)*SorH(13,r) - 12*SorH(14,r) + 72*z**2*SorH(14,r) + r*SorH(12,r,1) - 9*r*z**2*SorH(12,r,1) + r**2*z**2*SorH(12,r,2) - 4*r*SorH(13,r,1) + 36*r*z**2*SorH(13,r,1) - 4*r**2*z**2*SorH(13,r,2) + 3*r*SorH(14,r,1) - 27*r*z**2*SorH(14,r,1) + 3*r**2*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,-1,0,0) : lambda r,x,y,z,SorH: (y*z*((-6 + 8*z**2)*SorH(9,r) + r*((3 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,-1,1,-1) : lambda r,x,y,z,SorH: (z*(3*(2 - 7*z**2 + 5*z**4 + y**2*(3 - 5*z**2) + x**2*(-3 + 5*z**2))*SorH(10,r) + 3*y**2*(-3 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((3*(x - y)*(x + y) + 7*(1 - x**2 + y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(x**2 - y**2 + z**2)*SorH(10,r,2) + y**2*((3 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,-1,1,0) : lambda r,x,y,z,SorH: (y*((-2 - 3*x**2 - 3*y**2 + 15*(1 + x**2 + y**2)*z**2 - 15*z**4)*SorH(10,r) + r*(x**2 + y**2 - (5 + 7*x**2 + 7*y**2)*z**2 + 7*z**4)*SorH(10,r,1) + (2 - 15*z**2 + 15*z**4)*SorH(11,r)*sqrt(3) + r*z**2*(r*(x**2 + y**2 - z**2)*SorH(10,r,2) + (5 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,-1,1,1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*z**2)*SorH(10,r) + 3*(-3 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(10,r,1) + (3 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,-1,2,-2) : lambda r,x,y,z,SorH: (x*z*(-2*(3 - 14*z**2 + 12*z**4 + 6*x**2*(-1 + 2*z**2))*SorH(12,r) + 2*(3 - 6*x**2 + 18*y**2 + 2*(-7 + 6*x**2 - 18*y**2)*z**2 + 12*z**4)*SorH(13,r) - 36*y**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) - 3*r*x**2*SorH(12,r,1) - 7*r*z**2*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) + 3*r*x**2*SorH(13,r,1) - 9*r*y**2*SorH(13,r,1) + 7*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) + 27*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) - 3*r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 9*r*y**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*y**2*z**2*SorH(14,r,2)))/r**2, \
	(2,-1,2,-1) : lambda r,x,y,z,SorH: (2*(x**2 + y**2)*(1 - 2*x**2 + 2*(-5 + 6*x**2)*z**2 + 12*z**4)*SorH(12,r) + 2*(x**2*(1 - 2*y**2 + 2*(-5 + 6*y**2)*z**2 + 12*z**4) + 2*(1 + y**2 - z**2)*(3*z**2 - 6*z**4 + y**2*(-1 + 6*z**2)))*SorH(13,r) + 6*y**2*SorH(14,r) - 60*y**2*z**2*SorH(14,r) + 72*y**2*z**4*SorH(14,r) + r*x**4*SorH(12,r,1) + r*x**2*y**2*SorH(12,r,1) + 5*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + 5*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*x**2*z**4*SorH(12,r,1) - 9*r*y**2*z**4*SorH(12,r,1) + r**2*x**4*z**2*SorH(12,r,2) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*x**2*z**4*SorH(12,r,2) + r**2*y**2*z**4*SorH(12,r,2) + r*x**2*y**2*SorH(13,r,1) + r*y**4*SorH(13,r,1) + 5*r*x**2*z**2*SorH(13,r,1) - 10*r*y**2*z**2*SorH(13,r,1) - 9*r*x**2*y**2*z**2*SorH(13,r,1) - 9*r*y**4*z**2*SorH(13,r,1) + 9*r*z**4*SorH(13,r,1) - 9*r*x**2*z**4*SorH(13,r,1) + 18*r*y**2*z**4*SorH(13,r,1) - 9*r*z**6*SorH(13,r,1) + r**2*x**2*y**2*z**2*SorH(13,r,2) + r**2*y**4*z**2*SorH(13,r,2) + r**2*x**2*z**4*SorH(13,r,2) - 2*r**2*y**2*z**4*SorH(13,r,2) + r**2*z**6*SorH(13,r,2) + 15*r*y**2*z**2*SorH(14,r,1) - 27*r*y**2*z**4*SorH(14,r,1) + 3*r**2*y**2*z**4*SorH(14,r,2))/r**2, \
	(2,-1,2,0) : lambda r,x,y,z,SorH: -(y*z*(12*(x**2 + y**2)*(-1 + 2*z**2)*SorH(12,r) + 4*(3 + 6*x**2 + 6*y**2 - 2*(7 + 6*x**2 + 6*y**2)*z**2 + 12*z**4)*SorH(13,r) - 12*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 56*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 14*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 14*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,-1,2,1) : lambda r,x,y,z,SorH: (x*y*(-4*(x**2 + y**2)*(-1 + 6*z**2)*SorH(12,r) + (-2*(3 + 2*x**2 + 2*y**2) + 12*(5 + 2*x**2 + 2*y**2)*z**2 - 72*z**4)*SorH(13,r) + 6*SorH(14,r) - 60*z**2*SorH(14,r) + 72*z**4*SorH(14,r) - r*(x**2 + y**2)*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) + r*x**2*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 15*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + 27*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) - 3*r**2*z**4*SorH(13,r,2) + 15*r*z**2*SorH(14,r,1) - 27*r*z**4*SorH(14,r,1) + 3*r**2*z**4*SorH(14,r,2)))/r**2, \
	(2,-1,2,2) : lambda r,x,y,z,SorH: (y*z*(4*(-3*(-1 + 3*x**2 + y**2) + 2*(-7 + 9*x**2 + 3*y**2)*z**2 + 12*z**4)*SorH(12,r) - 4*(3 - 18*x**2 + 6*y**2 + 2*(-7 + 18*x**2 - 6*y**2)*z**2 + 12*z**4)*SorH(13,r) - 36*x**2*SorH(14,r) + 36*y**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 72*y**2*z**2*SorH(14,r) + 9*r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) + 14*r*z**2*SorH(12,r,1) - 27*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + 3*r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 18*r*x**2*SorH(13,r,1) + 6*r*y**2*SorH(13,r,1) - 14*r*z**2*SorH(13,r,1) + 54*r*x**2*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) - 6*r**2*x**2*z**2*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(x - y)*(x + y)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,0,0,0) : lambda r,x,y,z,SorH: (-2*(2 + x**2 + y**2 - 2*z**2)*(-1 + 4*z**2)*SorH(9,r) + r*((-x**2 - y**2 + 5*(2 + x**2 + y**2)*z**2 - 10*z**4)*SorH(9,r,1) - r*z**2*(x**2 + y**2 - 2*z**2)*SorH(9,r,2)))/(2.*r**2), \
	(2,0,1,-1) : lambda r,x,y,z,SorH: (y*((4 + 3*x**2 + 3*y**2 - 15*(2 + x**2 + y**2)*z**2 + 30*z**4)*SorH(11,r) - 2*(2 - 15*z**2 + 15*z**4)*SorH(10,r)*sqrt(3) - r*((x**2 + y**2 - (10 + 7*x**2 + 7*y**2)*z**2 + 14*z**4)*SorH(11,r,1) + r*z**2*(x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*(5 - 7*z**2)*SorH(10,r,1)*sqrt(3) + 2*r*z**4*SorH(10,r,2)*sqrt(3))))/(2.*r**2), \
	(2,0,1,0) : lambda r,x,y,z,SorH: (z*(3*(4 + 3*x**2 + 3*y**2 - (14 + 5*x**2 + 5*y**2)*z**2 + 10*z**4)*SorH(11,r) + 6*(x**2 + y**2)*(-3 + 5*z**2)*SorH(10,r)*sqrt(3) + r*((-3*(x**2 + y**2) + 7*(2 + x**2 + y**2)*z**2 - 14*z**4)*SorH(11,r,1) + 2*r*z**4*SorH(11,r,2) - 2*(x**2 + y**2)*(-3 + 7*z**2)*SorH(10,r,1)*sqrt(3) + r*(x**2 + y**2)*z**2*(-SorH(11,r,2) + 2*SorH(10,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,0,1,1) : lambda r,x,y,z,SorH: (x*((4 + 3*x**2 + 3*y**2 - 15*(2 + x**2 + y**2)*z**2 + 30*z**4)*SorH(11,r) - 2*(2 - 15*z**2 + 15*z**4)*SorH(10,r)*sqrt(3) - r*((x**2 + y**2 - (10 + 7*x**2 + 7*y**2)*z**2 + 14*z**4)*SorH(11,r,1) + r*z**2*(x**2 + y**2 - 2*z**2)*SorH(11,r,2) + 2*z**2*(5 - 7*z**2)*SorH(10,r,1)*sqrt(3) + 2*r*z**4*SorH(10,r,2)*sqrt(3))))/(2.*r**2), \
	(2,0,2,-2) : lambda r,x,y,z,SorH: (x*y*(4*(1 - x**2 - y**2 + 2*(-5 + 3*x**2 + 3*y**2)*z**2 + 12*z**4)*SorH(12,r) + (-8 + 80*z**2 - 96*z**4)*SorH(13,r) + 4*(1 + x**2 + y**2)*SorH(14,r) - 40*z**2*SorH(14,r) - 24*x**2*z**2*SorH(14,r) - 24*y**2*z**2*SorH(14,r) + 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 10*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 20*r*z**2*SorH(13,r,1) + 36*r*z**4*SorH(13,r,1) - 4*r**2*z**4*SorH(13,r,2) - r*x**2*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 10*r*z**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) + 9*r*y**2*z**2*SorH(14,r,1) - 18*r*z**4*SorH(14,r,1) + r**2*z**2*(-x**2 - y**2 + 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,-1) : lambda r,x,y,z,SorH: -(y*z*(12*(x**2 + y**2)*(-1 + 2*z**2)*SorH(12,r) + 4*(3 + 6*x**2 + 6*y**2 - 2*(7 + 6*x**2 + 6*y**2)*z**2 + 12*z**4)*SorH(13,r) - 12*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 56*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 14*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 14*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,0) : lambda r,x,y,z,SorH: (12*(x**2 + y**2)**2*(-1 + 6*z**2)*SorH(12,r) + 24*(x**2 + y**2)*(1 - 10*z**2 + 12*z**4)*SorH(13,r) - 8*x**2*SorH(14,r) - 4*x**4*SorH(14,r) - 8*y**2*SorH(14,r) - 8*x**2*y**2*SorH(14,r) - 4*y**4*SorH(14,r) + 48*z**2*SorH(14,r) + 80*x**2*z**2*SorH(14,r) + 24*x**4*z**2*SorH(14,r) + 80*y**2*z**2*SorH(14,r) + 48*x**2*y**2*z**2*SorH(14,r) + 24*y**4*z**2*SorH(14,r) - 144*z**4*SorH(14,r) - 96*x**2*z**4*SorH(14,r) - 96*y**2*z**4*SorH(14,r) + 96*z**6*SorH(14,r) + 3*r*x**4*SorH(12,r,1) + 6*r*x**2*y**2*SorH(12,r,1) + 3*r*y**4*SorH(12,r,1) - 27*r*x**4*z**2*SorH(12,r,1) - 54*r*x**2*y**2*z**2*SorH(12,r,1) - 27*r*y**4*z**2*SorH(12,r,1) + 3*r**2*x**4*z**2*SorH(12,r,2) + 6*r**2*x**2*y**2*z**2*SorH(12,r,2) + 3*r**2*y**4*z**2*SorH(12,r,2) + 60*r*x**2*z**2*SorH(13,r,1) + 60*r*y**2*z**2*SorH(13,r,1) - 108*r*x**2*z**4*SorH(13,r,1) - 108*r*y**2*z**4*SorH(13,r,1) + 12*r**2*x**2*z**4*SorH(13,r,2) + 12*r**2*y**2*z**4*SorH(13,r,2) + r*x**4*SorH(14,r,1) + 2*r*x**2*y**2*SorH(14,r,1) + r*y**4*SorH(14,r,1) - 20*r*x**2*z**2*SorH(14,r,1) - 9*r*x**4*z**2*SorH(14,r,1) - 20*r*y**2*z**2*SorH(14,r,1) - 18*r*x**2*y**2*z**2*SorH(14,r,1) - 9*r*y**4*z**2*SorH(14,r,1) + 36*r*z**4*SorH(14,r,1) + 36*r*x**2*z**4*SorH(14,r,1) + 36*r*y**2*z**4*SorH(14,r,1) - 36*r*z**6*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)**2*SorH(14,r,2))/(4.*r**2), \
	(2,0,2,1) : lambda r,x,y,z,SorH: -(x*z*(12*(x**2 + y**2)*(-1 + 2*z**2)*SorH(12,r) + 4*(3 + 6*x**2 + 6*y**2 - 2*(7 + 6*x**2 + 6*y**2)*z**2 + 12*z**4)*SorH(13,r) - 12*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 56*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 14*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 14*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,0,2,2) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*(4*(1 - x**2 - y**2 + 2*(-5 + 3*x**2 + 3*y**2)*z**2 + 12*z**4)*SorH(12,r) + (-8 + 80*z**2 - 96*z**4)*SorH(13,r) + 4*(1 + x**2 + y**2)*SorH(14,r) - 40*z**2*SorH(14,r) - 24*x**2*z**2*SorH(14,r) - 24*y**2*z**2*SorH(14,r) + 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 10*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 20*r*z**2*SorH(13,r,1) + 36*r*z**4*SorH(13,r,1) - 4*r**2*z**4*SorH(13,r,2) - r*x**2*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 10*r*z**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) + 9*r*y**2*z**2*SorH(14,r,1) - 18*r*z**4*SorH(14,r,1) + r**2*z**2*(-x**2 - y**2 + 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,1,0,0) : lambda r,x,y,z,SorH: (x*z*((-6 + 8*z**2)*SorH(9,r) + r*((3 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/r**2, \
	(2,1,1,-1) : lambda r,x,y,z,SorH: (x*y*z*(6*(3 - 5*z**2)*SorH(10,r) + 3*(-3 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(10,r,1) + (3 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/r**2, \
	(2,1,1,0) : lambda r,x,y,z,SorH: (x*((-2 - 3*x**2 - 3*y**2 + 15*(1 + x**2 + y**2)*z**2 - 15*z**4)*SorH(10,r) + r*(x**2 + y**2 - (5 + 7*x**2 + 7*y**2)*z**2 + 7*z**4)*SorH(10,r,1) + (2 - 15*z**2 + 15*z**4)*SorH(11,r)*sqrt(3) + r*z**2*(r*(x**2 + y**2 - z**2)*SorH(10,r,2) + (5 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*SorH(11,r,2)*sqrt(3))))/r**2, \
	(2,1,1,1) : lambda r,x,y,z,SorH: (z*(3*(2 - 7*z**2 + 5*z**4 + x**2*(3 - 5*z**2) + y**2*(-3 + 5*z**2))*SorH(10,r) + 3*x**2*(-3 + 5*z**2)*SorH(11,r)*sqrt(3) + r*((-3*(x - y)*(x + y) + 7*(1 + x**2 - y**2)*z**2 - 7*z**4)*SorH(10,r,1) + r*z**2*(-x**2 + y**2 + z**2)*SorH(10,r,2) + x**2*((3 - 7*z**2)*SorH(11,r,1) + r*z**2*SorH(11,r,2))*sqrt(3))))/r**2, \
	(2,1,2,-2) : lambda r,x,y,z,SorH: (y*z*(-2*(3 - 14*z**2 + 12*z**4 + 6*y**2*(-1 + 2*z**2))*SorH(12,r) + (6*(1 + 6*x**2 - 2*y**2) - 4*(7 + 18*x**2 - 6*y**2)*z**2 + 24*z**4)*SorH(13,r) - 36*x**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 3*r*y**2*SorH(12,r,1) - 7*r*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) + 9*r*z**4*SorH(12,r,1) - r**2*y**2*z**2*SorH(12,r,2) - r**2*z**4*SorH(12,r,2) - 9*r*x**2*SorH(13,r,1) + 3*r*y**2*SorH(13,r,1) + 7*r*z**2*SorH(13,r,1) + 27*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) - 9*r*z**4*SorH(13,r,1) - 3*r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) + r**2*z**4*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 3*r**2*x**2*z**2*SorH(14,r,2)))/r**2, \
	(2,1,2,-1) : lambda r,x,y,z,SorH: (x*y*(-4*(x**2 + y**2)*(-1 + 6*z**2)*SorH(12,r) + (-2*(3 + 2*x**2 + 2*y**2) + 12*(5 + 2*x**2 + 2*y**2)*z**2 - 72*z**4)*SorH(13,r) + 6*SorH(14,r) - 60*z**2*SorH(14,r) + 72*z**4*SorH(14,r) - r*(x**2 + y**2)*SorH(12,r,1) + 9*r*x**2*z**2*SorH(12,r,1) + 9*r*y**2*z**2*SorH(12,r,1) - r**2*x**2*z**2*SorH(12,r,2) - r**2*y**2*z**2*SorH(12,r,2) + r*x**2*SorH(13,r,1) + r*y**2*SorH(13,r,1) - 15*r*z**2*SorH(13,r,1) - 9*r*x**2*z**2*SorH(13,r,1) - 9*r*y**2*z**2*SorH(13,r,1) + 27*r*z**4*SorH(13,r,1) + r**2*x**2*z**2*SorH(13,r,2) + r**2*y**2*z**2*SorH(13,r,2) - 3*r**2*z**4*SorH(13,r,2) + 15*r*z**2*SorH(14,r,1) - 27*r*z**4*SorH(14,r,1) + 3*r**2*z**4*SorH(14,r,2)))/r**2, \
	(2,1,2,0) : lambda r,x,y,z,SorH: -(x*z*(12*(x**2 + y**2)*(-1 + 2*z**2)*SorH(12,r) + 4*(3 + 6*x**2 + 6*y**2 - 2*(7 + 6*x**2 + 6*y**2)*z**2 + 12*z**4)*SorH(13,r) - 12*SorH(14,r) - 12*x**2*SorH(14,r) - 12*y**2*SorH(14,r) + 56*z**2*SorH(14,r) + 24*x**2*z**2*SorH(14,r) + 24*y**2*z**2*SorH(14,r) - 48*z**4*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) - 6*r*x**2*SorH(13,r,1) - 6*r*y**2*SorH(13,r,1) + 14*r*z**2*SorH(13,r,1) + 18*r*x**2*z**2*SorH(13,r,1) + 18*r*y**2*z**2*SorH(13,r,1) - 18*r*z**4*SorH(13,r,1) - 2*r**2*x**2*z**2*SorH(13,r,2) - 2*r**2*y**2*z**2*SorH(13,r,2) + 2*r**2*z**4*SorH(13,r,2) + 3*r*x**2*SorH(14,r,1) + 3*r*y**2*SorH(14,r,1) - 14*r*z**2*SorH(14,r,1) - 9*r*x**2*z**2*SorH(14,r,1) - 9*r*y**2*z**2*SorH(14,r,1) + 18*r*z**4*SorH(14,r,1) + r**2*z**2*(x**2 + y**2 - 2*z**2)*SorH(14,r,2))*sqrt(3))/(2.*r**2), \
	(2,1,2,1) : lambda r,x,y,z,SorH: (2*(x**2 + y**2)*(1 - 2*y**2 + 2*(-5 + 6*y**2)*z**2 + 12*z**4)*SorH(12,r) + 2*(y**2 - 2*x**2*(1 + x**2 + y**2) + 6*z**2 + 2*(-5*y**2 + 2*x**2*(5 + 3*x**2 + 3*y**2))*z**2 - 6*(3 + 4*x**2 - 2*y**2)*z**4 + 12*z**6)*SorH(13,r) + 6*x**2*SorH(14,r) - 60*x**2*z**2*SorH(14,r) + 72*x**2*z**4*SorH(14,r) + r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 5*r*x**2*z**2*SorH(12,r,1) + 5*r*y**2*z**2*SorH(12,r,1) - 9*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) - 9*r*x**2*z**4*SorH(12,r,1) - 9*r*y**2*z**4*SorH(12,r,1) + r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + r**2*x**2*z**4*SorH(12,r,2) + r**2*y**2*z**4*SorH(12,r,2) + r*x**4*SorH(13,r,1) + r*x**2*y**2*SorH(13,r,1) - 10*r*x**2*z**2*SorH(13,r,1) - 9*r*x**4*z**2*SorH(13,r,1) + 5*r*y**2*z**2*SorH(13,r,1) - 9*r*x**2*y**2*z**2*SorH(13,r,1) + 9*r*z**4*SorH(13,r,1) + 18*r*x**2*z**4*SorH(13,r,1) - 9*r*y**2*z**4*SorH(13,r,1) - 9*r*z**6*SorH(13,r,1) + r**2*x**4*z**2*SorH(13,r,2) + r**2*x**2*y**2*z**2*SorH(13,r,2) - 2*r**2*x**2*z**4*SorH(13,r,2) + r**2*y**2*z**4*SorH(13,r,2) + r**2*z**6*SorH(13,r,2) + 15*r*x**2*z**2*SorH(14,r,1) - 27*r*x**2*z**4*SorH(14,r,1) + 3*r**2*x**2*z**4*SorH(14,r,2))/r**2, \
	(2,1,2,2) : lambda r,x,y,z,SorH: -(x*z*(4*(-3*(-1 + x**2 + 3*y**2) + 2*(-7 + 3*x**2 + 9*y**2)*z**2 + 12*z**4)*SorH(12,r) + 4*(-3 - 6*x**2 + 18*y**2 + 2*(7 + 6*x**2 - 18*y**2)*z**2 - 12*z**4)*SorH(13,r) + 36*x**2*SorH(14,r) - 36*y**2*SorH(14,r) - 72*x**2*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) + 14*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 27*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + 3*r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) + 6*r*x**2*SorH(13,r,1) - 18*r*y**2*SorH(13,r,1) - 14*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) + 54*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) + 2*r**2*x**2*z**2*SorH(13,r,2) - 6*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) - 9*r*x**2*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) + 27*r*x**2*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(-x**2 + y**2)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,0,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*((-2 + 8*z**2)*SorH(9,r) + r*((1 - 5*z**2)*SorH(9,r,1) + r*z**2*SorH(9,r,2)))*sqrt(3))/(2.*r**2), \
	(2,2,1,-1) : lambda r,x,y,z,SorH: (y*(-2*(2 - 15*z**2 + 15*z**4 + 6*x**2*(-1 + 5*z**2))*SorH(10,r) + 3*(x - y)*(x + y)*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-2*x**2 + (-5 + 14*x**2)*z**2 + 7*z**4)*SorH(10,r,1) - (x - y)*(x + y)*(-1 + 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*(-2*(2*x**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*z*(6*(3 - 5*z**2)*SorH(10,r) + 3*(-3 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(2*(-3 + 7*z**2)*SorH(10,r,1) + (3 - 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*(-2*SorH(10,r,2) + SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,1,1) : lambda r,x,y,z,SorH: (x*(2*(2 - 15*z**2 + 15*z**4 + 6*y**2*(-1 + 5*z**2))*SorH(10,r) + 3*(x - y)*(x + y)*(-1 + 5*z**2)*SorH(11,r)*sqrt(3) + r*(2*(5*z**2 - 7*z**4 + y**2*(2 - 14*z**2))*SorH(10,r,1) - (x - y)*(x + y)*(-1 + 7*z**2)*SorH(11,r,1)*sqrt(3) + r*z**2*(2*(2*y**2 + z**2)*SorH(10,r,2) + (x - y)*(x + y)*SorH(11,r,2)*sqrt(3)))))/(2.*r**2), \
	(2,2,2,-2) : lambda r,x,y,z,SorH: (x*(x - y)*y*(x + y)*(4*(-1 + 6*z**2)*SorH(12,r) + (16 - 96*z**2)*SorH(13,r) - 12*SorH(14,r) + 72*z**2*SorH(14,r) + r*SorH(12,r,1) - 9*r*z**2*SorH(12,r,1) + r**2*z**2*SorH(12,r,2) - 4*r*SorH(13,r,1) + 36*r*z**2*SorH(13,r,1) - 4*r**2*z**2*SorH(13,r,2) + 3*r*SorH(14,r,1) - 27*r*z**2*SorH(14,r,1) + 3*r**2*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,-1) : lambda r,x,y,z,SorH: (y*z*(4*(-3*(-1 + 3*x**2 + y**2) + 2*(-7 + 9*x**2 + 3*y**2)*z**2 + 12*z**4)*SorH(12,r) - 4*(3 - 18*x**2 + 6*y**2 + 2*(-7 + 18*x**2 - 6*y**2)*z**2 + 12*z**4)*SorH(13,r) - 36*x**2*SorH(14,r) + 36*y**2*SorH(14,r) + 72*x**2*z**2*SorH(14,r) - 72*y**2*z**2*SorH(14,r) + 9*r*x**2*SorH(12,r,1) + 3*r*y**2*SorH(12,r,1) + 14*r*z**2*SorH(12,r,1) - 27*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + 3*r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 18*r*x**2*SorH(13,r,1) + 6*r*y**2*SorH(13,r,1) - 14*r*z**2*SorH(13,r,1) + 54*r*x**2*z**2*SorH(13,r,1) - 18*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) - 6*r**2*x**2*z**2*SorH(13,r,2) + 2*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) + 9*r*x**2*SorH(14,r,1) - 9*r*y**2*SorH(14,r,1) - 27*r*x**2*z**2*SorH(14,r,1) + 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(x - y)*(x + y)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,0) : lambda r,x,y,z,SorH: ((x - y)*(x + y)*(4*(1 - x**2 - y**2 + 2*(-5 + 3*x**2 + 3*y**2)*z**2 + 12*z**4)*SorH(12,r) + (-8 + 80*z**2 - 96*z**4)*SorH(13,r) + 4*(1 + x**2 + y**2)*SorH(14,r) - 40*z**2*SorH(14,r) - 24*x**2*z**2*SorH(14,r) - 24*y**2*z**2*SorH(14,r) + 48*z**4*SorH(14,r) + r*x**2*SorH(12,r,1) + r*y**2*SorH(12,r,1) + 10*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 9*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) - 20*r*z**2*SorH(13,r,1) + 36*r*z**4*SorH(13,r,1) - 4*r**2*z**4*SorH(13,r,2) - r*x**2*SorH(14,r,1) - r*y**2*SorH(14,r,1) + 10*r*z**2*SorH(14,r,1) + 9*r*x**2*z**2*SorH(14,r,1) + 9*r*y**2*z**2*SorH(14,r,1) - 18*r*z**4*SorH(14,r,1) + r**2*z**2*(-x**2 - y**2 + 2*z**2)*SorH(14,r,2))*sqrt(3))/(4.*r**2), \
	(2,2,2,1) : lambda r,x,y,z,SorH: -(x*z*(4*(-3*(-1 + x**2 + 3*y**2) + 2*(-7 + 3*x**2 + 9*y**2)*z**2 + 12*z**4)*SorH(12,r) + 4*(-3 - 6*x**2 + 18*y**2 + 2*(7 + 6*x**2 - 18*y**2)*z**2 - 12*z**4)*SorH(13,r) + 36*x**2*SorH(14,r) - 36*y**2*SorH(14,r) - 72*x**2*z**2*SorH(14,r) + 72*y**2*z**2*SorH(14,r) + 3*r*x**2*SorH(12,r,1) + 9*r*y**2*SorH(12,r,1) + 14*r*z**2*SorH(12,r,1) - 9*r*x**2*z**2*SorH(12,r,1) - 27*r*y**2*z**2*SorH(12,r,1) - 18*r*z**4*SorH(12,r,1) + r**2*x**2*z**2*SorH(12,r,2) + 3*r**2*y**2*z**2*SorH(12,r,2) + 2*r**2*z**4*SorH(12,r,2) + 6*r*x**2*SorH(13,r,1) - 18*r*y**2*SorH(13,r,1) - 14*r*z**2*SorH(13,r,1) - 18*r*x**2*z**2*SorH(13,r,1) + 54*r*y**2*z**2*SorH(13,r,1) + 18*r*z**4*SorH(13,r,1) + 2*r**2*x**2*z**2*SorH(13,r,2) - 6*r**2*y**2*z**2*SorH(13,r,2) - 2*r**2*z**4*SorH(13,r,2) - 9*r*x**2*SorH(14,r,1) + 9*r*y**2*SorH(14,r,1) + 27*r*x**2*z**2*SorH(14,r,1) - 27*r*y**2*z**2*SorH(14,r,1) + 3*r**2*(-x**2 + y**2)*z**2*SorH(14,r,2)))/(2.*r**2), \
	(2,2,2,2) : lambda r,x,y,z,SorH: (4*(x**4*(-1 + 6*z**2) + (-2 + y**2 + 2*z**2)*(-y**2 + 6*(-1 + y**2)*z**2 + 12*z**4) + 2*x**2*(1 + y**2 - 2*(5 + 3*y**2)*z**2 + 12*z**4))*SorH(12,r) + 8*(y**2*(1 - 10*z**2 + 12*z**4) + x**2*(1 - 8*y**2 + 2*(-5 + 24*y**2)*z**2 + 12*z**4))*SorH(13,r) - 12*x**4*SorH(14,r) + 24*x**2*y**2*SorH(14,r) - 12*y**4*SorH(14,r) + 72*x**4*z**2*SorH(14,r) - 144*x**2*y**2*z**2*SorH(14,r) + 72*y**4*z**2*SorH(14,r) + r*x**4*SorH(12,r,1) - 2*r*x**2*y**2*SorH(12,r,1) + r*y**4*SorH(12,r,1) + 20*r*x**2*z**2*SorH(12,r,1) - 9*r*x**4*z**2*SorH(12,r,1) + 20*r*y**2*z**2*SorH(12,r,1) + 18*r*x**2*y**2*z**2*SorH(12,r,1) - 9*r*y**4*z**2*SorH(12,r,1) + 36*r*z**4*SorH(12,r,1) - 36*r*x**2*z**4*SorH(12,r,1) - 36*r*y**2*z**4*SorH(12,r,1) - 36*r*z**6*SorH(12,r,1) + r**2*x**4*z**2*SorH(12,r,2) - 2*r**2*x**2*y**2*z**2*SorH(12,r,2) + r**2*y**4*z**2*SorH(12,r,2) + 4*r**2*x**2*z**4*SorH(12,r,2) + 4*r**2*y**2*z**4*SorH(12,r,2) + 4*r**2*z**6*SorH(12,r,2) + 16*r*x**2*y**2*SorH(13,r,1) + 20*r*x**2*z**2*SorH(13,r,1) + 20*r*y**2*z**2*SorH(13,r,1) - 144*r*x**2*y**2*z**2*SorH(13,r,1) - 36*r*x**2*z**4*SorH(13,r,1) - 36*r*y**2*z**4*SorH(13,r,1) + 16*r**2*x**2*y**2*z**2*SorH(13,r,2) + 4*r**2*x**2*z**4*SorH(13,r,2) + 4*r**2*y**2*z**4*SorH(13,r,2) + 3*r*x**4*SorH(14,r,1) - 6*r*x**2*y**2*SorH(14,r,1) + 3*r*y**4*SorH(14,r,1) - 27*r*x**4*z**2*SorH(14,r,1) + 54*r*x**2*y**2*z**2*SorH(14,r,1) - 27*r*y**4*z**2*SorH(14,r,1) + 3*r**2*(x**2 - y**2)**2*z**2*SorH(14,r,2))/(4.*r**2), \
},
],\
]
